/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialSeries } from "./FinancialSeries";
import { DependencyProperty } from "igniteui-angular-core";
import { ISortingAxis_$type } from "./ISortingAxis";
import { typeCast, markType, markDep } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { AxisRange } from "./AxisRange";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
export let FinancialOverlay = /*@__PURE__*/ (() => {
    class FinancialOverlay extends FinancialSeries {
        constructor() {
            super();
            this.x5 = false;
            this.x5 = false;
        }
        get_en() {
            return true;
        }
        np(a, b, c, d) {
            super.np(a, b, c, d);
            if (this.ub != null && typeCast(ISortingAxis_$type, this.ub) !== null) {
                this.ub.i$i();
            }
            this.us.b0.e(this.hk);
            this.x6();
            if (this.uu != null) {
                this.uu.c1();
            }
            this.pr(true);
        }
        get_gl() {
            return true;
        }
        pa(a, b, c, d) {
            switch (b) {
                case "FastItemsSource":
                    this.x5 = false;
                    break;
                case FinancialOverlay.$$p[0]:
                    this.x5 = false;
                    this.pr(false);
                    this.om();
                    break;
                case "XAxis":
                    this.x5 = false;
                    break;
            }
            super.pa(a, b, c, d);
        }
        bu() {
            if (this.bv == 0) {
                return 1;
            }
            else {
                return super.bu();
            }
        }
        f5(a, b) {
            if (this.f4(a, b)) {
                return true;
            }
            return false;
        }
        ac() {
            super.ac();
            this.pr(false);
        }
        fp(a) {
            let b = this.c7 != null ? this.c7.indexOf(a) : -1;
            let c = this.cg.by;
            c = c.copy();
            let d = this.cg.bx;
            let e = new Rect(0, 0, 0, 1, 1);
            let f = this.ts(this.cg);
            let g = new ScalerParams(0, e, e, this.ub.ch, f);
            let h = new ScalerParams(0, e, e, this.uu.ch, f);
            h.b = this.h3();
            if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
                if (this.ub != null) {
                    let i = this.ub.ej(b, g);
                    if (i < c.left + 0.1 * c.width) {
                        i = i + 0.4 * c.width;
                    }
                    if (i > c.right - 0.1 * c.width) {
                        i = i - 0.4 * c.width;
                    }
                    c.x = i - 0.5 * c.width;
                }
                if (this.uu != null && this.u6 != null && this.u5 != null && b < this.u6.count && b < this.u5.count) {
                    let j = this.uu.ej(this.u6.item(b), h);
                    let k = this.uu.ej(this.u5.item(b), h);
                    if (!isNaN_(j) && !isNaN_(k)) {
                        let l = Math.abs(j - k);
                        if (c.height < l) {
                            c.height = l;
                            c.y = Math.min(j, k);
                        }
                        else {
                            if (j < c.top + 0.1 * c.height) {
                                j = j + 0.4 * c.height;
                            }
                            if (j > c.bottom - 0.1 * c.height) {
                                j = j - 0.4 * c.height;
                            }
                            c.y = j - 0.5 * c.height;
                        }
                    }
                }
                this.co.au(this.cv, c, true);
            }
            return b >= 0;
        }
        aq(a) {
            if (a != null && a == this.uu && this.u6 != null && this.u5 != null) {
                return new AxisRange(this.u6.minimum, this.u5.maximum);
            }
            return null;
        }
    }
    FinancialOverlay.$t = markType(FinancialOverlay, 'FinancialOverlay', FinancialSeries.$);
    FinancialOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialOverlay, 'raisePropertyChanged', ['IgnoreFirst:x7:x9', [1, 0]]);
    return FinancialOverlay;
})();
