/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { TypicalPriceIndicatorStrategy } from "./TypicalPriceIndicatorStrategy";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let TypicalPriceIndicator = /*@__PURE__*/ (() => {
    class TypicalPriceIndicator extends StrategyBasedIndicator {
        bc() {
            return new TypicalPriceIndicator();
        }
        get_y0() {
            return new TypicalPriceIndicatorStrategy();
        }
        get y0() {
            return this.get_y0();
        }
        get_zd() {
            return TypicalPriceIndicator.$;
        }
        get zd() {
            return this.get_zd();
        }
    }
    TypicalPriceIndicator.$t = markType(TypicalPriceIndicator, 'TypicalPriceIndicator', StrategyBasedIndicator.$);
    return TypicalPriceIndicator;
})();
