/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager_$type } from "./IAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-angular-core";
import { Point_$type, enumGetBox, typeCast, runOn, delegateCombine, markType, markDep } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { Series } from "./Series";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { ICategoryScaler_$type } from "./ICategoryScaler";
import { IScaler_$type } from "./IScaler";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior_$type } from "./ConsolidatedItemHitTestBehavior";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { NumericYAxis } from "./NumericYAxis";
import { ScalerParams } from "./ScalerParams";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { CollisionAvoider } from "./CollisionAvoider";
import { NonCollisionAvoider } from "./NonCollisionAvoider";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
/**
 * @hidden
 */
var AnchoredCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredCategorySeries, _super);
    function AnchoredCategorySeries() {
        var _this = _super.call(this) || this;
        _this.xl = null;
        _this.xq = false;
        _this.xn = null;
        _this.xi = null;
        _this.xx = null;
        _this.xw = null;
        _this.xp = true;
        _this.xr = 0;
        _this.xs = 0;
        _this.vt = new CategoryFramePreparer(1, _this, _this.vx, _this, _this, _this.vx.cu);
        return _this;
    }
    Object.defineProperty(AnchoredCategorySeries.prototype, "xm", {
        get: function () {
            var _this = this;
            if (this.xl == null) {
                this.xl = DVContainer.instance.createInstance(IAnchoredCategorySeriesInteractionManager_$type, function () { return _this.da.n; });
            }
            return this.xl;
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeries.prototype.getHostReferenceValue = function () {
        return this.h3();
    };
    AnchoredCategorySeries.prototype.k0 = function () {
        return AnchoredCategorySeries.$$p[5];
    };
    AnchoredCategorySeries.prototype.cd = function () {
        var a = new AnchoredCategorySeriesView(this);
        return a;
    };
    AnchoredCategorySeries.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.xh = a;
    };
    AnchoredCategorySeries.prototype.jv = function (a, b) {
        var c = this.lw(b);
        if (c == AnchoredCategorySeries.$$p[5]) {
            return this.jw(a, b, this.x7);
        }
        if (c == AnchoredCategorySeries.$$p[1]) {
            return this.jw(a, b, this.xz);
        }
        return _super.prototype.jv.call(this, a, b);
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "valueColumn", {
        get: function () {
            return this.xn;
        },
        set: function (a) {
            if (this.xn != a) {
                var b = this.xn;
                this.xn = a;
                if (!this.xq) {
                    this.raisePropertyChanged("ValueColumn", b, this.xn);
                }
            }
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeries.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = new DataLegendSeriesValueInfo();
        c.a = 0;
        c.l = this.ia({ $type: Point_$type, x: a, y: b }, false, false);
        c.q = this.x7 != null ? this.x7 : "Value";
        c.p = "Value";
        c.r = this.x3 != null ? this.x3 : "V:";
        c.s = this.x5 != null ? this.x5 : "";
        var d = new DataLegendSeriesContext();
        d.f = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(c);
            return $ret;
        })());
        d.b = this.aw();
        return d;
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "yu", {
        get: function () {
            return this.c(AnchoredCategorySeries.yg);
        },
        set: function (a) {
            this.h(AnchoredCategorySeries.yg, a);
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeries.prototype.fp = function (a) {
        var b = new Rect(0, 0, 0, 1, 1);
        var c = this.fetchXAxis();
        var d = this.fetchYAxis();
        var e = this.ts(this.cg);
        var f = c != null ? this.vt.r(typeCast(ICategoryScaler_$type, c), b, b, e) : 0;
        return this.xm.c$a(this, this.valueColumn, c, d, f, a);
    };
    AnchoredCategorySeries.prototype.xe = function (a, b, c) {
        if (b < a || a < 0 || a > this.valueColumn.count || b < 0 || b > this.valueColumn.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.cn;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.c7.item(g);
        }
        return d;
    };
    AnchoredCategorySeries.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        if (this.xh.c6 && this.xh.c5.g$b(a, b, c, d)) {
            var e = false;
            if (b == "FastItemsSource") {
                e = this.fr && c != null;
            }
            this.pr(e);
            this.om();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.valueColumn);
                    this.valueColumn = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.valueColumn = this.c4(this.x7);
                }
                var f = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (f != null && !f.c1()) {
                    this.xh.cu.g(this.hk);
                    this.pr(this.fr && c != null);
                }
                break;
            case AnchoredCategorySeries.$$p[5]:
                if (this.c7 != null) {
                    this.c7.deregisterColumn(this.valueColumn);
                    this.valueColumn = this.c4(this.x7);
                }
                this.xx = this.x7;
                break;
            case AnchoredCategorySeries.$$p[1]:
                this.xw = this.xz;
                this.pr(true);
                break;
            case "ValueColumn":
                if (this.xh.c6) {
                    this.xh.c5.g$i();
                }
                var g = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (g != null && !g.c1()) {
                    this.xh.cu.g(this.hk);
                    this.pr(this.fr && this.dp);
                }
                this.yf();
                this.ql();
                break;
            case "TrendLineBrush":
                this.pg(b);
                break;
            case "ErrorBarSettings":
                this.pr(false);
                break;
            case "TrendLineType":
                this.om();
                break;
            case AnchoredCategorySeries.$$p[2]:
                this.pr(false);
                break;
        }
    };
    AnchoredCategorySeries.prototype.aq = function (a) {
        if (this.valueColumn == null || this.valueColumn.count == 0) {
            return null;
        }
        if (a == this.fetchXAxis()) {
            return new AxisRange(0, this.valueColumn.count - 1);
        }
        if (a == this.fetchYAxis()) {
            return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
        }
        return null;
    };
    AnchoredCategorySeries.prototype.np = function (a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.xh.cu.g(this.hk);
                break;
        }
        if (this.xh.c6) {
            this.xh.c5.g$e(a, b, c, d);
        }
        this.yf();
        this.ql();
        if (a == 0 || a == 2 || a == 3 || a == 4) {
            this.xp = true;
        }
        else if (a == 1) {
            for (var e = b; e < b + c; e++) {
                this.xr += this.valueColumn.item(e);
            }
            this.xs = this.xr / this.valueColumn.count;
        }
    };
    AnchoredCategorySeries.prototype.wo = function () {
        return this.xt(this.vx);
    };
    AnchoredCategorySeries.prototype.xt = function (a) {
        var b = 0;
        var c = a.by;
        var d = a.bx;
        var e = this.getEffectiveViewport1(a);
        var f = typeCast(NumericYAxis.$, this.fetchYAxis());
        if (!c.isEmpty && !d.isEmpty && f != null) {
            var g = new ScalerParams(0, c, d, f.ch, e);
            if (f.cp) {
                g.b = this.h3();
            }
            b = f.ej(f.l7, g);
        }
        return b;
    };
    AnchoredCategorySeries.prototype.yd = function (a, b, c) {
        var d = this.xt(c);
        if (a.count > 0) {
            var e = d;
            a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
            a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
        }
    };
    AnchoredCategorySeries.prototype.xf = function (a, b, c, d) {
        return this.xg(a, b, c, d, false);
    };
    AnchoredCategorySeries.prototype.xg = function (a, b, c, d, e) {
        return CategorySeries.vi(a, b, c, d, e);
    };
    AnchoredCategorySeries.prototype.fo = function () {
        return this.highlightedItemsSource != null || this.xz != null;
    };
    AnchoredCategorySeries.prototype.g1 = function () {
        var a = _super.prototype.g1.call(this);
        {
            var b = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.ad = "ValueMemberPath";
                $ret.p = true;
                $ret.y = "HighlightedValueMemberPath";
                $ret.q = true;
                return $ret;
            })());
            b.valueResolving = delegateCombine(b.valueResolving, runOn(this, this.x9));
            a.add(b);
        }
        return a;
    };
    AnchoredCategorySeries.prototype.x9 = function (a, b) {
        if (this.xz != null) {
            b.value = this.xz;
            return;
        }
        b.value = this.x7;
    };
    AnchoredCategorySeries.prototype.gm = function (a, b, c) {
        var d = _super.prototype.gm.call(this, a, b, c);
        var e = c;
        if (this.valueColumn == null || this.valueColumn.count == 0 || e.cu.d < 1) {
            d = false;
        }
        return d;
    };
    AnchoredCategorySeries.prototype.nk = function (a, b) {
        _super.prototype.nk.call(this, a, b);
        var c = b;
        c.c0();
        if (c.c6) {
            c.c5.g$d();
        }
    };
    AnchoredCategorySeries.prototype.w4 = function (a, b) {
        _super.prototype.w4.call(this, a, b);
        this.vu(b).d(a, b);
    };
    AnchoredCategorySeries.prototype.w7 = function (a, b) {
        _super.prototype.w7.call(this, a, b);
        var c = typeCast(AnchoredCategorySeriesView.$, b);
        c.b6 = true;
        if (c.c6) {
            c.c5.g$g(a.p);
        }
        if (this.ue()) {
            CategoryMarkerManager.e(this, a.m, b.cx, this.ug);
            this.w1(b, a);
            b.cp();
        }
        this.ya(a, b);
    };
    AnchoredCategorySeries.prototype.pq = function (a, b, c, d, e) {
        _super.prototype.pq.call(this, a, b, c, d, e);
        var f = this.a3.a$h.item(d);
        var g = f;
        g.cu.g(this.hk);
        f.a3(c);
        if (this.dm(g)) {
            return;
        }
        if (this.xi == null) {
            this.xi = new CategoryFrame(3);
        }
        this.xi.u();
        this.w4(this.xi, g);
        this.w7(this.xi, g);
    };
    AnchoredCategorySeries.prototype.ya = function (a, b) {
    };
    AnchoredCategorySeries.prototype.qf = function () {
        _super.prototype.qf.call(this);
        if (this.index < 0) {
            return;
        }
        this.xh.da();
        if (this.trendLineBrush != null) {
            this.xh.c8();
        }
        else {
            this.xh.c7();
        }
    };
    AnchoredCategorySeries.prototype.jz = function (a, b) {
        if (this.xh.c6 && a == this.xh.c5.g$j) {
            return null;
        }
        return _super.prototype.jz.call(this, a, b);
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "currentCategoryMode", {
        get: function () {
            return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.vn()));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "scaler", {
        get: function () {
            return typeCast(ICategoryScaler_$type, this.vn());
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "yScaler", {
        get: function () {
            return typeCast(IScaler_$type, this.v3());
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "bucketizer", {
        get: function () {
            return this.xh.cu;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "currentMode2Index", {
        get: function () {
            return this.ws();
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeries.prototype.provideCollisionDetector = function () {
        if (this.xj == 1) {
            return new CollisionAvoider();
        }
        return NonCollisionAvoider.b;
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "trendlinePreparer", {
        get: function () {
            return this.xh.c6 ? this.xh.c5 : null;
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeries.prototype.n2 = function (a) {
        _super.prototype.n2.call(this, a);
        if (this.xh.c6) {
            this.a5.exportTrendlineData(this, a, this.xh.c5.g$j);
        }
    };
    AnchoredCategorySeries.prototype.js = function (a) {
        var _this = this;
        var b = this.fetchXAxis();
        var c = this.fetchYAxis();
        return this.xm.c$b(this, a, this.wp(this.cg), this.valueColumn, b, c, this.xk == 1, function (d) { return _super.prototype.js.call(_this, d); });
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "mayContainUnknowns", {
        get: function () {
            return this.valueColumn == null || this.valueColumn.mayContainUnknowns;
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeries.prototype.h3 = function () {
        return Series.h4(this.valueColumn, typeCast(ISortingAxis_$type, this.fetchXAxis()));
    };
    AnchoredCategorySeries.prototype.get_xv = function () {
        return 0;
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "xv", {
        get: function () {
            return this.get_xv();
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeries.prototype.ar = function (a) {
        if (a.isEmpty && this.cv != null) {
            a = this.cv.tr;
        }
        if (this.valueColumn == null) {
            return null;
        }
        var b = this.tq(this.cg);
        var c = this.vn();
        var d = new ScalerParams(0, a, this.cv.t6, c.ch, this.getEffectiveViewport());
        var e = (c.em(b.left, d));
        var f = (c.em(b.right, d));
        if (c.ch) {
            var g = e;
            e = f;
            f = g;
        }
        e -= this.xv;
        f += this.xv;
        var h = null;
        if (c.cn) {
            h = c;
            e = h.i$f(e);
            f = h.i$f(f);
        }
        else {
            e = Math.floor(e);
            f = Math.ceil(f);
        }
        if (isNaN_(e) || isNaN_(f)) {
            return null;
        }
        e = Math.max(0, Math.min(this.valueColumn.count - 1, e));
        f = Math.max(0, Math.min(this.valueColumn.count - 1, f));
        var i = 1.7976931348623157E+308;
        var j = -1.7976931348623157E+308;
        if (truncate(e) <= truncate(f)) {
            for (var k = truncate(e); k <= truncate(f); k++) {
                var l = k;
                if (h != null) {
                    l = h.i$b._inner[k];
                }
                var m = this.valueColumn.item(l);
                if (this.valueColumn.mayContainUnknowns) {
                    if (isInfinity(m) || isNaN_(m)) {
                        continue;
                    }
                }
                i = Math.min(i, m);
                j = Math.max(j, m);
            }
        }
        var n = new AxisRange(i, j);
        n = this.ap(n, this.v3(), a);
        return n;
    };
    AnchoredCategorySeries.prototype.yf = function () {
        this.hs = this.valueColumn == null || this.valueColumn.count == 0 ? NaN : this.valueColumn.item(this.valueColumn.count - 1);
    };
    AnchoredCategorySeries.prototype.ye = function () {
        if (this.xp) {
            this.xr = 0;
            for (var a = 0; a < this.valueColumn.count; a++) {
                this.xr += this.valueColumn.item(a);
            }
            this.xs = this.xr / this.valueColumn.count;
            this.xp = false;
        }
    };
    AnchoredCategorySeries.prototype.id = function (a, b) {
        if (b == null || !b.cj) {
            return NaN;
        }
        var c = this.v3();
        if (b != c) {
            return NaN;
        }
        var d = this.am(a);
        if (c.cp) {
            return d[1];
        }
        else {
            return d[0];
        }
    };
    AnchoredCategorySeries.prototype.am = function (a) {
        var b = NaN;
        switch (a) {
            case 5:
            case 2:
                b = this.valueColumn.maximum;
                break;
            case 4:
            case 1:
                b = this.valueColumn.minimum;
                break;
            case 6:
            case 3:
                if (this.xp) {
                    this.ye();
                }
                b = this.xs;
                break;
        }
        var c = this.v3();
        if (c.cp) {
            return [NaN, b];
        }
        else {
            return [b, NaN];
        }
    };
    AnchoredCategorySeries.prototype.tm = function (a) {
        var b = NaN;
        switch (a) {
            case 5:
            case 2:
                b = this.valueColumn.maximum;
                break;
            case 4:
            case 1:
                b = this.valueColumn.minimum;
                break;
            case 6:
            case 3:
                if (this.xp) {
                    this.ye();
                }
                b = this.xs;
                break;
        }
        if (isNaN_(b)) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var c = this.v3();
        var d = this.getEffectiveViewport1(this.cg);
        var e = new ScalerParams(0, this.cg.by, this.cg.bx, c.ch, d);
        if (c.cp) {
            e.b = this.h3();
        }
        e.c = d;
        if (c.cp) {
            return { $type: Point_$type, x: NaN, y: c.ej(b, e) };
        }
        else {
            return { $type: Point_$type, x: c.ej(b, e), y: NaN };
        }
    };
    AnchoredCategorySeries.prototype.tn = function (a) {
        var b = this.v3();
        var c = this.getEffectiveViewport1(this.cg);
        var d = new ScalerParams(0, this.cg.by, this.cg.bx, b.ch, c);
        if (b.cp) {
            d.b = this.h3();
        }
        d.c = c;
        if (b.cp) {
            return { $type: Point_$type, x: NaN, y: b.ej(a[1], d) };
        }
        else {
            return { $type: Point_$type, x: b.ej(a[0], d), y: NaN };
        }
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.wk;
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeries.$t = markType(AnchoredCategorySeries, 'AnchoredCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasSingleValueCategory_$type, IHasCategoryTrendline_$type, ITrendLineSeries_$type]);
    AnchoredCategorySeries.yg = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredCategorySeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    AnchoredCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, AnchoredCategorySeries, 'raisePropertyChanged', ['ConsolidatedItemHitTestBehavior:xk:yh', [ConsolidatedItemHitTestBehavior_$type, enumGetBox(ConsolidatedItemHitTestBehavior_$type, 0)], 'HighlightedValueMemberPath:xz:yi', [2, null], 'MarkerCollisionAvoidance:xj:yj', [CategorySeriesMarkerCollisionAvoidance_$type, enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, 1)], 'ValueMemberAsLegendLabel:x3:yr', [2, null], 'ValueMemberAsLegendUnit:x5:ys', [2, null], 'ValueMemberPath:x7:yt', [2, null], 'TrendLineType::yp', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::yo', [1, 1.5], 'TrendLinePeriod::yn', [1, 7], 'TrendLineBrush::yk', [Brush.$, null], 'TrendLineZIndex:xu:yq', [1, 1001], 'TrendLineDashArray:yv:yl', [DoubleCollection.$], 'TrendLineDashCap:yw:ym', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredCategorySeries;
}(CategorySeries));
export { AnchoredCategorySeries };
/**
 * @hidden
 */
var AnchoredCategoryBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredCategoryBucketCalculator, _super);
    function AnchoredCategoryBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.i = null;
        _this.h = null;
        _this.j = 0;
        _this.i = a;
        return _this;
    }
    AnchoredCategoryBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        var b = this.h;
        var c = this.j;
        var d = a * this.d;
        var e = d + this.d - 1;
        var f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        var g = 1.7976931348623157E+308;
        var h = -1.7976931348623157E+308;
        var i = true;
        for (var j = d; j <= e; ++j) {
            var k = b[j];
            g = g < k ? g : k;
            h = h > k ? h : k;
            i = false;
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    };
    AnchoredCategoryBucketCalculator.prototype.getBucket = function (a) {
        var b = this.h;
        var c = this.j;
        var d = a * this.d;
        var e = d + this.d - 1;
        var f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        var g = 0;
        var h = 0;
        var i = true;
        for (var j = d; j <= e; ++j) {
            var k = b[j];
            if (!i) {
                if (!isNaN_(k)) {
                    g = g < k ? g : k;
                    h = h > k ? h : k;
                }
            }
            else {
                if (!isNaN_(k)) {
                    g = k;
                    h = k;
                    i = false;
                }
            }
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    };
    AnchoredCategoryBucketCalculator.prototype.cacheValues = function () {
        this.j = this.i.c3.valueColumn.count;
        this.h = this.i.c3.valueColumn.asArray();
    };
    AnchoredCategoryBucketCalculator.prototype.unCacheValues = function () {
        this.h = null;
    };
    AnchoredCategoryBucketCalculator.$t = markType(AnchoredCategoryBucketCalculator, 'AnchoredCategoryBucketCalculator', CategoryBucketCalculator.$);
    return AnchoredCategoryBucketCalculator;
}(CategoryBucketCalculator));
export { AnchoredCategoryBucketCalculator };
/**
 * @hidden
 */
var AnchoredCategorySeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredCategorySeriesView, _super);
    function AnchoredCategorySeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c3 = null;
        _this.c4 = null;
        _this.c3 = a;
        return _this;
    }
    Object.defineProperty(AnchoredCategorySeriesView.prototype, "c5", {
        get: function () {
            if (this.c4 == null) {
                this.c4 = CategoryTrendLineManagerFactory.a(this.c4, this.e.as(), this.e.qt, this.e, this.e.da);
            }
            return this.c4;
        },
        set: function (a) {
            this.c4 = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeriesView.prototype, "c6", {
        get: function () {
            return this.c4 != null;
        },
        enumerable: false,
        configurable: true
    });
    AnchoredCategorySeriesView.prototype.da = function () {
        this.c3.yu = null;
    };
    AnchoredCategorySeriesView.prototype.c8 = function () {
        this.c3.yu = this.c3.trendLineBrush;
    };
    AnchoredCategorySeriesView.prototype.c7 = function () {
        this.c3.yu = this.c3.su;
    };
    AnchoredCategorySeriesView.prototype.cv = function () {
        return new AnchoredCategoryBucketCalculator(this);
    };
    AnchoredCategorySeriesView.prototype.c9 = function () {
        this.cu.cacheValues();
    };
    AnchoredCategorySeriesView.prototype.db = function () {
        this.cu.unCacheValues();
    };
    AnchoredCategorySeriesView.prototype.dc = function (a) {
        var b = this.cx.item(a);
        return this.cs(b);
    };
    AnchoredCategorySeriesView.prototype.a7 = function (a, b) {
        if (a.d) {
            if (this.c3.trendLineType != 0 && !b) {
                var c = this.c5.g$j;
                c.ad = this.c3.trendLineThickness;
                c._stroke = this.c3.yu;
                c.ai = this.c3.yv;
                c.aj = this.c3.yw;
                a.v(c);
            }
        }
        _super.prototype.a7.call(this, a, b);
    };
    AnchoredCategorySeriesView.prototype.getDefaultTooltipTemplate = function () {
        return this.c3.xm.c$c(this.e, this.c3.x7);
    };
    AnchoredCategorySeriesView.$t = markType(AnchoredCategorySeriesView, 'AnchoredCategorySeriesView', CategorySeriesView.$);
    return AnchoredCategorySeriesView;
}(CategorySeriesView));
export { AnchoredCategorySeriesView };
