/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { AnnotationLayer } from "./AnnotationLayer";
import { Axis } from "./Axis";
import { DependencyProperty } from "igniteui-angular-core";
import { DataToolTipLayerGroupingMode_$type } from "igniteui-angular-core";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { Base, enumGetBox, EnumUtil, fromEnum, typeCast, String_$type, typeGetValue, Point_$type, Array_$type, markType, markDep, runOn, TypeRegistrar } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { RectUtil } from "igniteui-angular-core";
import { DataTooltipGroupedPositionX_$type } from "igniteui-angular-core";
import { DataTooltipGroupedPositionY_$type } from "igniteui-angular-core";
import { DataAbbreviationMode_$type } from "igniteui-angular-core";
import { DataLegendValueMode_$type } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { DataLegendHeaderDateMode_$type } from "igniteui-angular-core";
import { DataLegendHeaderTimeMode_$type } from "igniteui-angular-core";
import { DataLegendSummaryType_$type } from "igniteui-angular-core";
import { LegendItemBadgeShape_$type } from "igniteui-angular-core";
import { DataLegendUnitsMode_$type } from "igniteui-angular-core";
import { DataLegendLabelMode_$type } from "igniteui-angular-core";
import { DataToolTipLayerFrame } from "./DataToolTipLayerFrame";
import { Dictionary$2 } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { DataToolTipSeriesInfo } from "./DataToolTipSeriesInfo";
import { DataContext } from "igniteui-angular-core";
import { DataTooltipCollisionInfo } from "./DataTooltipCollisionInfo";
import { DeviceUtils } from "igniteui-angular-core";
import { HashSet$1 } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { stringEmpty } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { PointerTooltip } from "./PointerTooltip";
import { IOnDemandRender_$type } from "igniteui-angular-core";
/**
 * @hidden
 */
var DataToolTipLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DataToolTipLayer, _super);
    function DataToolTipLayer() {
        var _this = _super.call(this) || this;
        _this.xr = 1;
        _this.yt = new Dictionary$2(String_$type, Base.$, 0);
        _this.yu = new List$1(String_$type, 0);
        _this.xj = 8;
        _this.xn = 11;
        _this.x6 = null;
        _this.xy = null;
        _this.x1 = null;
        _this.x3 = null;
        _this.x0 = null;
        _this.x2 = null;
        _this.x5 = null;
        _this.x4 = null;
        _this.xz = null;
        var a = new DataToolTipLayerFrame();
        var b = new DataToolTipLayerFrame();
        var c = new DataToolTipLayerFrame();
        _this.uh = a;
        _this.ug = b;
        _this.ui = c;
        _this.ab = DataToolTipLayer.$;
        return _this;
    }
    DataToolTipLayer.prototype.bc = function () {
        return new DataToolTipLayer();
    };
    DataToolTipLayer.prototype.get_d6 = function () {
        return true;
    };
    DataToolTipLayer.prototype.cd = function () {
        return new DataToolTipLayerView(this);
    };
    DataToolTipLayer.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.xv = a;
    };
    DataToolTipLayer.prototype.get_eh = function () {
        return true;
    };
    Object.defineProperty(DataToolTipLayer.prototype, "xs", {
        get: function () {
            return this.xr;
        },
        set: function (a) {
            var b = this.xr;
            this.xr = a;
            if (b != this.xr) {
                this.raisePropertyChanged("ActualGroupingMode", enumGetBox(DataToolTipLayerGroupingMode_$type, b), enumGetBox(DataToolTipLayerGroupingMode_$type, this.xr));
            }
        },
        enumerable: false,
        configurable: true
    });
    DataToolTipLayer.prototype.xu = function () {
        var e_1, _a;
        var a = true;
        var b = true;
        var c = true;
        var d = true;
        if (this.xt != 0) {
            return this.xt;
        }
        var e = this.xa();
        if (e != null) {
            try {
                for (var _b = __values(fromEnum(e.db())), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    if (!f.d7 && !f.fa) {
                        a = false;
                    }
                    if (!f.d7 && !f.e3) {
                        b = false;
                    }
                    if (!f.d7 && !f.fb) {
                        c = false;
                    }
                    if (!f.d7 && !f.e7) {
                        d = false;
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
        if (a || b || c || d) {
            return 2;
        }
        return 1;
    };
    DataToolTipLayer.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        switch (b) {
            case DataToolTipLayer.$$p[37]:
                this.pr(true);
                break;
            case DataToolTipLayer.$$p[44]:
                this.pr(true);
                break;
            case DataToolTipLayer.$$p[8]:
                this.xs = this.xu();
                break;
            case "ActualGroupingMode":
                this.pr(true);
                break;
            case DataToolTipLayer.$$p[6]:
                this.xk = this.xm();
                break;
            case DataToolTipLayer.$$p[7]:
                this.xo = this.xq();
                break;
            case "SeriesViewer":
                this.xv.cl();
                break;
            case DataToolTipLayer.$$p[26]:
            case DataToolTipLayer.$$p[20]:
            case DataToolTipLayer.$$p[5]:
            case DataToolTipLayer.$$p[19]:
            case DataToolTipLayer.$$p[4]:
            case DataToolTipLayer.$$p[45]:
            case DataToolTipLayer.$$p[47]:
            case DataToolTipLayer.$$p[48]:
            case DataToolTipLayer.$$p[49]:
            case DataToolTipLayer.$$p[46]:
            case DataToolTipLayer.$$p[52]:
            case DataToolTipLayer.$$p[51]:
            case DataToolTipLayer.$$p[50]:
            case DataToolTipLayer.$$p[53]:
            case DataToolTipLayer.$$p[54]:
            case DataToolTipLayer.$$p[58]:
            case DataToolTipLayer.$$p[57]:
            case DataToolTipLayer.$$p[56]:
            case DataToolTipLayer.$$p[55]:
            case "ValueTextStyle":
            case DataToolTipLayer.$$p[12]:
            case DataToolTipLayer.$$p[11]:
            case DataToolTipLayer.$$p[9]:
            case DataToolTipLayer.$$p[10]:
            case DataToolTipLayer.$$p[13]:
            case DataToolTipLayer.$$p[18]:
            case DataToolTipLayer.$$p[16]:
            case DataToolTipLayer.$$p[17]:
            case DataToolTipLayer.$$p[14]:
            case DataToolTipLayer.$$p[15]:
            case "HeaderTextStyle":
            case DataToolTipLayer.$$p[30]:
            case "SummaryTitleTextStyle":
            case DataToolTipLayer.$$p[33]:
            case DataToolTipLayer.$$p[32]:
            case DataToolTipLayer.$$p[31]:
            case DataToolTipLayer.$$p[29]:
            case DataToolTipLayer.$$p[36]:
            case "SummaryValueTextStyle":
            case DataToolTipLayer.$$p[28]:
            case DataToolTipLayer.$$p[27]:
            case "SummaryLabelTextStyle":
            case DataToolTipLayer.$$p[35]:
            case DataToolTipLayer.$$p[34]:
            case "SummaryUnitsTextStyle":
            case DataToolTipLayer.$$p[0]:
            case DataToolTipLayer.$$p[1]:
            case DataToolTipLayer.$$p[40]:
            case DataToolTipLayer.$$p[43]:
            case DataToolTipLayer.$$p[41]:
            case DataToolTipLayer.$$p[42]:
            case "UnitsTextStyle":
            case DataToolTipLayer.$$p[39]:
            case DataToolTipLayer.$$p[38]:
            case "TitleTextStyle":
            case DataToolTipLayer.$$p[21]:
            case DataToolTipLayer.$$p[22]:
            case DataToolTipLayer.$$p[23]:
            case "LabelTextStyle":
                this.acb(b, c, d);
                break;
        }
    };
    DataToolTipLayer.prototype.acb = function (a, b, c) {
        if (!this.yt.containsKey(a)) {
            this.yu.add(a);
            this.yt.addItem(a, c);
        }
        else {
            this.yt.item(a, c);
        }
        this.pr(true);
    };
    DataToolTipLayer.prototype.acf = function (a, b) {
        switch (a) {
            case DataToolTipLayer.$$p[8]:
                this.xt = EnumUtil.getEnumValue(DataToolTipLayerGroupingMode_$type, b);
                break;
            case DataToolTipLayer.$$p[24]:
                this.yy = b;
                break;
            case DataToolTipLayer.$$p[25]:
                this.yz = b;
                break;
            case DataToolTipLayer.$$p[2]:
                this.yw = b;
                break;
            case DataToolTipLayer.$$p[3]:
                this.yx = b;
                break;
            case DataToolTipLayer.$$p[6]:
                this.xl = EnumUtil.getEnumValue(DataTooltipGroupedPositionX_$type, b);
                break;
            case DataToolTipLayer.$$p[7]:
                this.xp = EnumUtil.getEnumValue(DataTooltipGroupedPositionY_$type, b);
                break;
            case DataToolTipLayer.$$p[26]:
                this.yo = b;
                break;
            case DataToolTipLayer.$$p[20]:
                this.w8 = b;
                break;
            case DataToolTipLayer.$$p[5]:
                this.w3 = b;
                break;
            case DataToolTipLayer.$$p[19]:
                this.w7 = b;
                break;
            case DataToolTipLayer.$$p[4]:
                this.w2 = b;
                break;
            case DataToolTipLayer.$$p[45]:
                this.xc = EnumUtil.getEnumValue(DataAbbreviationMode_$type, b);
                break;
            case DataToolTipLayer.$$p[47]:
                this.zy = typeGetValue(b);
                break;
            case DataToolTipLayer.$$p[48]:
                this.zz = typeGetValue(b);
                break;
            case DataToolTipLayer.$$p[49]:
                this.xi = EnumUtil.getEnumValue(DataLegendValueMode_$type, b);
                break;
            case DataToolTipLayer.$$p[46]:
                this.abt = b;
                break;
            case DataToolTipLayer.$$p[52]:
                this.yq = b;
                break;
            case DataToolTipLayer.$$p[51]:
                this.abz = b;
                break;
            case DataToolTipLayer.$$p[50]:
                this.w9 = b;
                break;
            case DataToolTipLayer.$$p[53]:
                this.aeq = b;
                break;
            case DataToolTipLayer.$$p[54]:
                this.yr = b;
                break;
            case DataToolTipLayer.$$p[58]:
                this.ab8 = b;
                break;
            case DataToolTipLayer.$$p[57]:
                this.ys = b;
                break;
            case DataToolTipLayer.$$p[56]:
                this.aer = b;
                break;
            case DataToolTipLayer.$$p[55]:
                this.aeb = b;
                break;
            case "ValueTextStyle":
                this.yf = b;
                break;
            case DataToolTipLayer.$$p[12]:
                this.aah = b;
                break;
            case DataToolTipLayer.$$p[11]:
                this.w6 = b;
                break;
            case DataToolTipLayer.$$p[9]:
                this.aad = b;
                break;
            case DataToolTipLayer.$$p[10]:
                this.xd = EnumUtil.getEnumValue(DataLegendHeaderDateMode_$type, b);
                break;
            case DataToolTipLayer.$$p[13]:
                this.xe = EnumUtil.getEnumValue(DataLegendHeaderTimeMode_$type, b);
                break;
            case DataToolTipLayer.$$p[18]:
                this.aam = b;
                break;
            case DataToolTipLayer.$$p[16]:
                this.ad3 = b;
                break;
            case DataToolTipLayer.$$p[17]:
                this.aek = b;
                break;
            case DataToolTipLayer.$$p[14]:
                this.aej = b;
                break;
            case DataToolTipLayer.$$p[15]:
                this.yh = b;
                break;
            case "HeaderTextStyle":
                this.x7 = b;
                break;
            case DataToolTipLayer.$$p[30]:
                this.ad6 = b;
                break;
            case "SummaryTitleTextStyle":
                this.ya = b;
                break;
            case DataToolTipLayer.$$p[33]:
                this.xg = EnumUtil.getEnumValue(DataLegendSummaryType_$type, b);
                break;
            case DataToolTipLayer.$$p[32]:
                this.aa5 = b;
                break;
            case DataToolTipLayer.$$p[31]:
                this.aen = b;
                break;
            case DataToolTipLayer.$$p[29]:
                this.aem = b;
                break;
            case DataToolTipLayer.$$p[36]:
                this.ad8 = b;
                break;
            case "SummaryValueTextStyle":
                this.yc = b;
                break;
            case DataToolTipLayer.$$p[28]:
                this.aa0 = b;
                break;
            case DataToolTipLayer.$$p[27]:
                this.ad5 = b;
                break;
            case "SummaryLabelTextStyle":
                this.x9 = b;
                break;
            case DataToolTipLayer.$$p[35]:
                this.abb = b;
                break;
            case DataToolTipLayer.$$p[34]:
                this.ad7 = b;
                break;
            case "SummaryUnitsTextStyle":
                this.yb = b;
                break;
            case DataToolTipLayer.$$p[0]:
                this.aei = b;
                break;
            case DataToolTipLayer.$$p[1]:
                this.xx = EnumUtil.getEnumValue(LegendItemBadgeShape_$type, b);
                break;
            case DataToolTipLayer.$$p[40]:
                this.xh = EnumUtil.getEnumValue(DataLegendUnitsMode_$type, b);
                break;
            case DataToolTipLayer.$$p[43]:
                this.abm = b;
                break;
            case DataToolTipLayer.$$p[41]:
                this.aea = b;
                break;
            case DataToolTipLayer.$$p[42]:
                this.aep = b;
                break;
            case "UnitsTextStyle":
                this.ye = b;
                break;
            case DataToolTipLayer.$$p[39]:
                this.aeo = b;
                break;
            case DataToolTipLayer.$$p[38]:
                this.ad9 = b;
                break;
            case "TitleTextStyle":
                this.yd = b;
                break;
            case DataToolTipLayer.$$p[21]:
                this.xf = EnumUtil.getEnumValue(DataLegendLabelMode_$type, b);
                break;
            case DataToolTipLayer.$$p[22]:
                this.ad4 = b;
                break;
            case DataToolTipLayer.$$p[23]:
                this.ael = b;
                break;
            case "LabelTextStyle":
                this.x8 = b;
                break;
        }
    };
    DataToolTipLayer.prototype.acc = function (a) {
        for (var b = 0; b < this.yu.count; b++) {
            var c = this.yu._inner[b];
            a.updatePropertyByName(c, this.yt.item(c));
        }
    };
    DataToolTipLayer.prototype.vt = function (a, b) {
        {
            if (!this.at.c) {
                this.pr(b);
            }
        }
    };
    DataToolTipLayer.prototype.vu = function (a, b) {
        if (!this.at.c) {
            this.pr(b);
        }
    };
    DataToolTipLayer.prototype.vw = function (a, b) {
        var e_2, _a;
        var _this = this;
        _super.prototype.vw.call(this, a, b);
        this.xr = this.xu();
        var c = a;
        var d = this.xv.b9;
        var e = this.yp;
        var f = false;
        c.m.clear();
        c.i.clear();
        c.l.clear();
        c.g.clear();
        c.f.clear();
        c.k.clear();
        c.j.clear();
        c.h.clear();
        if (isNaN_(this.wz.x) && isNaN_(this.wz.y)) {
            d.count = 0;
            return;
        }
        {
            if (this.xs == 2) {
                var g_1 = 0;
                {
                    try {
                        for (var _b = __values(fromEnum(this.cv.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var h = _c.value;
                            if (this.un(h)) {
                                this.ace(h, c, e, f, g_1);
                                g_1++;
                            }
                            if (h.isStacked) {
                                h.n6(function (i) {
                                    if (_this.un(i)) {
                                        _this.ace(i, c, e, f, g_1);
                                        g_1++;
                                    }
                                    if (i.dw) {
                                        i.n4(function (j) {
                                            if (_this.un(j)) {
                                                _this.ace(j, c, e, f, g_1);
                                                g_1++;
                                            }
                                            return true;
                                        });
                                    }
                                    return true;
                                });
                            }
                            if (h.dw) {
                                h.n4(function (i) {
                                    if (_this.un(i)) {
                                        _this.ace(i, c, e, f, g_1);
                                        g_1++;
                                    }
                                    return true;
                                });
                            }
                        }
                    }
                    catch (e_2_1) {
                        e_2 = { error: e_2_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_2)
                                throw e_2.error;
                        }
                    }
                    this.aca(c);
                }
                d.count = g_1;
            }
            else {
                var i = this.xa();
                var j = this.yv(i);
                var k = this.xw(i, j, e);
                this.acd(k, c, e);
            }
        }
    };
    DataToolTipLayer.prototype.yv = function (a) {
        var e_3, _a;
        var b = new List$1(Series.$, 0);
        if (a == null) {
            return b;
        }
        try {
            for (var _b = __values(fromEnum(a.de)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                b.add(c);
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        return b;
    };
    DataToolTipLayer.prototype.xa = function () {
        var e_4, _a, e_5, _b;
        if (this.xb != null) {
            return this.xb;
        }
        if (this.cv == null) {
            return null;
        }
        try {
            for (var _c = __values(fromEnum(this.cv.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var a = _d.value;
                if (a.ed) {
                    var b = a.as();
                    if (b != null && b.co()) {
                        return b;
                    }
                }
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(this.cv.series)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var c = _f.value;
                if (!c.ed) {
                    var d = c.ag();
                    var e = d != null && d.length > 0 ? d[0] : null;
                    if (e != null && e.co()) {
                        return e;
                    }
                }
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
        return null;
    };
    DataToolTipLayer.prototype.xw = function (a, b, c) {
        var d = 1.7976931348623157E+308;
        var e = -1.7976931348623157E+308;
        var f = new List$1(DataContext.$, 0);
        var g = new List$1(Base.$, 0);
        var h = false;
        var i = true;
        var j = { $type: Point_$type, x: NaN, y: NaN };
        var k = 0;
        var l = 0;
        var _loop_1 = function (m) {
            var n = b.item(m);
            k = n.cv.l;
            l = n.cv.m;
            if (n.ed) {
                var o = n;
                var p_1 = new List$1(Series.$, 0);
                if (o.isStacked) {
                    o.n6(function (q) {
                        p_1.add(q);
                        if (q.dw) {
                            q.n4(function (r) {
                                p_1.add(r);
                                return true;
                            });
                        }
                        return true;
                    });
                }
                else if (o.dw) {
                    p_1.add(o);
                    o.n4(function (q) {
                        p_1.add(q);
                        return true;
                    });
                }
                else {
                    p_1.add(o);
                }
                for (var q = 0; q < p_1.count; q++) {
                    var r = p_1._inner[q];
                    var s = p_1._inner[q];
                    if (!r.categoryAxis.co()) {
                        continue;
                    }
                    if (i) {
                        h = s.isVertical;
                    }
                    else {
                        if (h != s.isVertical) {
                            continue;
                        }
                    }
                    var t = this_1.vp(s);
                    if (!t.c) {
                        continue;
                    }
                    j = s.te(t.d);
                    var u = s.tj(t.d, c, false);
                    if (h) {
                        if (!isNaN_(u.y)) {
                            d = Math.min(d, u.y);
                            e = Math.max(e, u.y);
                        }
                    }
                    else {
                        if (!isNaN_(u.x)) {
                            d = Math.min(d, u.x);
                            e = Math.max(e, u.x);
                        }
                    }
                }
            }
            else {
                var v = n.ag();
                for (var w = 0; w < v.length; w++) {
                    if (!v[w].co()) {
                        continue;
                    }
                }
                var x = n.tj(this_1.wz, c, false);
                j = n.te(this_1.wz);
                if (h) {
                    if (!isNaN_(x.y)) {
                        d = Math.min(d, x.y);
                        e = Math.max(e, x.y);
                    }
                }
                else {
                    if (!isNaN_(x.x)) {
                        d = Math.min(d, x.x);
                        e = Math.max(e, x.x);
                    }
                }
            }
            var y = null;
            var z = n.js(this_1.wz);
            if (n.ei && z != null) {
                y = n.av(z);
            }
            else {
                y = new DataContext();
                y.item = z;
                y.series = n;
            }
            f.add(y);
        };
        var this_1 = this;
        for (var m = 0; m < b.count; m++) {
            _loop_1(m);
        }
        var aa = 0;
        var ab = 0;
        if (h) {
            ab = (d + e) / 2;
            aa = this.ty.right;
            if (!isNaN_(j.x)) {
                aa = j.x;
            }
            if (ab < 0 || ab > this.ty.bottom) {
                ab = NaN;
            }
        }
        else {
            aa = (d + e) / 2;
            if (!isNaN_(j.y)) {
                ab = j.y;
            }
            if (aa < 0 || aa > this.ty.right) {
                aa = NaN;
            }
        }
        var ac = new DataToolTipSeriesInfo();
        ac.f = { $type: Point_$type, x: aa, y: ab };
        ac.e = { $type: Point_$type, x: j.x, y: j.y };
        ac.b = f;
        ac.a = h;
        return ac;
    };
    DataToolTipLayer.prototype.n9 = function () {
        this.wz = { $type: Point_$type, x: NaN, y: NaN };
        this.pr(false);
        this.xv.cj(false);
    };
    DataToolTipLayer.prototype.oa = function () {
        this.wz = { $type: Point_$type, x: NaN, y: NaN };
        this.pr(false);
        this.xv.cj(true);
    };
    Object.defineProperty(DataToolTipLayer.prototype, "aef", {
        get: function () {
            var a = RectUtil.n(this.cg.bx);
            var b = new Size(1, this.cg.bx.width, this.cg.bx.height);
            return new Rect(3, a, b);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataToolTipLayer.prototype, "aee", {
        get: function () {
            var a = RectUtil.n(this.cg.bx);
            var b = new Size(1, this.cg.bx.width, this.cg.bx.height);
            return new Rect(3, this.xv.cm(a), b);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataToolTipLayer.prototype, "aed", {
        get: function () {
            var a = new Rect(0, 0, 0, this.cv.m, this.cv.l);
            var b = RectUtil.n(a);
            var c = new Size(1, a.width, a.height);
            return new Rect(3, this.xv.cm(b), c);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataToolTipLayer.prototype, "aeh", {
        get: function () {
            var a = { $type: Point_$type, x: 0, y: 0 };
            return new Rect(3, a, this.xv.cr());
        },
        enumerable: false,
        configurable: true
    });
    DataToolTipLayer.prototype.aeg = function () {
        return this.aef;
    };
    DataToolTipLayer.prototype.yl = function (a, b, c) {
        if (Rect.l_op_Equality(a, Rect.empty)) {
            return false;
        }
        var d = a.top;
        return c < d;
    };
    DataToolTipLayer.prototype.yi = function (a, b, c, d) {
        if (Rect.l_op_Equality(a, Rect.empty)) {
            return false;
        }
        var e = a.bottom;
        return c + d.height >= e;
    };
    DataToolTipLayer.prototype.yj = function (a, b, c) {
        if (Rect.l_op_Equality(a, Rect.empty)) {
            return false;
        }
        var d = a.left;
        return c < d;
    };
    DataToolTipLayer.prototype.yk = function (a, b, c, d) {
        if (Rect.l_op_Equality(a, Rect.empty)) {
            return false;
        }
        var e = a.right;
        return c + d.width > e;
    };
    DataToolTipLayer.prototype.zo = function (a, b) {
        return a.top + b;
    };
    DataToolTipLayer.prototype.zm = function (a, b, c) {
        return a.bottom - c.height - b;
    };
    DataToolTipLayer.prototype.zn = function (a, b) {
        return ((a.bottom + a.top) / 2) - (b.height / 2);
    };
    DataToolTipLayer.prototype.zx = function (a, b, c, d, e) {
        var f = c.y - d.height - b;
        return f;
    };
    DataToolTipLayer.prototype.zv = function (a, b, c, d, e) {
        var f = c.y + b;
        return f;
    };
    DataToolTipLayer.prototype.zw = function (a, b, c, d, e) {
        var f = c.y - (d.height / 2);
        return f;
    };
    DataToolTipLayer.prototype.zr = function (a, b, c, d, e) {
        var f = c.y - d.height;
        f = f - b;
        return f;
    };
    DataToolTipLayer.prototype.zp = function (a, b, c, d, e) {
        var f = c.y;
        f = f + b;
        return f;
    };
    DataToolTipLayer.prototype.zq = function (a, b, c, d, e) {
        var f = c.y - (d.height / 2);
        return f;
    };
    DataToolTipLayer.prototype.y7 = function (a, b) {
        return a.left + b;
    };
    DataToolTipLayer.prototype.y9 = function (a, b, c) {
        return (a.right - (c.width)) - b;
    };
    DataToolTipLayer.prototype.y8 = function (a, b, c) {
        return ((a.right + a.left) / 2) - (c.width / 2) + b;
    };
    DataToolTipLayer.prototype.zg = function (a, b, c, d, e) {
        var f = (c.x - d.width) - b;
        return f;
    };
    DataToolTipLayer.prototype.zi = function (a, b, c, d, e) {
        var f = c.x + b;
        return f;
    };
    DataToolTipLayer.prototype.zh = function (a, b, c, d, e) {
        var f = (c.x - (d.width / 2));
        f = f + b;
        return f;
    };
    DataToolTipLayer.prototype.zd = function (a, b, c, d, e) {
        var f = c.x - d.width;
        f = f - b;
        return f;
    };
    DataToolTipLayer.prototype.zf = function (a, b, c, d, e) {
        var f = c.x;
        f = f + b;
        return f;
    };
    DataToolTipLayer.prototype.ze = function (a, b, c, d, e) {
        var f = c.x - (d.width / 2);
        f = f + b;
        return f;
    };
    DataToolTipLayer.prototype.y3 = function (a, b, c, d, e, f, g, h) {
        switch (a) {
            case 1:
                {
                    return this.zr(e, b, h, f, true);
                }
            case 2:
                {
                    return this.zp(e, b, h, f, true);
                }
            case 3:
                {
                    return this.zq(e, b, h, f, true);
                }
            case 5: return this.zs(e, c, b, h, f);
            case 6: return this.zt(e, c, b, h, f);
            case 4: return this.zu(e, c, b, h, f);
            case 8: return this.zj(e, c, b, h, f);
            case 9: return this.zk(e, c, b, h, f);
            case 7: return this.zl(e, c, b, h, f);
            case 13: return this.zo(d, b);
            case 14: return this.zm(d, b, f);
            case 15: return this.zn(d, f);
            case 10: return this.zx(e, b, g, f, true);
            case 12: return this.zw(e, b, g, f, true);
            case 11:
            default: return this.zv(e, b, g, f, true);
        }
    };
    DataToolTipLayer.prototype.za = function (a, b, c, d, e) {
        var f = d.x;
        f = f + b / 2;
        f = f - e.width;
        f = f - c;
        return f;
    };
    DataToolTipLayer.prototype.zb = function (a, b, c, d, e) {
        var f = d.x;
        f = f + b / 2;
        f = f - e.width / 2;
        f = f + c;
        return f;
    };
    DataToolTipLayer.prototype.zc = function (a, b, c, d, e) {
        var f = d.x;
        f = f + b / 2;
        f = f + c;
        return f;
    };
    DataToolTipLayer.prototype.y4 = function (a, b, c, d, e) {
        var f = d.x;
        f = f - b / 2;
        f = f - e.width;
        f = f - c;
        return f;
    };
    DataToolTipLayer.prototype.y5 = function (a, b, c, d, e) {
        var f = d.x;
        f = f - b / 2;
        f = f - e.width / 2;
        f = f + c;
        return f;
    };
    DataToolTipLayer.prototype.y6 = function (a, b, c, d, e) {
        var f = d.x;
        f = f - b / 2;
        f = f + c;
        return f;
    };
    DataToolTipLayer.prototype.zl = function (a, b, c, d, e) {
        var f = d.y;
        f = f + b / 2;
        f = f - e.height;
        f = f - c;
        return f;
    };
    DataToolTipLayer.prototype.zk = function (a, b, c, d, e) {
        var f = d.y;
        f = f + b / 2;
        f = f - e.height / 2;
        f = f + c;
        return f;
    };
    DataToolTipLayer.prototype.zj = function (a, b, c, d, e) {
        var f = d.y;
        f = f + b / 2;
        f = f + c;
        return f;
    };
    DataToolTipLayer.prototype.zu = function (a, b, c, d, e) {
        var f = d.y;
        f = f - b / 2;
        f = f - e.height;
        f = f - c;
        return f;
    };
    DataToolTipLayer.prototype.zt = function (a, b, c, d, e) {
        var f = d.y;
        f = f - b / 2;
        f = f - e.height / 2;
        f = f + c;
        return f;
    };
    DataToolTipLayer.prototype.zs = function (a, b, c, d, e) {
        var f = d.y;
        f = f - b / 2;
        f = f + c;
        return f;
    };
    DataToolTipLayer.prototype.y2 = function (a, b, c, d, e, f, g, h) {
        switch (a) {
            case 10: return this.zg(e, b, g, f, true);
            case 11: return this.zi(e, b, g, f, true);
            case 12: return this.zh(e, b, g, f, true);
            case 13: return this.y7(d, b);
            case 14: return this.y9(e, b, f);
            case 15: return this.y8(e, b, f);
            case 5: return this.y6(e, c, b, h, f);
            case 6: return this.y5(e, c, b, h, f);
            case 4: return this.y4(e, c, b, h, f);
            case 8: return this.zc(e, c, b, h, f);
            case 9: return this.zb(e, c, b, h, f);
            case 7: return this.za(e, c, b, h, f);
            case 1:
                {
                    return this.zd(e, b, h, f, true);
                }
            case 3:
                {
                    return this.ze(e, b, h, f, true);
                }
            case 2:
            default:
                {
                    return this.zf(e, b, h, f, true);
                }
        }
    };
    DataToolTipLayer.prototype.aec = function (a, b, c, d) {
        var e = this.xk;
        var f = this.xo;
        var g = this.xa();
        var h = 0;
        if (g != null && g.cb && this.cv != null) {
            h = g.getCategorySize(this.cv.tr, this.ty, this.getEffectiveViewport());
            if (g.categoryMode == 0) {
                h = 0;
            }
        }
        var i = this.y0(e);
        var j = this.y1(f);
        var k = this.y2(e, i, h, this.aef, a, b, c, d);
        var l = this.y3(f, j, h, this.aef, a, b, c, d);
        var m = this.ym(a, i, k, b);
        var n = this.yn(a, j, l, b);
        if (!m) {
            var o = this.w4(e);
            var p = 0;
            while (!m && p < o.length) {
                e = o[p];
                i = this.y0(e);
                k = this.y2(e, i, h, this.aef, a, b, c, d);
                m = this.ym(a, i, k, b);
                p++;
            }
        }
        if (!n) {
            var q = this.w5(f);
            var r = 0;
            while (!n && r < q.length) {
                f = q[r];
                j = this.y1(f);
                l = this.y3(f, j, h, this.aef, a, b, c, d);
                n = this.yn(a, j, l, b);
                r++;
            }
        }
        return { $type: Point_$type, x: k, y: l };
    };
    DataToolTipLayer.prototype.y1 = function (a) {
        if (!isNaN_(this.yz)) {
            return this.yz;
        }
        switch (a) {
            case 1: return this.yx;
            case 2: return this.yx;
            case 3: return 0;
            case 4: return this.yx;
            case 5: return this.yx;
            case 6: return this.yx;
            case 7: return this.yx;
            case 8: return this.yx;
            case 9: return 0;
            case 10: return this.yx;
            case 11: return this.yx;
            case 12: return 0;
            case 13: return this.yx;
            case 14: return this.yx;
            case 15: return 0;
        }
        return this.yx;
    };
    DataToolTipLayer.prototype.y0 = function (a) {
        if (!isNaN_(this.yy)) {
            return this.yy;
        }
        switch (a) {
            case 4: return this.yw;
            case 6: return 0;
            case 5: return this.yw;
            case 13: return this.yw;
            case 15: return 0;
            case 14: return this.yw;
            case 7: return this.yw;
            case 9: return 0;
            case 8: return this.yw;
            case 1: return this.yw;
            case 3: return 0;
            case 2: return this.yw;
            case 10: return this.yw;
            case 12: return 0;
            case 11: return this.yw;
        }
        return this.yw;
    };
    DataToolTipLayer.prototype.w5 = function (a) {
        var b = [a];
        switch (a) {
            case 1:
                b = [2, 3];
                break;
            case 2:
                b = [1, 3];
                break;
            case 3:
                b = [1, 2];
                break;
            case 4:
                b = [8, 7, 3];
                break;
            case 5:
                b = [7, 8, 3];
                break;
            case 6:
                b = [9, 8, 4, 3];
                break;
            case 7:
                b = [5, 4, 2];
                break;
            case 8:
                b = [4, 5, 3];
                break;
            case 9:
                b = [6, 4, 8, 3];
                break;
            case 10:
                b = [11, 12];
                break;
            case 11:
                b = [10, 12];
                break;
            case 12:
                b = [10, 11];
                break;
            case 13: break;
            case 14: break;
            case 15: break;
        }
        return b;
    };
    DataToolTipLayer.prototype.w4 = function (a) {
        var b = [a];
        switch (a) {
            case 1:
                b = [2, 3];
                break;
            case 2:
                b = [1, 3];
                break;
            case 3:
                b = [1, 2];
                break;
            case 4:
                b = [8, 7, 3];
                break;
            case 5:
                b = [7, 8, 1];
                break;
            case 6:
                b = [9, 8, 4, 3];
                break;
            case 7:
                b = [5, 4, 2];
                break;
            case 8:
                b = [4, 5, 3];
                break;
            case 9:
                b = [6, 4, 8, 3];
                break;
            case 10:
                b = [11, 12];
                break;
            case 11:
                b = [10, 12];
                break;
            case 12:
                b = [10, 11];
                break;
            case 13: break;
            case 14: break;
            case 15: break;
        }
        return b;
    };
    DataToolTipLayer.prototype.ym = function (a, b, c, d) {
        return !(this.yj(a, b, c) || this.yk(a, b, c, d));
    };
    DataToolTipLayer.prototype.yn = function (a, b, c, d) {
        return !(this.yl(a, b, c) || this.yi(a, b, c, d));
    };
    DataToolTipLayer.prototype.aca = function (a) {
        var b = new List$1(DataTooltipCollisionInfo.$, 0);
        for (var c = 0; c < a.f.count; c++) {
            var d = new DataTooltipCollisionInfo();
            d.d = c;
            d.e = { $type: Point_$type, x: a.f._inner[c], y: a.g._inner[c] };
            d.c = a.k._inner[c];
            d.a = a.j._inner[c];
            d.b = a.m._inner[c];
            if (isNaN_(d.e.x) || isNaN_(d.e.y)) {
                continue;
            }
            b.add(d);
        }
        b.aa(function (e, f) {
            if (e.e.y < f.e.y) {
                return -1;
            }
            if (e.e.y > f.e.y) {
                return 1;
            }
            if (e.b < f.b) {
                return -1;
            }
            if (e.b > f.b) {
                return 1;
            }
            return 0;
        });
        var e = this.yg(b);
        if (!e) {
            return;
        }
        for (var f = 0; f < b.count - 1; f++) {
            var g = b._inner[f];
            var h = b._inner[f + 1];
            var i = new Rect(0, g.e.x, g.e.y, g.c, g.a);
            var j = new Rect(0, h.e.x, h.e.y, h.c, h.a);
            if (i.intersectsWith(j) || i.top > j.bottom) {
                h.e = { $type: Point_$type, x: h.e.x, y: i.bottom + 1 };
            }
        }
        if (b._inner[b.count - 1].e.y + b._inner[b.count - 1].a > this.cg.bx.height) {
            b._inner[b.count - 1].e = { $type: Point_$type, x: b._inner[b.count - 1].e.x, y: b._inner[b.count - 1].e.y - ((b._inner[b.count - 1].e.y + b._inner[b.count - 1].a) - this.cg.bx.height) };
        }
        for (var k = b.count - 1; k >= 1; k--) {
            var l = b._inner[k];
            var m = b._inner[k - 1];
            var n = new Rect(0, l.e.x, l.e.y, l.c, l.a);
            var o = new Rect(0, m.e.x, m.e.y, m.c, m.a);
            if (n.intersectsWith(o) || n.top < o.bottom) {
                m.e = { $type: Point_$type, x: m.e.x, y: n.top - (o.height + 1) };
            }
        }
        for (var p = 0; p < b.count; p++) {
            var q = b._inner[p].d;
            var r = b._inner[p];
            a.f._inner[q] = r.e.x;
            a.g._inner[q] = r.e.y;
        }
    };
    DataToolTipLayer.prototype.yg = function (a) {
        if (a.count <= 1) {
            return false;
        }
        var b = this.cg.bx;
        for (var c = 0; c < a.count - 1; c++) {
            var d = a._inner[c];
            var e = a._inner[c + 1];
            var f = new Rect(0, d.e.x, d.e.y, d.c, d.a);
            var g = new Rect(0, e.e.x, e.e.y, e.c, e.a);
            if (f.intersectsWith(g)) {
                return true;
            }
        }
        return false;
    };
    DataToolTipLayer.prototype.ace = function (a, b, c, d, e) {
        var f = this.vp(a);
        if (!f.c) {
            return;
        }
        var g = a.tj(f.d, c, d);
        var h = this.xv.b9;
        var i = this.wz;
        if (!c) {
            i = this.to(g);
        }
        var j = a.js(i);
        var k = h.item(e);
        var l = this.cg.bx;
        var m = this.xv.b8(k);
        if (!Base.equalsStatic(m.target, this.cv)) {
            m.target = this.cv;
        }
        m.includedSeries = [a.dataLegendKey];
        this.acc(m);
        m.targetCursorPositionX = this.wz.x;
        m.targetCursorPositionY = this.wz.y;
        if (!this.xv.cb(k, a)) {
            return;
        }
        var n = this.xv.cq(k);
        b.i.add1(k);
        var o = g.x;
        var p = g.x;
        p = Math.max(p, l.left);
        p = Math.min(p, l.right);
        b.l.add(p);
        var q = g.y;
        q = Math.max(q, l.top);
        q = Math.min(q, l.bottom);
        b.m.add(q);
        var r = DeviceUtils.g(10);
        var s = g.x + r;
        if (s + n.width > l.right) {
            s = (o - n.width) - r;
        }
        if (s < l.left) {
            s = l.left;
        }
        b.f.add(s);
        var t = (g.y - n.height) - r;
        if (t + n.height > l.bottom) {
            t = (l.bottom - n.height) - r;
        }
        if (t < l.top) {
            t = l.top;
        }
        b.g.add(t);
        b.k.add(n.width);
        b.j.add(n.height);
        var u = this.su;
        if (u == null) {
            u = this.sy;
        }
        if (u == null) {
            u = a.su;
        }
        b.h.add(u);
    };
    DataToolTipLayer.prototype.acd = function (a, b, c) {
        var e_6, _a;
        this.xj = this.xm();
        this.xn = this.xq();
        var d = a.f;
        var e = a.e;
        var f = 0;
        var g = this.xv.b9.item(0);
        this.xv.cb(g, null);
        var h = this.xv.b8(g);
        if (!Base.equalsStatic(h.target, this.cv)) {
            h.target = this.cv;
        }
        var i = new List$1(String_$type, 0);
        var j = this.xa();
        if (j != null) {
            try {
                for (var _b = __values(fromEnum(j.db())), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var k = _c.value;
                    if (k.isStacked) {
                        k.n6(function (l) {
                            i.add(l.dataLegendKey);
                            if (l.dw) {
                                l.n4(function (m) {
                                    i.add(m.dataLegendKey);
                                    return true;
                                });
                            }
                            return true;
                        });
                    }
                    else if (k.dw) {
                        i.add(k.dataLegendKey);
                        k.n4(function (l) {
                            i.add(l.dataLegendKey);
                            return true;
                        });
                    }
                    else {
                        i.add(k.dataLegendKey);
                    }
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
            h.includedSeries = i.toArray();
        }
        else {
            h.includedSeries = null;
        }
        this.acc(h);
        h.targetCursorPositionX = this.wz.x;
        h.targetCursorPositionY = this.wz.y;
        var l = this.xv.cq(g);
        var m = 0;
        var n = 0;
        var o = 0;
        var p = 0;
        var q = false;
        var r = false;
        o = d.x;
        p = d.y;
        var s = this.cg.bx;
        var t = this.xv.cr();
        var u = this.aeg();
        var v = this.aec(u, l, e, d);
        var w = v.x;
        var x = v.y;
        {
        }
        b.l.add(w);
        b.m.add(x);
        b.f.add(w);
        b.g.add(x);
        b.k.add(l.width);
        b.j.add(l.height);
        b.i.add1(g);
        var y = null;
        b.h.add(y);
        this.xv.b9.count = 1;
    };
    DataToolTipLayer.prototype.z0 = function (a) {
        return a.toolTip;
    };
    DataToolTipLayer.prototype.vz = function (a, b) {
        _super.prototype.vz.call(this, a, b);
        var c = a;
        var d = c.m.count;
        var e = b.bx.left;
        var f = b.bx.right;
        var g = b.bx.top;
        var h = b.bx.bottom;
        for (var i = 0; i < d; i++) {
            if (isNaN_(c.l._inner[i]) || isNaN_(c.m._inner[i]) || isNaN_(c.f._inner[i]) || isNaN_(c.g._inner[i])) {
                this.xv.ci(c.i._inner[i]);
                continue;
            }
            var j = c.f._inner[i];
            var k = c.g._inner[i];
            var l = c.k._inner[i];
            var m = c.j._inner[i];
            var n = false;
            if (n) {
                this.xv.ci(c.i._inner[i]);
                continue;
            }
            var o = c.i._inner[i];
            var p = Math.min(c.f._inner[i], c.l._inner[i]);
            var q = Math.min(c.g._inner[i], c.m._inner[i]);
            var r = c.l._inner[i] - c.f._inner[i];
            var s = c.m._inner[i] - c.g._inner[i];
            if (o != null) {
                this.xv.ck(o, p, q, r, s);
            }
        }
    };
    DataToolTipLayer.prototype.fn = function () {
        return true;
    };
    Object.defineProperty(DataToolTipLayer.prototype, "xk", {
        get: function () {
            return this.xj;
        },
        set: function (a) {
            var b = this.xj;
            this.xj = a;
            if (b != this.xj) {
                this.raisePropertyChanged("ActualGroupedPositionModeX", enumGetBox(DataTooltipGroupedPositionX_$type, b), enumGetBox(DataTooltipGroupedPositionX_$type, this.xj));
            }
        },
        enumerable: false,
        configurable: true
    });
    DataToolTipLayer.prototype.xm = function () {
        var e_7, _a;
        if (this.cv == null) {
            return 2;
        }
        var a = false;
        var b = false;
        var c = false;
        var d = false;
        var e = this.xa();
        if (e == null) {
            return 2;
        }
        try {
            for (var _b = __values(fromEnum(e.de)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var f = _c.value;
                if (f.ee) {
                    a = true;
                }
                if (f.isVertical) {
                    b = true;
                }
                if (f.e3) {
                    c = true;
                }
                if (f.fa) {
                    d = true;
                }
            }
        }
        catch (e_7_1) {
            e_7 = { error: e_7_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_7)
                    throw e_7.error;
            }
        }
        var g = ((function () {
            var $ret = new HashSet$1(DataTooltipGroupedPositionX_$type, 0);
            $ret.add_1(1);
            $ret.add_1(2);
            $ret.add_1(3);
            $ret.add_1(4);
            $ret.add_1(5);
            $ret.add_1(6);
            $ret.add_1(7);
            $ret.add_1(8);
            $ret.add_1(9);
            return $ret;
        })());
        var h = g.contains(this.xl);
        if (this.xl != 0) {
            if (h && b) {
                return 11;
            }
            return this.xl;
        }
        if (c || d) {
            return 11;
        }
        if (b) {
            return 11;
        }
        if (a) {
            return 8;
        }
        return 8;
    };
    Object.defineProperty(DataToolTipLayer.prototype, "xo", {
        get: function () {
            return this.xn;
        },
        set: function (a) {
            var b = this.xn;
            this.xn = a;
            if (b != this.xn) {
                this.raisePropertyChanged("ActualPositionModeY", enumGetBox(DataTooltipGroupedPositionY_$type, b), enumGetBox(DataTooltipGroupedPositionY_$type, this.xn));
            }
        },
        enumerable: false,
        configurable: true
    });
    DataToolTipLayer.prototype.xq = function () {
        var e_8, _a;
        if (this.cv == null) {
            return 11;
        }
        var a = false;
        var b = false;
        var c = false;
        var d = this.xa();
        if (d == null) {
            return 11;
        }
        try {
            for (var _b = __values(fromEnum(d.db())), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (e.isVertical) {
                    a = true;
                }
                if (e.e3) {
                    b = true;
                }
                if (e.fa) {
                    c = true;
                }
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        var f = ((function () {
            var $ret = new HashSet$1(DataTooltipGroupedPositionY_$type, 0);
            $ret.add_1(1);
            $ret.add_1(2);
            $ret.add_1(3);
            $ret.add_1(4);
            $ret.add_1(5);
            $ret.add_1(6);
            $ret.add_1(7);
            $ret.add_1(8);
            $ret.add_1(9);
            return $ret;
        })());
        var g = f.contains(this.xp);
        if (this.xp != 0) {
            if (g && !a) {
                return 11;
            }
            return this.xp;
        }
        if (b || c) {
            return 11;
        }
        if (a) {
            return 8;
        }
        if (!a) {
            return 11;
        }
        return 11;
    };
    Object.defineProperty(DataToolTipLayer.prototype, "yf", {
        get: function () {
            return this.x6;
        },
        set: function (a) {
            var b = this.x6;
            this.x6 = a;
            if (b != this.x6) {
                this.raisePropertyChanged("ValueTextStyle", b, this.x6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataToolTipLayer.prototype, "x7", {
        get: function () {
            return this.xy;
        },
        set: function (a) {
            var b = this.xy;
            this.xy = a;
            if (b != this.xy) {
                this.raisePropertyChanged("HeaderTextStyle", b, this.xy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataToolTipLayer.prototype, "ya", {
        get: function () {
            return this.x1;
        },
        set: function (a) {
            var b = this.x1;
            this.x1 = a;
            if (b != this.x1) {
                this.raisePropertyChanged("SummaryTitleTextStyle", b, this.x1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataToolTipLayer.prototype, "yc", {
        get: function () {
            return this.x3;
        },
        set: function (a) {
            var b = this.x3;
            this.x3 = a;
            if (b != this.x3) {
                this.raisePropertyChanged("SummaryValueTextStyle", b, this.x3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataToolTipLayer.prototype, "x9", {
        get: function () {
            return this.x0;
        },
        set: function (a) {
            var b = this.x0;
            this.x0 = a;
            if (b != this.x0) {
                this.raisePropertyChanged("SummaryLabelTextStyle", b, this.x0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataToolTipLayer.prototype, "yb", {
        get: function () {
            return this.x2;
        },
        set: function (a) {
            var b = this.x2;
            this.x2 = a;
            if (b != this.x2) {
                this.raisePropertyChanged("SummaryUnitsTextStyle", b, this.x2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataToolTipLayer.prototype, "ye", {
        get: function () {
            return this.x5;
        },
        set: function (a) {
            var b = this.x5;
            this.x5 = a;
            if (b != this.x5) {
                this.raisePropertyChanged("UnitsTextStyle", b, this.x5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataToolTipLayer.prototype, "yd", {
        get: function () {
            return this.x4;
        },
        set: function (a) {
            var b = this.x4;
            this.x4 = a;
            if (b != this.x4) {
                this.raisePropertyChanged("TitleTextStyle", b, this.x4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DataToolTipLayer.prototype, "x8", {
        get: function () {
            return this.xz;
        },
        set: function (a) {
            var b = this.xz;
            this.xz = a;
            if (b != this.xz) {
                this.raisePropertyChanged("LabelTextStyle", b, this.xz);
            }
        },
        enumerable: false,
        configurable: true
    });
    DataToolTipLayer.$t = markType(DataToolTipLayer, 'DataToolTipLayer', AnnotationLayer.$);
    DataToolTipLayer.$$p = markDep(DependencyProperty, PropertyMetadata, DataToolTipLayer, 'raisePropertyChanged', ['BadgeMargin:aei:acg', [Thickness.$, new Thickness(1, 0, 0, 0, 0)], 'BadgeShape:xx:ach', [LegendItemBadgeShape_$type, enumGetBox(LegendItemBadgeShape_$type, 0)], 'DefaultPositionOffsetX:yw:aci', [1, DeviceUtils.g(10)], 'DefaultPositionOffsetY:yx:acj', [1, DeviceUtils.g(10)], 'ExcludedColumns:w2:ack', [Array_$type, null], 'ExcludedSeries:w3:acl', [Array_$type, null], 'GroupedPositionModeX:xl:acm', [DataTooltipGroupedPositionX_$type, enumGetBox(DataTooltipGroupedPositionX_$type, 0)], 'GroupedPositionModeY:xp:acn', [DataTooltipGroupedPositionY_$type, enumGetBox(DataTooltipGroupedPositionY_$type, 0)], 'GroupingMode:xt:aco', [DataToolTipLayerGroupingMode_$type, enumGetBox(DataToolTipLayerGroupingMode_$type, 0)], 'HeaderFormatCulture:aad:acp', [2, stringEmpty()], 'HeaderFormatDate:xd:acq', [DataLegendHeaderDateMode_$type, enumGetBox(DataLegendHeaderDateMode_$type, 0)], 'HeaderFormatSpecifiers:w6:acr', [Array_$type, null], 'HeaderFormatString:aah:acs', [2, null], 'HeaderFormatTime:xe:act', [DataLegendHeaderTimeMode_$type, enumGetBox(DataLegendHeaderTimeMode_$type, 0)], 'HeaderRowMargin:aej:acu', [Thickness.$, new Thickness(0, 5)], 'HeaderRowVisible:yh:acv', [0, true], 'HeaderTextColor:ad3:acw', [Brush.$, null], 'HeaderTextMargin:aek:acx', [Thickness.$, new Thickness(1, 2, 0, 0, 0)], 'HeaderText:aam:acy', [2, null], 'IncludedColumns:w7:acz', [Array_$type, null], 'IncludedSeries:w8:ac0', [Array_$type, null], 'LabelDisplayMode:xf:ac1', [DataLegendLabelMode_$type, enumGetBox(DataLegendLabelMode_$type, 0)], 'LabelTextColor:ad4:ac2', [Brush.$, null], 'LabelTextMargin:ael:ac3', [Thickness.$, new Thickness(1, 8, 0, 0, 0)], 'PositionOffsetX:yy:ac4', [1, NaN], 'PositionOffsetY:yz:ac5', [1, NaN], 'ShouldUpdateWhenSeriesDataChanges:yo:ac6', [0, true], 'SummaryLabelTextColor:ad5:ac7', [Brush.$, null], 'SummaryLabelText:aa0:ac8', [2, null], 'SummaryRowMargin:aem:ac9', [Thickness.$, new Thickness(0, 5)], 'SummaryTitleTextColor:ad6:ada', [Brush.$, null], 'SummaryTitleTextMargin:aen:adb', [Thickness.$, new Thickness(1, 2, 0, 0, 0)], 'SummaryTitleText:aa5:adc', [2, null], 'SummaryType:xg:add', [DataLegendSummaryType_$type, enumGetBox(DataLegendSummaryType_$type, 0)], 'SummaryUnitsTextColor:ad7:ade', [Brush.$, null], 'SummaryUnitsText:abb:adf', [2, null], 'SummaryValueTextColor:ad8:adg', [Brush.$, null], 'TargetAxis:xb:adh', [Axis.$, null], 'TitleTextColor:ad9:adi', [Brush.$, null], 'TitleTextMargin:aeo:adj', [Thickness.$, new Thickness(1, 0, 0, 0, 0)], 'UnitsDisplayMode:xh:adk', [DataLegendUnitsMode_$type, enumGetBox(DataLegendUnitsMode_$type, 0)], 'UnitsTextColor:aea:adl', [Brush.$, null], 'UnitsTextMargin:aep:adm', [Thickness.$, new Thickness(1, 0, 0, 0, 0)], 'UnitsText:abm:adn', [2, null], 'UseInterpolation:yp:ado', [0, false], 'ValueFormatAbbreviation:xc:adp', [DataAbbreviationMode_$type, enumGetBox(DataAbbreviationMode_$type, 0)], 'ValueFormatCulture:abt:adq', [2, stringEmpty()], 'ValueFormatMaxFractions:zy:adr', [1, -1], 'ValueFormatMinFractions:zz:ads', [1, -1], 'ValueFormatMode:xi:adt', [DataLegendValueMode_$type, enumGetBox(DataLegendValueMode_$type, 0)], 'ValueFormatSpecifiers:w9:adu', [Array_$type, null], 'ValueFormatString:abz:adv', [2, null], 'ValueFormatUseGrouping:yq:adw', [0, true], 'ValueRowMargin:aeq:adx', [Thickness.$, new Thickness(0, 5)], 'ValueRowVisible:yr:ady', [0, true], 'ValueTextColor:aeb:adz', [Brush.$, null], 'ValueTextMargin:aer:ad0', [Thickness.$, new Thickness(1, 2, 0, 2, 0)], 'ValueTextUseSeriesColors:ys:ad1', [0, false], 'ValueTextWhenMissingData:ab8:ad2', [2, "N/A"]]);
    return DataToolTipLayer;
}(AnnotationLayer));
export { DataToolTipLayer };
/**
 * @hidden
 */
var DataToolTipLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DataToolTipLayerView, _super);
    function DataToolTipLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b9 = null;
        _this.cc = null;
        _this.b7 = null;
        _this.ca = false;
        _this._htmlTest = null;
        _this.b7 = a;
        _this.htmlTest = /^[^<]*(<[\w\W]+>)[^>]*$/;
        _this.cc = new List$1(PointerTooltip.$, 0);
        return _this;
    }
    DataToolTipLayerView.prototype.ak = function () {
        _super.prototype.ak.call(this);
        for (var a = 0; a < this.b9.a.count; a++) {
            this.b9.a._inner[a].br();
        }
        for (var b = 0; b < this.b9.b.count; b++) {
            this.b9.b._inner[b].br();
        }
        this.b9.clear();
    };
    DataToolTipLayerView.prototype.cd = function () {
        var a = new PointerTooltip();
        a.bw(this.e.i5);
        a._visibility = 1;
        a.ap = this.e.cv.cu.k;
        var b = null;
        if (TypeRegistrar.isRegistered("XamDataLegend")) {
            b = TypeRegistrar.create("XamDataLegend");
        }
        b.pixelScalingRatio = 1;
        if (this.e.cv != null) {
            var c = this.e.cv.cu.j.ae.createElement("div");
            var ren_ = this.e.cv.cu.j.ae.getSubRenderer(c);
            var len_ = b;
            len_.provideContainer(ren_);
        }
        a.ai = typeCast(IOnDemandRender_$type, b);
        a.ai.shouldOnDemandRender = true;
        this.cc.add(a);
        return a;
    };
    DataToolTipLayerView.prototype.cf = function (a) {
        var b = a;
    };
    DataToolTipLayerView.prototype.ch = function (a) {
        var b = a;
        b._visibility = 1;
    };
    DataToolTipLayerView.prototype.cg = function (a) {
        var b = a;
        b.bz();
        b.content = null;
        this.cc.remove1(a);
    };
    DataToolTipLayerView.prototype.au = function () {
        var _this = this;
        _super.prototype.au.call(this);
        this.b9 = ((function () {
            var $ret = new Pool$1(Base.$);
            $ret.create = runOn(_this, _this.cd);
            $ret.activate = runOn(_this, _this.cf);
            $ret.disactivate = runOn(_this, _this.ch);
            $ret.destroy = runOn(_this, _this.cg);
            return $ret;
        })());
    };
    Object.defineProperty(DataToolTipLayerView.prototype, "htmlTest", {
        get: function () {
            return this._htmlTest;
        },
        set: function (a) {
            this._htmlTest = a;
        },
        enumerable: false,
        configurable: true
    });
    DataToolTipLayerView.prototype.cb = function (a, b) {
        var c = a;
        var d = c.ai;
        return true;
    };
    DataToolTipLayerView.prototype.cq = function (a) {
        var b = a;
        var c = new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
        b.cy = 1;
        var d = b.cx(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        b.cy = 0;
        return d;
    };
    DataToolTipLayerView.prototype.cp = function () {
        if (this.e.cv != null) {
            var a = this.e.cv.tk();
            var b = this.e.cv.cu.a8;
            var c = this.e.cv.cu.a7;
            return new Rect(0, 0, 0, b, c);
        }
        return Rect.empty;
    };
    DataToolTipLayerView.prototype.co = function () {
        if (this.e.cv != null) {
            var a = this.e.cv.tk();
            var b = this.e.cv.cu.a8;
            var c = this.e.cv.cu.a7;
            return new Rect(0, 0, 0, b, c);
        }
        return Rect.empty;
    };
    DataToolTipLayerView.prototype.cn = function () {
        var a = 0;
        var b = 0;
        if (this.e.cv != null) {
            var c = this.e.cv.tk();
            a += c.x;
            b += c.y;
            var d = this.e.cv.cu.a8;
            var e = this.e.cv.cu.a7;
            return new Rect(0, a, b, d, e);
        }
        return Rect.empty;
    };
    DataToolTipLayerView.prototype.cm = function (a) {
        var b = 0;
        var c = 0;
        if (this.e.cv != null) {
            var d = this.e.cv.tk();
            b += d.x;
            c += d.y;
        }
        return { $type: Point_$type, x: b + a.x, y: c + a.y };
    };
    DataToolTipLayerView.prototype.ck = function (a, b, c, d, e) {
        var f = null;
        if (this.e.cv != null) {
            f = this.e.cv.cu.j.i();
        }
        var g = a;
        if (g == null) {
            return;
        }
        if (d == 0 && e == 0) {
            g.cy = 1;
        }
        else {
            g.cy = 0;
        }
        g.aq = f;
        g.cs = { $type: Point_$type, x: d, y: e };
        g._visibility = 0;
        g.n = b;
        g.o = c;
    };
    DataToolTipLayerView.prototype.cr = function () {
        var a = (window.innerWidth);
        var b = (window.innerHeight);
        return new Size(1, a, b);
    };
    DataToolTipLayerView.prototype.ci = function (a) {
        if (a != null) {
            var b = a;
            b._visibility = 1;
        }
    };
    DataToolTipLayerView.prototype.cl = function () {
        if (this.e.cv == null) {
            this.cj(true);
        }
    };
    DataToolTipLayerView.prototype.a8 = function (a, b) {
        _super.prototype.a8.call(this, a, b);
        if (b) {
            return;
        }
        var c = 0;
        var d = 0;
        var e = this.e.cv;
        if (e != null) {
            var f = e.cu.j.b8();
            c += f.x;
            d += f.y;
        }
        for (var g = 0; g < this.cc.count; g++) {
            this.cc._inner[g].by(this.cc._inner[g].n + c, this.cc._inner[g].o + d);
        }
    };
    DataToolTipLayerView.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
        for (var b = 0; b < this.cc.count; b++) {
            var c = this.cc._inner[b];
            var d = 0;
            var e = 0;
            if (this.e.cv != null) {
                var f = this.e.cv.tk();
                d += f.x;
                e += f.y;
            }
            var g = c.a5();
            var h = c.n - d;
            var i = c.o - e;
            var j = c.ai;
            var k = null;
            if (j != null) {
                k = j.exportVisualData();
            }
            this.e.a5.addPointerTooltipWithDataLegend(a, g, h, i, k);
        }
    };
    DataToolTipLayerView.prototype.b8 = function (a) {
        var b = a;
        return b.ai;
    };
    DataToolTipLayerView.prototype.cj = function (a) {
        this.as();
        for (var b = 0; b < this.cc.count; b++) {
            this.ci(this.cc._inner[b]);
            if (a) {
                this.cc._inner[b].bs();
            }
        }
    };
    DataToolTipLayerView.$t = markType(DataToolTipLayerView, 'DataToolTipLayerView', AnnotationLayerView.$);
    return DataToolTipLayerView;
}(AnnotationLayerView));
export { DataToolTipLayerView };
