import { Series } from "./Series";
import { Point, Type } from "igniteui-angular-core";
import { AnnotationAppearanceMode } from "./AnnotationAppearanceMode";
import { DoubleCollection } from "igniteui-angular-core";
import { Frame } from "./Frame";
import { SeriesView } from "./SeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { NotifyCollectionChangedEventArgs } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { Brush } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { Tuple$2 } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class AnnotationLayer extends Series {
    static $t: Type;
    constructor();
    protected cd(): SeriesView;
    o2(a: SeriesView): void;
    protected un(a: Series): boolean;
    protected uf: AnnotationLayerView;
    up: boolean;
    uq: boolean;
    w0: Point;
    uk: boolean;
    protected get_eg(): boolean;
    t6: AnnotationAppearanceMode;
    t3: AnnotationAppearanceMode;
    u3: number;
    us: number;
    ud: AnnotationAppearanceMode;
    t4: AnnotationAppearanceMode;
    ue: AnnotationAppearanceMode;
    t5: AnnotationAppearanceMode;
    u2: number;
    ur: number;
    u4: number;
    ut: number;
    wx: DoubleCollection;
    wr: DoubleCollection;
    wy: DoubleCollection;
    ws: DoubleCollection;
    protected bu(): SeriesHitTestMode;
    protected get_eu(): boolean;
    protected get_isUsableInLegend(): boolean;
    protected pa(a: any, b: string, c: any, d: any): void;
    protected w1: Point;
    private v3;
    private v2;
    private vy;
    private vx;
    protected ul(a: Axis): boolean;
    private vr;
    protected um(a: Series): boolean;
    private v1;
    protected vt(a: Axis, b: boolean): void;
    protected vu(a: Series, b: boolean): void;
    private v0;
    private vq;
    protected wp(): Brush;
    protected wq(): Brush;
    protected vs(a: NotifyCollectionChangedEventArgs): void;
    protected vv(a: NotifyCollectionChangedEventArgs): void;
    protected uh: Frame;
    protected ug: Frame;
    protected ui: Frame;
    protected qp(a: Rect, b: Rect): void;
    protected qo(a: Rect, b: Rect): void;
    ps(a: boolean): void;
    protected get_d7(): boolean;
    protected vw(a: Frame, b: SeriesView): void;
    protected vz(a: Frame, b: SeriesView): void;
    protected vp(a: Series): Tuple$2<boolean, Point>;
    protected os(a: Point): void;
    wz: Point;
    gm(a: Rect, b: Rect, c: SeriesView): boolean;
    protected u0(): number;
    protected uz(): number;
    protected u1(): number;
    protected ua(): AnnotationAppearanceMode;
    protected ub(): AnnotationAppearanceMode;
    protected uc(): AnnotationAppearanceMode;
    protected wv(): DoubleCollection;
    protected ww(): DoubleCollection;
    protected t7(): AnnotationAppearanceMode;
    protected t8(): AnnotationAppearanceMode;
    protected t9(): AnnotationAppearanceMode;
    protected uu(): number;
    protected ux(): number;
    protected uw(): number;
    protected uv(): number;
    protected uy(): number;
    protected wt(): DoubleCollection;
    protected wu(): DoubleCollection;
    protected v4(): void;
    protected get_gi(): boolean;
    private uj;
    get uo(): boolean;
    set uo(a: boolean);
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnnotationLayerView extends SeriesView {
    static $t: Type;
    constructor(a: AnnotationLayer);
    protected b0: AnnotationLayer;
    private b1;
    private b2;
    private b6;
    b3(): void;
    b5(): void;
    b4(): void;
}
