import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries } from "igniteui-angular-core";
import { ISupportsSizeScale } from "./ISupportsSizeScale";
import { ISupportsFillScale } from "./ISupportsFillScale";
import { Rect } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { Type } from "igniteui-angular-core";
import { ActualRange } from "./ActualRange";
import { Series } from "./Series";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { SeriesView } from "./SeriesView";
import { MarkerFillMode } from "./MarkerFillMode";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { BrushSelectionMode } from "./BrushSelectionMode";
import { MarkerManagerBase } from "./MarkerManagerBase";
/**
 * @hidden
 */
export declare class BubbleSeries extends ScatterBase implements IScaleLegendSeries, ISupportsSizeScale, ISupportsFillScale {
    static $t: Type;
    protected bc(): Series;
    protected get_dy(): boolean;
    protected cd(): SeriesView;
    o2(a: SeriesView): void;
    zj: BubbleSeriesView;
    protected ir(): number;
    t6(): MarkerFillMode;
    constructor();
    private aa9;
    private aa8;
    isAttachedTo(a: IChartLegend): boolean;
    protected dx(): boolean;
    protected n5(a: (arg1: any) => void): void;
    get zq(): IFastItemColumn$1<number>;
    zw: List$1<UIElement>;
    private aa7;
    get legendReady(): boolean;
    get minScaleText(): string;
    get maxScaleText(): string;
    forScaleColors(a: (arg1: Brush, arg2: number) => void): boolean;
    aal: string;
    jv(a: any, b: string): any;
    get zs(): IFastItemColumn$1<number>;
    set zs(a: IFastItemColumn$1<number>);
    private zo;
    zl: SizeScale;
    aab: string;
    private zn;
    get zr(): IFastItemColumn$1<any>;
    set zr(a: IFastItemColumn$1<any>);
    z6: string;
    zi: BrushScale;
    private zm;
    get zp(): IFastItemColumn$1<number>;
    set zp(a: IFastItemColumn$1<number>);
    zt: boolean;
    zu: boolean;
    z0: number;
    zz: number;
    zv: boolean;
    xy(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    x8(a: ScatterFrame, b: ScatterBaseView): void;
    private aaq;
    static zx(a: number, b: number, c: number, d: number, e: number): number;
    static zy(a: number, b: number, c: number, d: number, logBase_: number, e: number): number;
    gm(a: Rect, b: Rect, c: SeriesView): boolean;
    protected wm(a: string, b: FastItemsSourceEventAction): boolean;
    private aap;
    protected np(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    of(): void;
    ol(): void;
    protected pa(a: any, b: string, c: any, d: any): void;
    updateSizeScaleGlobals(): void;
    updateFillScaleGlobals(): void;
    zh(a: SizeScale): ActualRange;
    zg(): ActualRange;
    zk: SizeScale;
    aas(a: List$1<Marker>, b: List$1<number>, c: Rect, d: boolean): void;
    aar(a: List$1<Marker>): void;
    aah: string;
    z2: string;
    aaj: string;
    z4: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    get actualMarkerBrush(): Brush;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CustomPaletteBrushScale extends BrushScale {
    static $t: Type;
    constructor();
    brushSelectionMode: BrushSelectionMode;
    getBrush1(a: number, b: number): Brush;
    protected get_isReady(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class BubbleSeriesView extends ScatterBaseView {
    static $t: Type;
    protected di: BubbleSeries;
    constructor(a: BubbleSeries);
    au(): void;
    protected cx(): MarkerManagerBase;
    dk(): void;
    dl(): void;
    dj(): void;
    getDefaultTooltipTemplate(): string;
}
