import { AnnotationLayer } from "./AnnotationLayer";
import { Series } from "./Series";
import { CategoryItemHighlightType } from "./CategoryItemHighlightType";
import { MarkerType } from "./MarkerType";
import { Brush } from "igniteui-angular-core";
import { DataTemplate } from "igniteui-angular-core";
import { CategoryItemHighlightLayerFrame } from "./CategoryItemHighlightLayerFrame";
import { Type, Point } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { ItemHighlightFrameRect } from "./ItemHighlightFrameRect";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CategoryItemHighlightLayer extends AnnotationLayer {
    static $t: Type;
    protected bc(): Series;
    protected get_d6(): boolean;
    constructor();
    protected cd(): SeriesView;
    o2(a: SeriesView): void;
    protected w2: CategoryItemHighlightLayerView;
    w6: Series;
    xk: string;
    xa: boolean;
    w3: CategoryItemHighlightType;
    w5: MarkerType;
    x4: Brush;
    x5: Brush;
    xt: DataTemplate;
    xc: number;
    w9: boolean;
    protected vu(a: Series, b: boolean): void;
    protected un(a: Series): boolean;
    protected vw(a: Frame, b: SeriesView): void;
    private w8;
    private w7;
    protected pa(a: any, b: string, c: any, d: any): void;
    private xb;
    private xq;
    xo(a: Point, b: CategoryItemHighlightLayerFrame, c: Series): void;
    private w4;
    xp(a: Rect, b: CategoryItemHighlightLayerFrame, c: Series): void;
    protected vz(a: Frame, b: SeriesView): void;
    xr(a: ItemHighlightFrameRect, b: ContentControl): void;
    xs(a: ItemHighlightFrameRect, b: Rectangle): void;
    protected fn(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategoryItemHighlightLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CategoryItemHighlightLayer);
    protected b7: CategoryItemHighlightLayer;
    b9: Pool$1<Rectangle>;
    b8: Pool$1<ContentControl>;
    au(): void;
    protected ca: List$1<ContentControl>;
    protected cb: List$1<Rectangle>;
    private cn;
    private ch;
    private cj;
    private ci;
    private ck;
    private cc;
    private ce;
    private cd;
    cl(a: Brush): Brush;
    cm(a: Brush): Brush;
    cg(a: Rectangle, b: number, c: number, d: number, e: number): void;
    cf(a: ContentControl, b: number, c: number): void;
    protected bj(a: any, b: number): void;
    protected a8(a: RenderingContext, b: boolean): void;
    an(a: any): void;
}
