import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-angular-core";
import { Series } from "./Series";
import { Thickness } from "igniteui-angular-core";
import { Visibility } from "igniteui-angular-core";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Type } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { AnnotationAppearanceMode } from "./AnnotationAppearanceMode";
import { DoubleCollection } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CrosshairLayer extends AnnotationLayer {
    static $t: Type;
    protected bc(): Series;
    protected get_d6(): boolean;
    protected get_d4(): boolean;
    constructor();
    protected cd(): SeriesView;
    o2(a: SeriesView): void;
    protected w4: CrosshairLayerView;
    zh: Brush;
    zi: Brush;
    xv: string;
    w5: Series;
    xa: boolean;
    w8: boolean;
    xAxisAnnotationFormatLabel: (item: any) => string;
    w6(): boolean;
    yAxisAnnotationFormatLabel: (item: any) => string;
    w7(): boolean;
    zl: Brush;
    zj: Brush;
    xd: number;
    xp: number;
    zk: Brush;
    get zr(): Thickness;
    xf: number;
    xh: number;
    xg: number;
    xe: number;
    get zs(): Thickness;
    xl: number;
    xn: number;
    xm: number;
    xk: number;
    xi: number;
    zo: Brush;
    zm: Brush;
    xj: number;
    xq: number;
    zn: Brush;
    xo: number;
    zu: Visibility;
    zt: Visibility;
    w9: boolean;
    protected vu(a: Series, b: boolean): void;
    protected vw(a: Frame, b: SeriesView): void;
    protected un(a: Series): boolean;
    oq(): void;
    protected t7(): AnnotationAppearanceMode;
    protected uu(): number;
    protected ux(): number;
    protected uw(): number;
    protected wt(): DoubleCollection;
    protected wu(): DoubleCollection;
    private zp;
    private zq;
    private ym;
    private xc;
    private xb;
    protected yn(a: CrosshairLayerFrame, b: boolean): void;
    private yl;
    protected vz(a: Frame, b: SeriesView): void;
    protected fn(): boolean;
    protected pa(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CrosshairLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CrosshairLayer);
    protected b7: CrosshairLayer;
    b8: Pool$1<Path>;
    protected b9: List$1<Path>;
    au(): void;
    private ch;
    private ca;
    private cc;
    private cb;
    cd(a: Path, b: number, c: number, d: number): void;
    ce(a: Brush, b: number): Brush;
    cg(a: Brush, b: number): Brush;
    cf(a: Brush, b: number): Brush;
    protected a8(a: RenderingContext, b: boolean): void;
    an(a: any): void;
}
