import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type, IList$1 } from "igniteui-angular-core";
import { FinancialEventArgs } from "./FinancialEventArgs";
import { Series } from "./Series";
/**
 * @hidden
 */
export declare class CustomIndicator extends StrategyBasedIndicator {
    static $t: Type;
    protected bc(): Series;
    protected get_y0(): IndicatorCalculationStrategy;
    protected get y0(): IndicatorCalculationStrategy;
    protected get_zd(): Type;
    protected get zd(): Type;
    protected yc(a: number, b: number): IList$1<string>;
    private zm;
    get indicator(): (sender: any, e: FinancialEventArgs) => void;
    set indicator(a: (sender: any, e: FinancialEventArgs) => void);
    private zl;
    get basedOnColumns(): (sender: any, e: FinancialEventArgs) => void;
    set basedOnColumns(a: (sender: any, e: FinancialEventArgs) => void);
    protected x9(a: number, b: number): boolean;
}
