import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { Series } from "./Series";
/**
 * @hidden
 */
export declare class FullStochasticOscillatorIndicator extends StrategyBasedIndicator {
    static $t: Type;
    protected bc(): Series;
    constructor();
    protected get_y0(): IndicatorCalculationStrategy;
    protected get y0(): IndicatorCalculationStrategy;
    protected get_zd(): Type;
    protected get zd(): Type;
    get zl(): number;
    set zl(a: number);
    static readonly zq: DependencyProperty;
    protected y6(): number;
    zf(a: number): void;
    get smoothingPeriod(): number;
    set smoothingPeriod(a: number);
    static readonly zr: DependencyProperty;
    protected y8(): number;
    get zn(): number;
    set zn(a: number);
    static readonly zs: DependencyProperty;
    protected y5(): number;
    protected yg(): number;
}
