import { ScatterTriangulationSeries } from "./ScatterTriangulationSeries";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Type, Point } from "igniteui-angular-core";
import { Series } from "./Series";
import { ValueBrushScale } from "./ValueBrushScale";
import { ContourValueResolver } from "./ContourValueResolver";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { RenderSurface } from "./RenderSurface";
import { DataContext } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class ScatterContourSeries extends ScatterTriangulationSeries {
    static $t: Type;
    protected bc(): Series;
    protected get_ex(): boolean;
    constructor();
    jv(a: any, b: string): any;
    private vy;
    protected cd(): SeriesView;
    wa: string;
    private v1;
    get v2(): IFastItemColumn$1<number>;
    set v2(a: IFastItemColumn$1<number>);
    v6: string;
    v8: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    protected pa(a: any, b: string, c: any, d: any): void;
    nk(a: boolean, b: SeriesView): void;
    ps(a: boolean): void;
    pq(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    protected wd(a: SeriesView): void;
    v0: ValueBrushScale;
    vz: ValueBrushScale;
    protected qf(): void;
    private we;
    private vw;
    get vx(): ContourValueResolver;
    set vx(a: ContourValueResolver);
    private wf;
    gm(a: Rect, b: Rect, c: SeriesView): boolean;
    au(a: Point, b: boolean): DataContext;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterContourSeriesView extends SeriesView {
    static $t: Type;
    private b2;
    private b1;
    constructor(a: ScatterContourSeries);
    protected b4: List$1<Path>;
    private cb;
    private b7;
    private b8;
    private b9;
    private b3;
    private b0;
    b5(a: List$1<List$1<List$1<Point>>>, b: number[]): void;
    protected bg(a: any, b: number): void;
    protected bh(a: any, b: number): void;
    protected a8(a: RenderingContext, b: boolean): void;
    b6(a: boolean): void;
    an(a: any): void;
    getDefaultTooltipTemplate(): string;
    ca(a: Point, b: boolean): Path;
}
