import { Series } from "./Series";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { IEnumerable, Type } from "igniteui-angular-core";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemsSource } from "igniteui-angular-core";
import { TriangulationStatusEventArgs } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { Rect } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
/**
 * @hidden
 */
export declare abstract class ScatterTriangulationSeries extends Series {
    static $t: Type;
    nh(): void;
    u5: string;
    jv(a: any, b: string): any;
    vd: string;
    private ua;
    protected get ug(): IFastItemColumn$1<number>;
    protected set ug(a: IFastItemColumn$1<number>);
    private ub;
    protected get uh(): IFastItemColumn$1<number>;
    protected set uh(a: IFastItemColumn$1<number>);
    t3: NumericXAxis;
    t4: NumericYAxis;
    private uj;
    ps(a: boolean): void;
    private vh;
    private vf;
    private t6;
    triangulationStatusChanged: (sender: any, args: TriangulationStatusEventArgs) => void;
    private vi;
    protected uc(a: IFastItemsSource, b: string): IFastItemColumn$1<number>;
    protected pa(a: any, b: string, c: any, d: any): void;
    ul(a: any): boolean;
    uk(a: any): boolean;
    gm(a: Rect, b: Rect, c: SeriesView): boolean;
    private vg;
    private um;
    oc(): void;
    protected np(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    aq(a: Axis): AxisRange;
    protected qp(a: Rect, b: Rect): void;
    protected qo(a: Rect, b: Rect): void;
    trianglesSource: IEnumerable;
    ui: IFastItemsSource;
    ut: string;
    uv: string;
    ux: string;
    private t7;
    protected get ud(): IFastItemColumn$1<number>;
    protected set ud(a: IFastItemColumn$1<number>);
    private t8;
    protected get ue(): IFastItemColumn$1<number>;
    protected set ue(a: IFastItemColumn$1<number>);
    private t9;
    protected get uf(): IFastItemColumn$1<number>;
    protected set uf(a: IFastItemColumn$1<number>);
    protected get_fb(): boolean;
    protected get_ez(): boolean;
    u1: string;
    u9: string;
    u3: string;
    vb: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    static $$p: string[];
}
