import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { SplineType } from "./SplineType";
import { SeriesView } from "./SeriesView";
import { AxisRange } from "./AxisRange";
import { Axis } from "./Axis";
import { Point, IList$1, Type } from "igniteui-angular-core";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CollisionAvoider } from "./CollisionAvoider";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { NumericAxisBase } from "./NumericAxisBase";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class SplineSeriesBase extends HorizontalAnchoredCategorySeries {
    static $t: Type;
    protected iq(): number;
    protected cd(): SeriesView;
    o2(a: SeriesView): void;
    p2(a: boolean): void;
    zj: SplineSeriesBaseView;
    zl: boolean;
    aq(a: Axis): AxisRange;
    protected get_ea(): boolean;
    zg(a: CategorySeriesView): number[][];
    zh(a: CategorySeriesView): number[][];
    protected zi: number[];
    zw(a: CategoryFrame, b: Rect, c: Rect, d: CategoryAxisBase, e: NumericAxisBase, f: CategorySeriesView): void;
    zm(a: CategoryFrame, b: number[], c: CollisionAvoider, d: number, e: number, f: CategorySeriesView, g: number): boolean;
    aj(a: CategoryAxisBase, b: List$1<number[]>, c: number, d: number, e: Point, f: boolean): number[][];
    w4(a: CategoryFrame, b: CategorySeriesView): void;
    zv(a: CategorySeriesView): void;
    private zp;
    h0(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    zq(a: CategoryAxisBase, b: Rect, c: Rect, d: Rect): number;
    private zo;
    protected get zs(): number;
    protected set zs(a: number);
    private zn;
    protected get zr(): number;
    protected set zr(a: number);
    zk: SplineType;
    protected zx(): void;
    protected pa(a: any, b: string, c: any, d: any): void;
    protected np(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class SplineSeriesBaseView extends AnchoredCategorySeriesView {
    static $t: Type;
    protected dd: SplineSeriesBase;
    constructor(a: SplineSeriesBase);
    de(): number;
    protected af(): void;
}
