/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { CustomIndicatorStrategy } from "./CustomIndicatorStrategy";
import { String_$type, fromEnum, markType } from "igniteui-angular-core";
import { FinancialEventArgs } from "./FinancialEventArgs";
import { List$1 } from "igniteui-angular-core";
/**
 * @hidden
 */
export let CustomIndicator = /*@__PURE__*/ (() => {
    class CustomIndicator extends StrategyBasedIndicator {
        constructor() {
            super(...arguments);
            this.zm = null;
            this.zl = null;
        }
        bc() {
            return new CustomIndicator();
        }
        get_y0() {
            return new CustomIndicatorStrategy();
        }
        get y0() {
            return this.get_y0();
        }
        get_zd() {
            return CustomIndicator.$;
        }
        get zd() {
            return this.get_zd();
        }
        yc(a, b) {
            let c = this.uo(a, b);
            let d = this.up(c);
            let e = new List$1(String_$type, 0);
            if (this.basedOnColumns != null) {
                let f = new FinancialEventArgs(c.calculateFrom, c.calculateCount, c, d, this);
                this.basedOnColumns(this, f);
                if (f.basedOn != null) {
                    for (let g of fromEnum(f.basedOn)) {
                        e.add(g);
                    }
                }
            }
            return e;
        }
        get indicator() {
            return this.zm;
        }
        set indicator(a) {
            this.zm = a;
            this.yk();
        }
        get basedOnColumns() {
            return this.zl;
        }
        set basedOnColumns(a) {
            this.zl = a;
        }
        x9(a, b) {
            super.x9(a, b);
            if (this.indicator != null) {
                let c = this.uo(a, b);
                if (b == 0) {
                    return false;
                }
                if (!this.vk(this.yc(a, b))) {
                    return false;
                }
                this.indicator(this, new FinancialEventArgs(a, b, c, this.up(c), this));
                if (this.y2(c) && this.uu != null) {
                    this.uu.c1();
                }
                return true;
            }
            return false;
        }
    }
    CustomIndicator.$t = markType(CustomIndicator, 'CustomIndicator', StrategyBasedIndicator.$);
    return CustomIndicator;
})();
