/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-angular-core";
import { IFinancialPriceSeriesProxy_$type } from "./IFinancialPriceSeriesProxy";
/**
 * @hidden
 */
export let FinancialPriceSeriesProxy = /*@__PURE__*/ (() => {
    class FinancialPriceSeriesProxy extends Base {
        getCloseMemberPath(a) {
            return a.wf;
        }
        getHighMemberPath(a) {
            return a.ws;
        }
        getLowMemberPath(a) {
            return a.wx;
        }
        getOpenMemberPath(a) {
            return a.w1;
        }
        getVolumeMemberPath(a) {
            return a.w5;
        }
        matchesType(a) {
            if (!a.el) {
                return false;
            }
            if (a.em || a.en) {
                return false;
            }
            return true;
        }
        setCategoryMode(a, b) {
            a.uj = b;
        }
        setCloseMemberPath(a, b) {
            a.wf = b;
        }
        setDisplayType(a, b) {
            a.x7 = b;
        }
        setHighMemberPath(a, b) {
            a.ws = b;
        }
        setLowMemberPath(a, b) {
            a.wx = b;
        }
        setOpenMemberPath(a, b) {
            a.w1 = b;
        }
        setVolumeMemberPath(a, b) {
            a.w5 = b;
        }
        setXAxis(a, b) {
            a.ub = b;
        }
        setYAxis(a, b) {
            a.uu = b;
        }
        setTrendLineType(a, b) {
            if (a.eo) {
                a.trendLineType = b;
            }
        }
    }
    FinancialPriceSeriesProxy.$t = markType(FinancialPriceSeriesProxy, 'FinancialPriceSeriesProxy', Base.$, [IFinancialPriceSeriesProxy_$type]);
    return FinancialPriceSeriesProxy;
})();
