/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { PolarBase } from "./PolarBase";
import { markType } from "igniteui-angular-core";
import { PolarBaseView } from "./PolarBaseView";
import { Defaults } from "./Defaults";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
export let PolarScatterSeries = /*@__PURE__*/ (() => {
    class PolarScatterSeries extends PolarBase {
        constructor() {
            super();
            this.ab = PolarScatterSeries.$;
        }
        bc() {
            return new PolarScatterSeries();
        }
        get_dy() {
            return true;
        }
        cd() {
            return new PolarScatterSeriesView(this);
        }
        o2(a) {
            super.o2(a);
            this.za = a;
        }
        ir() {
            return 0.7;
        }
        t6() {
            if (this.t5 == 0) {
                return 2;
            }
            return super.t6();
        }
    }
    PolarScatterSeries.$t = markType(PolarScatterSeries, 'PolarScatterSeries', PolarBase.$);
    return PolarScatterSeries;
})();
/**
 * @hidden
 */
export let PolarScatterSeriesView = /*@__PURE__*/ (() => {
    class PolarScatterSeriesView extends PolarBaseView {
        constructor(a) {
            super(a);
            this.c6 = null;
            this.c6 = a;
        }
        au() {
            super.au();
            if (!this.q) {
                this.c6.uc = Defaults.e;
            }
        }
        af() {
            let a = new Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.s8 = a;
            this.e.is = 3;
            this.e.it = 2;
            this.e.iu = 2;
            this.e.gk = false;
        }
    }
    PolarScatterSeriesView.$t = markType(PolarScatterSeriesView, 'PolarScatterSeriesView', PolarBaseView.$);
    return PolarScatterSeriesView;
})();
