/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-angular-core";
import { HighlightingInfo } from "igniteui-angular-core";
import { ShapeItemSearchMode_$type } from "./ShapeItemSearchMode";
import { IEnumerable$1_$type, enumGetBox, Number_$type, Point_$type, String_$type, typeCast, runOn, delegateCombine, fromEnum, Array_$type, markType, markDep } from "igniteui-angular-core";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { StyleShapeEventArgs } from "./StyleShapeEventArgs";
import { FrameworkElement } from "igniteui-angular-core";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { Tuple$2 } from "igniteui-angular-core";
import { ShapeHitRegion } from "./ShapeHitRegion";
import { RectUtil } from "igniteui-angular-core";
import { Tuple$3 } from "igniteui-angular-core";
import { GeometryUtil } from "igniteui-angular-core";
import { AssigningShapeStyleEventArgs } from "./AssigningShapeStyleEventArgs";
import { AssigningShapeMarkerStyleEventArgs } from "./AssigningShapeMarkerStyleEventArgs";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { PointCollectionUtil } from "igniteui-angular-core";
import { FlattenedShape } from "./FlattenedShape";
import { SeriesView } from "./SeriesView";
import { Clipper } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { Dictionary$2 } from "igniteui-angular-core";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { PolySimplification } from "igniteui-angular-core";
import { DefaultFlattener } from "./DefaultFlattener";
import { AxisRange } from "./AxisRange";
import { Style } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { boxArray$1 } from "igniteui-angular-core";
import { InvalidOperationException } from "igniteui-angular-core";
import { isNaN_, truncate } from "igniteui-angular-core";
import { FastItemObjectColumn } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { PointCollection } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { PolyLineSegment } from "igniteui-angular-core";
import { PathFigure } from "igniteui-angular-core";
import { PolygonUtil } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ShapeSeriesBase = /*@__PURE__*/ (() => {
    class ShapeSeriesBase extends Series {
        constructor() {
            super();
            this.uw = false;
            this.uv = false;
            this.ur = null;
            this.us = null;
            this.ui = 1;
            this.t7 = null;
            this.t8 = null;
            this.assigningShapeStyle = null;
            this.assigningShapeMarkerStyle = null;
            this.um = null;
            this.ut = null;
            this.ue = null;
            this.ug = null;
            this.vg = 0;
            this.vc = null;
            this.t4 = null;
            this.t6 = null;
            this.t5 = null;
            this.t3 = null;
            this.wr = null;
            this.vj = 0;
            this.styleShape = null;
            this.um = new ShapeSeriesRenderManager();
            FastItemObjectColumn.m();
            this.vj = this.vi;
            this.wr = Rect.empty;
        }
        nh() {
            super.nh();
            this.uf = null;
            this.uh = null;
        }
        ag() {
            return [this.uf, this.uh];
        }
        jv(a, b) {
            let c = this.lw(b);
            if (c == ShapeSeriesBase.$$p[6]) {
                return this.jw(a, b, this.vy);
            }
            return null;
        }
        get_et() {
            return true;
        }
        get_dv() {
            return true;
        }
        up(a, b, c) {
            let d = this.te(b);
            let e = this.un.c2(d, false);
            let f = -1;
            if (e == null) {
                if (a != null) {
                    f = this.c7.indexOf(a);
                }
                else {
                    return null;
                }
            }
            else if (e.dataContext != null) {
                f = e.dataContext.c;
            }
            if (f == -1) {
                return null;
            }
            let g = new HighlightingInfo();
            g.i = this;
            g.g = f;
            g.f = f;
            g.c = false;
            if (c != null && c.g == g.g && c.f == g.f) {
                return c;
            }
            return g;
        }
        uq(a, b, c) {
            let d = this.un.b4(this.te(b));
            let e = -1;
            if (d == null) {
                if (a != null) {
                    e = this.c7.indexOf(a);
                }
                else {
                    return null;
                }
            }
            else {
                e = d.ak;
            }
            if (e == -1) {
                return null;
            }
            let f = new HighlightingInfo();
            f.i = this;
            f.g = e;
            f.f = e;
            f.c = false;
            f.d = true;
            if (c != null && c.g == f.g && c.f == f.f) {
                return c;
            }
            return f;
        }
        get uj() {
            return this.ui;
        }
        set uj(a) {
            let b = this.ui;
            this.ui = a;
            if (b != this.ui) {
                this.raisePropertyChanged("ActualItemSearchMode", enumGetBox(ShapeItemSearchMode_$type, b), enumGetBox(ShapeItemSearchMode_$type, this.ui));
            }
        }
        uk() {
            if (this.ul != 0) {
                return this.ul;
            }
            return 1;
        }
        hw(a) {
            switch (this.uj) {
                case 1: return this.v4(a).c;
                case 2: return this.vh(a);
                case 3: return this.vh(a);
            }
            return -1;
        }
        v4(a) {
            let b = this.te(a);
            let c = { $type: Point_$type, x: NaN, y: NaN };
            let d = this.un.ce;
            if (d == null) {
                return new Tuple$2(Number_$type, Point_$type, -1, c);
            }
            let e = this.un.b5(b, false, !this.ux);
            if (e != null) {
                c = RectUtil.l(e.d);
                return new Tuple$2(Number_$type, Point_$type, e.b, c);
            }
            let f = b.x;
            let g = b.y;
            if (this.c7 == null || this.uf == null || this.uh == null || this.vc == null) {
                return new Tuple$2(Number_$type, Point_$type, -1, c);
            }
            if (this.c7.count > this.vm) {
                return new Tuple$2(Number_$type, Point_$type, -1, c);
            }
            let h = 1.7976931348623157E+308;
            let i = -1;
            for (let j = 0; j < d.count; j++) {
                let k = d._inner[j].d;
                let l = RectUtil.g(k, b);
                if (l < h) {
                    h = l;
                    i = d._inner[j].b;
                    c = RectUtil.l(d._inner[j].d);
                }
            }
            return new Tuple$2(Number_$type, Point_$type, i, c);
        }
        v3(a) {
            let b = this.te(a);
            let c = b.x;
            let d = b.y;
            let e = { $type: Point_$type, x: NaN, y: NaN };
            if (this.c7 == null || this.uf == null || this.uh == null || this.vc == null) {
                return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
            }
            if (this.c7.count > this.vm) {
                return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
            }
            let f = 1.7976931348623157E+308;
            let g = this.un.ce;
            if (g == null) {
                return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
            }
            let h = this.un.b5(b, false, !this.ux);
            if (h != null) {
                let i = RectUtil.l(h.d);
                let j = this.v2(b, h.a, this.ux);
                return new Tuple$3(Number_$type, Point_$type, Point_$type, h.b, j.d, i);
            }
            for (let k = 0; k < g.count; k++) {
                let l = g._inner[k].d;
                let m = RectUtil.g(l, b);
                let n = (l.width * l.width) + (l.height * l.height) + m;
                if (n <= f) {
                    f = n;
                }
            }
            let o = 1.7976931348623157E+308;
            let p = -1;
            for (let q = 0; q < g.count; q++) {
                let r = g._inner[q].d;
                let s = RectUtil.g(r, b);
                if (s < f) {
                    let t = this.v2(b, g._inner[q].a, this.ux);
                    if (t.c < o) {
                        o = t.c;
                        e = t.d;
                        p = q;
                    }
                }
            }
            if (p >= 0) {
                return new Tuple$3(Number_$type, Point_$type, Point_$type, g._inner[p].b, e, RectUtil.l(g._inner[p].d));
            }
            return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
        }
        get_ux() {
            return true;
        }
        get ux() {
            return this.get_ux();
        }
        v2(a, b, c) {
            let d = { $type: Point_$type, x: NaN, y: NaN };
            let e = 1.7976931348623157E+308;
            let f = { $type: Point_$type, x: NaN, y: NaN };
            let g = false;
            let h = -1;
            for (let i = 0; i < b.count; i++) {
                let j = b._inner[i];
                if (i >= 1) {
                    let k = GeometryUtil.d(a, d, j);
                    if (k < e) {
                        e = k;
                        g = true;
                        h = i;
                    }
                }
                d = j;
            }
            if (c) {
                let l = b._inner[0];
                let m = GeometryUtil.d(a, d, l);
                if (m < e) {
                    e = m;
                    let n = GeometryUtil.i(a, d, l);
                    f = { $type: Point_$type, x: d.x + (l.x - d.x) * n, y: d.y + (l.y - d.y) * n };
                    return new Tuple$2(Number_$type, Point_$type, e, f);
                }
            }
            if (g) {
                let o = b._inner[h - 1];
                let p = b._inner[h];
                let q = GeometryUtil.i(a, o, p);
                f = { $type: Point_$type, x: o.x + (p.x - o.x) * q, y: o.y + (p.y - o.y) * q };
            }
            return new Tuple$2(Number_$type, Point_$type, e, f);
        }
        vh(a) {
            return this.v3(a).c;
        }
        tj(a, b, c) {
            if (this.uf == null || this.uh == null || this.vc == null) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            switch (this.uj) {
                case 1:
                    let d = this.v4(a);
                    return d.d;
                case 2:
                    let e = this.v3(a);
                    return e.e;
                case 3:
                    let f = this.v3(a);
                    return f.d;
            }
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        js(a) {
            let b = this.i9(a);
            if (this.c7 != null && b >= 0 && b < this.c7.count) {
                return this.c7.item(b);
            }
            return null;
        }
        uo(a, b, c) {
            let d = new HighlightingInfo();
            d.i = this;
            d.g = 0;
            d.f = this.c7.count - 1;
            d.c = true;
            if (c != null && c.g == d.g && c.f == d.f) {
                return c;
            }
            return d;
        }
        c0(a, b, c) {
            if (this.dv && this.fd(this.bp) && !c) {
                let d = this.up(a, b, this.ur);
                this.ur = d;
                return d;
            }
            else {
                let e = this.uo(a, b, this.ur);
                this.ur = e;
                return e;
            }
        }
        c1(a, b, c) {
            if (this.fd(this.bp) && !c) {
                let d = this.uq(a, b, this.us);
                this.us = d;
                return d;
            }
            else {
                let e = this.uo(a, b, this.us);
                e.d = true;
                this.us = e;
                return e;
            }
        }
        va() {
            return (this.assigningShapeStyle != null && this.uw) || (this.bp != 1);
        }
        u9() {
            return (this.assigningShapeMarkerStyle != null && this.uv) || (this.bp != 1);
        }
        get vp() {
            return this.c(ShapeSeriesBase.wh);
        }
        set vp(a) {
            this.h(ShapeSeriesBase.wh, a);
        }
        fo() {
            return this.highlightedItemsSource != null || this.vp != null;
        }
        g1() {
            let a = super.g1();
            {
                let b = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.ad = "ShapeMemberPath";
                    $ret.p = true;
                    $ret.y = "HighlightedShapeMemberPath";
                    $ret.q = true;
                    return $ret;
                })());
                b.valueResolving = delegateCombine(b.valueResolving, runOn(this, this.v6));
                a.add(b);
            }
            {
                let c = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "Brush";
                    $ret.p = true;
                    $ret.y = "ActualBrush";
                    $ret.q = true;
                    return $ret;
                })());
                c.valueResolving = delegateCombine(c.valueResolving, runOn(this, this.pz));
                a.add(c);
            }
            {
                let d = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "Outline";
                    $ret.p = true;
                    $ret.y = "ActualOutline";
                    $ret.q = true;
                    return $ret;
                })());
                d.valueResolving = delegateCombine(d.valueResolving, runOn(this, this.pz));
                a.add(d);
            }
            return a;
        }
        v6(a, b) {
            if (this.vp != null) {
                b.value = this.vp;
                return;
            }
            b.value = this.vy;
        }
        get uu() {
            return this.ut;
        }
        set uu(a) {
            let b = this.uu != a;
            if (b) {
                let c = this.uu;
                this.ut = a;
                this.raisePropertyChanged("ShapeColumn", c, this.uu);
            }
        }
        u1(array_) {
            let a = (Array.isArray(array_));
            return a;
        }
        static u5(a) {
            if (a == null) {
                return true;
            }
            let val_ = a;
            return (val_ == undefined);
        }
        convertToListList(a) {
            if (a == null) {
                return null;
            }
            let b = new List$1(List$1.$.specialize(Point_$type), 0);
            let c;
            let curr_;
            let d;
            let e;
            let f = false;
            let g = false;
            for (let h = 0; h < a.length; h++) {
                c = a[h];
                if (c == null) {
                    continue;
                }
                let i = new List$1(Point_$type, 0);
                for (let j = 0; j < c.length; j++) {
                    curr_ = c[j];
                    if (f) {
                        d = (curr_.X);
                        e = (curr_.Y);
                    }
                    else {
                        d = (curr_.x);
                        e = (curr_.y);
                    }
                    if (!g) {
                        if ((isNaN_(d) || ShapeSeriesBase.u5(d)) && (isNaN_(e) || ShapeSeriesBase.u5(e))) {
                            d = (curr_.X);
                            e = (curr_.Y);
                            if (!isNaN_(d) && !ShapeSeriesBase.u5(d) && !isNaN_(e) && !ShapeSeriesBase.u5(e)) {
                                g = true;
                                f = true;
                            }
                        }
                        else {
                            g = true;
                        }
                    }
                    i.add({ $type: Point_$type, x: d, y: e });
                }
                b.add(i);
            }
            return b;
        }
        c6(a) {
            if (this.c7 != null && this.u1(this.itemsSource) && a != null && a.split('!').length != 2) {
                if (this.coercionMethods == null) {
                    this.coercionMethods = {};
                }
                let methods_ = this.coercionMethods;
                methods_.convertToListList = this.convertToListList;
                a += "!convertToListList";
            }
            return super.c6(a);
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            let e = false;
            let f = false;
            switch (b) {
                case ShapeSeriesBase.$$p[2]:
                    this.uj = this.uk();
                    break;
                case "FastItemsSource":
                    let g = typeCast(IFastItemsSource_$type, c);
                    if (g != null) {
                        g.deregisterColumn(this.uu);
                        this.uu = null;
                    }
                    let h = typeCast(IFastItemsSource_$type, d);
                    if (h != null) {
                        this.uu = this.c6(this.vy);
                    }
                    e = this.uf != null && !this.uf.c1();
                    f = this.uh != null && !this.uh.c1();
                    if (e || f) {
                        this.pr(this.fr && c != null);
                    }
                    break;
                case ShapeSeriesBase.$$p[6]:
                    if (this.c7 != null) {
                        this.c7.deregisterColumn(this.uu);
                        this.uu = this.c6(this.vy);
                    }
                    break;
                case "ShapeColumn":
                    this.we();
                    e = this.uf != null && !this.uf.c1();
                    f = this.uh != null && !this.uh.c1();
                    if (e || f) {
                        this.pr(this.fr && this.dp);
                    }
                    this.om();
                    break;
                case ShapeSeriesBase.$$p[7]:
                case ShapeSeriesBase.$$p[8]:
                    this.ue = this.uf;
                    this.ug = this.uh;
                    let i = c;
                    let j = d;
                    this.wf(i);
                    this.v7(j);
                    if ((j != null && !j.c1()) || (j == null && i != null)) {
                        this.pr(false);
                    }
                    this.om();
                    break;
                case "ActualResolution":
                    this.vg = this.hk;
                    this.om();
                    break;
                case "ActualBrush":
                    this.pr(false);
                    break;
                case ShapeSeriesBase.$$p[5]:
                    this.vj = this.vi;
                    this.pr(false);
                    this.om();
                    break;
                case "ActualThickness":
                    this.pr(false);
                    this.om();
                    break;
                case ShapeSeriesBase.$$p[1]:
                    this.uw = this.u8();
                    this.pr(false);
                    break;
                case ShapeSeriesBase.$$p[0]:
                    this.uv = this.u7();
                    this.pr(false);
                    break;
            }
        }
        u8() {
            return this.u4;
        }
        u7() {
            return this.u3;
        }
        uz(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        uy(a) {
            if (typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        we() {
            this.vc = null;
            if (this.uu == null) {
                return;
            }
            this.vc = new List$1(Rect.$, 2, this.uu.count);
            for (let a = 0; a < this.uu.count; a++) {
                this.vc.add(PointCollectionUtil.j(this.uu.item(a)));
            }
        }
        ws(a) {
            if (typeCast(IEnumerable$1_$type.specialize(IEnumerable$1_$type.specialize(Point_$type)), a) !== null) {
                return PointCollectionUtil.h(a);
            }
            else if (typeCast(IEnumerable$1_$type.specialize(Point_$type), a) !== null) {
                return PointCollectionUtil.g(a);
            }
            return Rect.empty;
        }
        ve(a, b, c, d, e, f, g) {
            return this.vf(a, b, c, d, e, f, g);
            if (typeCast(List$1.$.specialize(List$1.$.specialize(Point_$type)), c) !== null) {
                return this.vf(a, b, c, d, e, f, g);
            }
            else if (typeCast(IEnumerable$1_$type.specialize(IEnumerable$1_$type.specialize(Point_$type)), c) !== null) {
                let h = c;
                let i = new List$1(FlattenedShape.$, 0);
                let j = null;
                for (let k of fromEnum(h)) {
                    j = this.ud(a, b, PointCollectionUtil.b(k), d, e, f, g);
                    if (j == null) {
                        continue;
                    }
                    i.add(j);
                }
                return i;
            }
            else if (typeCast(IEnumerable$1_$type.specialize(Point_$type), c) !== null) {
                let l = c;
                let m = this.ud(a, b, PointCollectionUtil.b(l), d, e, f, g);
                let n = new List$1(FlattenedShape.$, 0);
                if (m != null) {
                    n.add(m);
                }
                return n;
            }
            else {
                throw new InvalidOperationException(1, "Unrecognized data in ShapeColumn");
            }
        }
        get_u2() {
            return true;
        }
        get u2() {
            return this.get_u2();
        }
        vb() {
            return false;
        }
        ps(a) {
            this.wd(this.cg);
        }
        pq(a, b, c, d, e) {
            super.pq(a, b, c, d, e);
            let f = this.a3.a$h.item(d);
            let g = f;
            f.a3(c);
            if (this.dm(f)) {
                return;
            }
            this.wd(f);
        }
        wd(a) {
            if (this.dm(a)) {
                return;
            }
            let b;
            let c;
            let d = a;
            let e = a.getViewInfo(c, b);
            c = e.p0;
            b = e.p1;
            if (c.width < 1 || c.height < 1 || this.uu == null) {
                return;
            }
            let f = this.uf;
            let g = this.uh;
            let h = this.getEffectiveViewport1(a);
            let i = new ScalerParams(1, b, c, f.ch);
            i.c = h;
            let j = new ScalerParams(1, b, c, g.ch);
            j.c = h;
            if (!this.f1) {
                d.cu();
                let k = new Rect(0, 0, 0, 0, 0);
                let l;
                let m;
                let n;
                let o;
                let p = this.uu.count;
                if (this.t6 == null || this.t6.length != p) {
                    this.t6 = new Array(p);
                    this.t4 = new Array(p);
                    this.t5 = new Array(p);
                    this.t3 = new Array(p);
                }
                let q = this.t6;
                let r = this.t4;
                let s = this.t5;
                let t = this.t3;
                let u;
                for (let v = 0; v < p; v++) {
                    u = this.vc._inner[v];
                    q[v] = u.top;
                    r[v] = u.left;
                    s[v] = u.right;
                    t[v] = u.bottom;
                }
                this.ue.hn(boxArray$1(r), 0, r.length, i);
                this.ue.hn(boxArray$1(s), 0, s.length, i);
                this.ug.hn(boxArray$1(q), 0, q.length, j);
                this.ug.hn(boxArray$1(t), 0, t.length, j);
                d.cv(r, q, s, t);
                let w = this.uu;
                let x = this.c7;
                this.wg(d);
                let y = c.left;
                let z = c.right;
                let aa = c.top;
                let ab = c.bottom;
                let ac = null;
                if (this.wr.isEmpty) {
                    ac = null;
                }
                else {
                    ac = new Clipper(1, this.wr.left, this.wr.bottom, this.wr.right, this.wr.top, this.u2);
                }
                let ad = this.vb();
                if (ad) {
                    d.cc.clear();
                }
                let ae = false;
                let af = true;
                let ag = 0;
                if (this.cv != null) {
                    if (this.cv.fc()) {
                        let ah = this.cv.lp(b, i);
                        ae = ah.c;
                        ag = ah.d;
                    }
                }
                let ai;
                for (let aj = 0; aj < p; aj++) {
                    n = r[aj];
                    l = q[aj];
                    m = t[aj];
                    o = s[aj];
                    k.x = Math.min(n, o);
                    k.y = Math.min(l, m);
                    k.width = Math.max(n, o) - k.x;
                    k.height = Math.max(l, m) - k.y;
                    if (k.intersectsWith(c)) {
                        if (k.x < y || k.y < aa || k.x > z || k.y > ab) {
                            ai = ac;
                        }
                        else {
                            ai = null;
                        }
                        let ak = this.ve(a, ai, w.item(aj), i, j, 0, ag);
                        if (ad) {
                            ShapeSeriesBase.wc(d, aj, ak);
                        }
                        d.ci(aj, x.item(aj), k, ak);
                    }
                    else if (ae) {
                        k.x = k.x + ag;
                        if (k.intersectsWith(c)) {
                            if (k.x < y || k.y < aa || k.x > z || k.y > ab) {
                                ai = ac;
                            }
                            else {
                                ai = null;
                            }
                            let al = this.ve(a, ai, w.item(aj), i, j, ag, ag);
                            if (ad) {
                                ShapeSeriesBase.wc(d, aj, al);
                            }
                            d.ci(aj, x.item(aj), k, al);
                        }
                    }
                }
                d.ct();
            }
            let am = this.va();
            this.um.az(this, this.va(), runOn(this, this.t9));
            let an = false;
            let ao = this.um.b;
            if (ao != null) {
                an = true;
            }
            let ap = a.q;
            let aq = this.fc;
            let ar = d.ca;
            d.cp((as) => {
                let at = as.dataContext != null ? as.dataContext.item : null;
                let au = as.dataContext != null ? as.dataContext.c : -1;
                d.cm(as, at, am);
                if (an) {
                    this.v9(as, aq, au, this.uu.count, ap, ar);
                }
                else {
                    if (ar) {
                        {
                            this.um.a1(as, this.hi, ar);
                        }
                    }
                }
                {
                    this.um.ad(as, false, false, false, false);
                }
            });
        }
        v9(a, b, c, d, e, f) {
            let g = this.bp != 1;
            this.um.a0(this.um.b, c, d, false);
            {
                this.um.a1(a, this.hi, f);
            }
            let h = this.um.ax;
            let i = null;
            let j = this.c7;
            if (g && this.cv != null) {
                i = this.cv.c2.getHighlightingInfo(this, j, h.o, h.n, false);
                h.b = i;
            }
            h.f = e;
            this.wb(h);
            this.um.z(this, i, e, g, false);
        }
        v8(a, b, c) {
            let d = this.bp != 1;
            this.um.a0(this.um.d, a, b, true);
            this.um.aa(this.hi);
            let e = this.um.aw;
            let f = null;
            let g = this.c7;
            let h = null;
            if (d && this.cv != null) {
                f = this.cv.c2.getHighlightingInfo(this, g, e.o, e.n, true);
                if (this.cv.c2.isCrossContextHighlight(this)) {
                    h = this.cv.c2.getHighlightingInfo(this, g, e.o, e.n, true);
                }
                e.b = f;
            }
            e.f = c;
            this.wa(e);
            this.um.y(this, f, c, d, e.l, this.cv.c2.sumHighlightingProgress);
        }
        wb(a) {
            if (this.assigningShapeStyle != null && this.uw) {
                this.assigningShapeStyle(this, a);
            }
        }
        wa(a) {
            if (this.assigningShapeMarkerStyle != null && this.uv) {
                this.assigningShapeMarkerStyle(this, a);
            }
        }
        t9(a, b) {
            return this.ua(a, b);
        }
        ua(a, b) {
            if (b < a || a < 0 || a > this.uu.count || b < 0 || b > this.uu.count) {
                return null;
            }
            let c = new Array((b - a) + 1);
            for (let d = a; d <= b; d++) {
                let e = d;
                c[d - a] = this.c7.item(d);
            }
            return c;
        }
        static wc(a, b, c) {
            let d = 0;
            let e = null;
            for (let f = 0; f < c.count; f++) {
                let g = c._inner[f];
                let h = g.b.width * g.b.height;
                if (h > d) {
                    d = h;
                    e = g;
                }
            }
            a.cc.addItem(b, e);
        }
        oc() {
            super.oc();
            if (this.uf != null) {
                this.uf.h7();
            }
            if (this.uh != null) {
                this.uh.h7();
            }
        }
        qp(a, b) {
            this.pr(false);
        }
        qo(a, b) {
            this.pr(false);
        }
        np(a, b, c, d) {
            super.np(a, b, c, d);
            switch (a) {
                case 3:
                    if (d == this.vy) {
                        this.vc._inner[b] = this.ws(this.uu.item(b));
                    }
                    break;
                case 1:
                    for (let e = b; e < b + c; e++) {
                        this.vc.insert(e, this.ws(this.uu.item(e)));
                    }
                    break;
                case 0:
                    this.vc.v(b, c);
                    break;
                case 2:
                    for (let f = b; f < b + c; f++) {
                        this.vc._inner[f] = this.ws(this.uu.item(f));
                    }
                    break;
                case 4:
                    this.we();
                    break;
            }
            this.pr(false);
        }
        gm(a, b, c) {
            let d = true;
            if (!super.gm(a, b, c) || (this.u6 && this.uu == null) || b.isEmpty || a.isEmpty || this.uf == null || this.uh == null || this.uf.bi == null || this.uh.bi == null || this.uf.lx == this.uf.lw || this.uh.lx == this.uh.lw || this.uu == null || this.uu.count == 0 || this.vc == null || this.vc.count == 0 || this.vc.count != this.uu.count) {
                d = false;
            }
            return d;
        }
        get_u6() {
            return true;
        }
        get u6() {
            return this.get_u6();
        }
        o2(a) {
            super.o2(a);
            this.un = typeCast(ShapeSeriesViewBase.$, a);
        }
        vf(a, b, c, d, e, f, g) {
            let h = new List$1(FlattenedShape.$, 0);
            let i;
            let j = c.count;
            for (let k = 0; k < j; k++) {
                i = c._inner[k];
                let l = this.ud(a, b, i, d, e, f, g);
                if (l == null) {
                    continue;
                }
                h.add(l);
            }
            return h;
        }
        ud(a, b, c, d, e, f, g) {
            let h = this.v5(c, d, e);
            let i = h.c;
            let j = h.d;
            let k = i.length;
            let l = 1.7976931348623157E+308;
            let m = 1.7976931348623157E+308;
            let n = -1.7976931348623157E+308;
            let o = -1.7976931348623157E+308;
            let p;
            let q;
            if (f != 0) {
                for (let r = 0; r < k; r++) {
                    i[r] = i[r] + f;
                }
            }
            for (let s = 0; s < k; s++) {
                p = i[s];
                q = j[s];
                l = p < l ? p : l;
                m = q < m ? q : m;
                n = p > n ? p : n;
                o = q > o ? q : o;
            }
            let t = !(l > this.wr.right || n < this.wr.left || m > this.wr.bottom || o < this.wr.top);
            if (!t && f == 0 && g != 0) {
                if (g != 0) {
                    for (let u = 0; u < k; u++) {
                        i[u] = i[u] + g;
                    }
                }
                for (let v = 0; v < k; v++) {
                    p = i[v];
                    q = j[v];
                    l = p < l ? p : l;
                    m = q < m ? q : m;
                    n = p > n ? p : n;
                    o = q > o ? q : o;
                }
                t = !(l > this.wr.right || n < this.wr.left || m > this.wr.bottom || o < this.wr.top);
            }
            if (!t) {
                return null;
            }
            let w = b != null && (l < this.wr.left || m < this.wr.top || n > this.wr.right || o > this.wr.bottom);
            let x = new Rect(0, l, m, n - l, o - m);
            if (!a.cb(x)) {
                return null;
            }
            l = l < this.wr.left ? this.wr.left : l;
            n = n > this.wr.right ? this.wr.right : n;
            m = m < this.wr.top ? this.wr.top : m;
            o = o > this.wr.bottom ? this.wr.bottom : o;
            let y = PolySimplification.b(h, this.hk);
            let z = new DefaultFlattener().c(h.c, h.d, y, this.vg);
            let aa = z.count;
            if (w) {
                let ab = new List$1(Point_$type, 0);
                b.i = ab;
                for (let ac = 0; ac < aa; ac++) {
                    b.j(z._inner[ac]);
                }
                b.i = null;
                z = ab;
            }
            if (z == null || z.count == 0) {
                return null;
            }
            let ad = new FlattenedShape();
            ad.a = z;
            ad.b = new Rect(0, l, m, n - l, o - m);
            ad.c = x;
            return ad;
        }
        v5(a, b, c) {
            let d = this.ue;
            let e = this.ug;
            let f = a.count;
            let g = new Array(f);
            let h = new Array(f);
            for (let i = 0; i < f; i++) {
                g[i] = a._inner[i].x;
                h[i] = a._inner[i].y;
            }
            d.hn(boxArray$1(g), 0, g.length, b);
            e.hn(boxArray$1(h), 0, h.length, c);
            return new Tuple$2(Array_$type, Array_$type, g, h);
        }
        wg(a) {
            a.c0();
        }
        nk(a, b) {
            super.nk(a, b);
            let c = b;
            c.cn();
        }
        v7(a) {
            if (a != null) {
                a.ct(this);
            }
        }
        wf(a) {
            if (a != null) {
                a.b0(this);
            }
        }
        au(a, b) {
            let c = this.un.c2(a, b);
            let d = null;
            if (c != null) {
                d = c.dataContext;
            }
            if (d != null) {
                return d;
            }
            return super.au(a, b);
        }
        vn(a) {
            return this.c7.item(a);
        }
        get_gg() {
            return true;
        }
        set_gg(a) {
            super.set_gg(a);
        }
        aq(a) {
            if (typeCast(NumericXAxis.$, a) !== null && this.vc != null) {
                let b = 1.7976931348623157E+308;
                let c = -1.7976931348623157E+308;
                for (let d of fromEnum(this.vc)) {
                    b = Math.min(b, d.left);
                    c = Math.max(c, d.right);
                }
                return new AxisRange(b, c);
            }
            if (typeCast(NumericYAxis.$, a) !== null && this.vc != null) {
                let e = 1.7976931348623157E+308;
                let f = -1.7976931348623157E+308;
                for (let g of fromEnum(this.vc)) {
                    e = Math.min(e, g.top);
                    f = Math.max(f, g.bottom);
                }
                return new AxisRange(e, f);
            }
            return null;
        }
        get_fb() {
            return true;
        }
        get_ez() {
            return true;
        }
        get u0() {
            return this.styleShape != null;
        }
        wt(a, b, c) {
            if (this.styleShape != null) {
                if (this.un.c9 != null && c == this.un.c9) {
                    c = new Style();
                    let d = this.un.c9;
                    c.fill = d.fill;
                    c.opacity = d.opacity;
                    c.stroke = d.stroke;
                    c.strokeThickness = d.strokeThickness;
                }
                else {
                    if (c != null) {
                        let e = new Style();
                        e.fill = c.fill;
                        e.opacity = c.opacity;
                        e.stroke = c.stroke;
                        e.strokeThickness = c.strokeThickness;
                        c = e;
                    }
                    else {
                        c = new Style();
                    }
                }
                let f = new StyleShapeEventArgs(a, b, c);
                this.styleShape(this, f);
                return f.d();
            }
            return c;
        }
    }
    ShapeSeriesBase.$t = markType(ShapeSeriesBase, 'ShapeSeriesBase', Series.$);
    ShapeSeriesBase.wh = DependencyProperty.i("HighlightedValueMemberPath", String_$type, ShapeSeriesBase.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("HighlightedValueMemberPath", b.oldValue, b.newValue)));
    ShapeSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, ShapeSeriesBase, 'raisePropertyChanged', ['IsCustomShapeMarkerStyleAllowed:u3:wi', [0, false], 'IsCustomShapeStyleAllowed:u4:wj', [0, false], 'ItemSearchMode:ul:wk', [ShapeItemSearchMode_$type, enumGetBox(ShapeItemSearchMode_$type, 0)], 'ItemSearchPointsThreshold:vl:wl', [1, 10000], 'ItemSearchThreshold:vm:wm', [1, 10000], 'ShapeFilterResolution:vi:wn', [1, 2], 'ShapeMemberPath:vy:wo', [2, null], 'XAxis:uf:wp', [NumericXAxis.$, null], 'YAxis:uh:wq', [NumericYAxis.$, null]]);
    return ShapeSeriesBase;
})();
/**
 * @hidden
 */
export let ShapeSeriesRenderManager = /*@__PURE__*/ (() => {
    class ShapeSeriesRenderManager extends SeriesRenderManager {
        constructor() {
            super(...arguments);
            this.aw = null;
            this.ax = null;
        }
        c() {
            this.aw = new AssigningShapeMarkerStyleEventArgs();
            return this.aw;
        }
        a() {
            this.ax = new AssigningShapeStyleEventArgs();
            return this.ax;
        }
        a1(a, b, c) {
            this.ag = this.ak;
            this.ah = this.al;
            this.m = this.t;
            this.am = this.an;
            this.ao = this.ar;
            this.k = this.r;
            this.l = this.s;
            this.j = this.q;
            if (c) {
                if (a._fill != null) {
                    this.ag = a._fill;
                }
                if (a._stroke != null) {
                    this.ah = a._stroke;
                }
                if (!isNaN_(a.ad) && (a.y == null || !isNaN_(a.y.strokeThickness))) {
                    this.m = a.ad;
                }
            }
            let d = this.b;
            if (d != null) {
                d.p = this.ag;
                d.q = this.ah;
                d.t = this.m;
                d.u = this.am;
                d.v = this.ao;
                d.r = this.k;
                d.s = this.l;
                d.k = this.j;
                d.e = this.f;
                d.i = b;
                d.d = false;
            }
        }
        ay(a, b, c) {
            this.w(a, b, c);
        }
        az(a, b, c) {
            this.x(a, b, c);
        }
        a0(a, b, c, d) {
            if (b == -1) {
                a.c = false;
                a.o = 0;
                a.n = c - 1;
            }
            else {
                if (d) {
                    a.o = b;
                    a.n = b;
                }
                else {
                    a.c = false;
                    a.o = b;
                    a.n = b;
                }
            }
        }
    }
    ShapeSeriesRenderManager.$t = markType(ShapeSeriesRenderManager, 'ShapeSeriesRenderManager', SeriesRenderManager.$);
    return ShapeSeriesRenderManager;
})();
/**
 * @hidden
 */
export let ShapeSeriesViewBase = /*@__PURE__*/ (() => {
    class ShapeSeriesViewBase extends SeriesView {
        constructor(a) {
            super(a);
            this.cc = null;
            this.b6 = null;
            this.cd = new List$1(ShapeHitRegion.$, 0);
            this.ch = 0;
            this.cg = null;
            this.b9 = null;
            this.c7 = new Path();
            this.b7 = null;
            this.c8 = null;
            this.b1 = null;
            this.b3 = null;
            this.b2 = null;
            this.b0 = null;
            this.b6 = a;
            this.b9 = this.b8();
            this.cg = new List$1(Path.$, 0);
            this.cc = new Dictionary$2(Number_$type, FlattenedShape.$, 0);
        }
        b4(a) {
            return null;
        }
        get ce() {
            return this.cd;
        }
        b8() {
            return ((() => {
                let $ret = new Pool$1(FrameworkElement.$);
                $ret.create = runOn(this, this.c1);
                $ret.activate = runOn(this, this.cq);
                $ret.disactivate = runOn(this, this.cr);
                $ret.destroy = runOn(this, this.cs);
                return $ret;
            })());
        }
        cb(a) {
            return a.width >= this.b6.vj && a.height >= this.b6.vj;
        }
        static cf(a) {
            let b = new List$1(PointCollection.$, 0);
            let c;
            let d = a.count;
            for (let e = 0; e < d; e++) {
                c = a._inner[e];
                let f = new PointCollection(1, c.a);
                b.add(f);
            }
            return b;
        }
        get ca() {
            return this.c8 != null || this.b7 != null || this.b6.u0;
        }
        ci(a, b, c, d) {
            if (d != null && d.count > 0) {
                let e = ShapeSeriesViewBase.cf(d);
                c.intersect(this.bx);
                if (!this.cb(c)) {
                }
                else {
                    let f = this.c5(a, e);
                    if (f != null) {
                        let g = this.c4(this.ch, b);
                        for (let h = 0; h < d.count; h++) {
                            let i = new ShapeHitRegion();
                            i.d = d._inner[h].b;
                            i.a = d._inner[h].a;
                            i.b = a;
                            i.c = g;
                            this.cd.add(i);
                        }
                        this.ck(g, f);
                        this.ch = this.ch + 1;
                    }
                }
            }
        }
        c4(a, b) {
            let c = this.b9.item(this.ch);
            if (c.dataContext != null) {
                c.dataContext.item = b;
                c.dataContext.c = a;
            }
            return c;
        }
        static cl(a, b, c) {
            if (b._fill == null) {
                b._fill = a.e.su;
            }
            if (b._stroke == null) {
                b._stroke = a.e.sx;
            }
            if (b.y == null) {
                b.ad = a.e.hl;
            }
        }
        cp(a) {
            for (let b = 0; b < this.b9.a.count; b++) {
                let c = this.b9.a._inner[b];
                a(c);
            }
        }
        cm(a, b, c) {
            if (a == null) {
                return;
            }
            this.co(a, c);
            let d = false;
            if (this.b7 != null) {
                let e = this.b7.selectStyle(b, a);
                if (e != null) {
                    d = true;
                }
                if (a.y != e) {
                    a.y = e;
                    this.k.j(a, a.y);
                }
            }
            if (!d) {
                if (a.y != this.c8) {
                    a.y = this.c8;
                    this.k.j(a, a.y);
                }
            }
            let f = this.b6.wt(b, a, a.y);
            if (a.y != f) {
                a.y = f;
                this.k.j(a, a.y);
            }
        }
        co(a, b) {
        }
        cj(a, b) {
            let c = truncate(Math.floor(a.left));
            let d = truncate(Math.ceil(a.right));
            let e = truncate(Math.floor(a.top));
            let f = truncate(Math.ceil(a.bottom));
            for (let g = c; g < d; g++) {
                for (let h = e; h < f; h++) {
                    this.cx(g, h, b);
                }
            }
        }
        cx(a, b, c) {
        }
        cu() {
            this.ch = 0;
        }
        ct() {
            this.b9.count = this.ch;
            this.as();
        }
        cw(a, b) {
        }
        cn() {
            this.b9.count = 0;
            this.as();
        }
        c1() {
            let a = this.b6;
            let b = ((() => {
                let $ret = new Path();
                $ret.dataContext = ((() => {
                    let $ret = new DataContext();
                    $ret.series = a;
                    return $ret;
                })());
                return $ret;
            })());
            this.cg.add(b);
            return b;
        }
        cq(a) {
            a._visibility = 0;
        }
        cr(a) {
            a.dataContext.item = null;
            a._visibility = 1;
        }
        cs(a) {
            this.cg.remove(a);
        }
        c6(a, b, c) {
            if (b == null) {
                return null;
            }
            let d = new PathGeometry();
            let e;
            let f = b.count;
            for (let g = 0; g < f; g++) {
                e = b._inner[g];
                if (e.count < 1) {
                    continue;
                }
                let h = new PolyLineSegment();
                h._points = e;
                let i = new PathFigure();
                i._isFilled = c;
                i._isClosed = c;
                i._startPoint = e._inner[0];
                i._segments.add(h);
                d.c.add(i);
            }
            return d;
        }
        ac(a) {
            return this.cg._inner[a];
        }
        ab(a) {
            let b = this.cg._inner[a];
            this.c7._visibility = b._visibility;
            this.c7.an = b.an;
            let c = this.bs(a);
            this.c7._fill = c;
            this.c7._stroke = c;
            this.c7.ad = this.e.hl + 3;
            return this.c7;
        }
        a8(a, b) {
            super.a8(a, b);
            for (let c = 0; c < this.cg.count; c++) {
                let d = this.aa(c, b);
                if (d._visibility != 1) {
                    a.t(d);
                }
            }
        }
        get c9() {
            return this.c8;
        }
        cz(a) {
            this.b7 = a;
        }
        cy(a) {
            this.c8 = a;
        }
        c2(a, b) {
            return this.c3(a, b, false);
        }
        c3(a, b, c) {
            let d = this.b5(a, b, c);
            if (d == null) {
                return null;
            }
            return d.c;
        }
        b5(a, b, c) {
            if (this.cd.count == 0) {
                return null;
            }
            let d = a.x;
            let e = a.y;
            let f = this.cd.count;
            let g = this.cd;
            let h = null;
            for (let i = 0; i < f; i++) {
                h = g._inner[i];
                if (h.a == null || h.a.count == 0) {
                    continue;
                }
                if (d >= h.d.left && d <= h.d.right && e >= h.d.top && e <= h.d.bottom) {
                    if (c) {
                        let j = this.b6.hl / 2 + this.b6.hz(b);
                        if (GeometryUtil.b(a, h.a._inner[0], h.a, j)) {
                            return h;
                        }
                    }
                    else {
                        if (PolygonUtil.b(h.a, a)) {
                            return h;
                        }
                    }
                }
            }
            return null;
        }
        cv(a, b, c, d) {
            this.b1 = a;
            this.b3 = b;
            this.b2 = c;
            this.b0 = d;
            this.cd.clear();
        }
        c0() {
            let a = this.bx;
            let b = ((() => {
                let $ret = new Path();
                $ret.y = this.c8;
                return $ret;
            })());
            b.ad = 1;
            if (this.k != null) {
                this.k.j(b, b.y);
            }
            this.b6.wr = RectUtil.r(a, b.ad);
        }
        an(a) {
            super.an(a);
            if (this.b9.a == null) {
                return;
            }
            for (let b = 0; b < this.b9.a.count; b++) {
                let c = typeCast(Path.$, this.b9.a._inner[b]);
                if (c._visibility != 1) {
                    this.e.a5.exportPathData(a, c, "shape" + b, ["Main "]);
                }
            }
        }
    }
    ShapeSeriesViewBase.$t = markType(ShapeSeriesViewBase, 'ShapeSeriesViewBase', SeriesView.$);
    return ShapeSeriesViewBase;
})();
