/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { DependencyProperty } from "igniteui-angular-core";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { CategoryFrame } from "./CategoryFrame";
import { Number_$type, typeCast, enumGetBox, EnumUtil, runOn, markType, markDep } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { CategorySeries } from "./CategorySeries";
import { NotImplementedException } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { GeometryGroup } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { LineGeometry } from "igniteui-angular-core";
import { Defaults } from "./Defaults";
import { Extensions } from "igniteui-angular-core";
import { IndicatorRenderer } from "./IndicatorRenderer";
/**
 * @hidden
 */
var FinancialIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialIndicator, _super);
    function FinancialIndicator() {
        var _this = _super.call(this) || this;
        _this._indicatorColumn = null;
        _this.x5 = null;
        _this.uf = new CategoryFrame(3);
        _this.uh = new CategoryFrame(3);
        _this.ud = new CategoryFrame(3);
        _this.indicatorColumn = new List$1(Number_$type, 0);
        _this.x5 = new AxisRange(-100, 100);
        return _this;
    }
    FinancialIndicator.prototype.get_em = function () {
        return true;
    };
    FinancialIndicator.prototype.cd = function () {
        return new FinancialIndicatorView(this);
    };
    FinancialIndicator.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.x6 = a;
    };
    FinancialIndicator.prototype.yj = function (a) {
        if (this.uu != null && !this.uu.c1()) {
            this.pr(true);
        }
    };
    FinancialIndicator.prototype.yb = function (a, b, c) {
        if (isNaN_(b.x) || isNaN_(b.y)) {
            return false;
        }
        var d = this.uu;
        var e = 0;
        if (d != null) {
            e = d.e4(d.l7);
        }
        if ((a.y >= e && a.y <= b.y) || (a.y <= e && a.y >= b.y)) {
            return true;
        }
        return false;
    };
    FinancialIndicator.prototype.bu = function () {
        if (this.bv == 0) {
            return 1;
        }
        else {
            return _super.prototype.bu.call(this);
        }
    };
    FinancialIndicator.prototype.tu = function (a) {
        if (this.ub == null || this.uu == null) {
            return Rect.empty;
        }
        var b = this.te(a);
        var c = this.cg.by;
        var d = this.cg.bx;
        var e = this.getEffectiveViewport1(this.cg);
        var f = new ScalerParams(0, c, d, this.uu.ch, e);
        f.b = this.h3();
        var g = this.aj(this.ub, this.ud.f, this.v8(this.cg), this.wa(this.cg), a, true);
        if (g == null) {
            return Rect.empty;
        }
        var h = g[0];
        var i = g[1];
        var j = Math.abs(b.x - h[0]);
        var k = Math.abs(b.x - i[0]);
        var l = this.uu.ej(this.uu.l7, f);
        var m = 1;
        if (j < k) {
            var n = h[0] - 0.5 * m;
            var o = h[1];
            var p = l;
            return new Rect(0, n, Math.min(o, p), m, Math.max(o, p) - Math.min(o, p));
        }
        else {
            var q = i[0] - 0.5 * m;
            var r = i[1];
            var s = l;
            return new Rect(0, q, Math.min(r, s), m, Math.max(r, s) - Math.min(r, s));
        }
    };
    FinancialIndicator.prototype.f5 = function (a, b) {
        var c = this.tj(this.to(a), true, false);
        if (this.x8 == 1) {
            if (this.yb(a, c, b)) {
                return true;
            }
        }
        if (this.x8 == 1 || this.x8 == 0) {
            if (this.f4(a, b)) {
                return true;
            }
        }
        if (this.x8 == 2) {
            if (this.f8(a, b)) {
                return true;
            }
        }
        return false;
    };
    FinancialIndicator.prototype.np = function (a, b, c, d) {
        _super.prototype.np.call(this, a, b, c, d);
        if (this.ub != null && typeCast(ISortingAxis_$type, this.ub) !== null) {
            this.ub.i$i();
        }
        if (this.x6.ca) {
            this.x6.b8.g$e(a, b, c, d);
        }
        if (d != null && this.vn.containsKey(d)) {
            var e = this.vn.tryGetValue(d, d);
            d = e.p1;
        }
        if (this.ub != null && typeCast(ISortingAxis_$type, this.ub) !== null) {
            a = 4;
            b = 0;
            c = this.c7.count;
        }
        switch (a) {
            case 3:
                if (this.ya(b, c, d)) {
                    this.yl(b, c, d);
                    this.yj(true);
                }
                break;
            case 2:
                if (this.ya(b, this.c7.count - b, d)) {
                    this.yl(b, this.c7.count - b, d);
                    this.yj(true);
                }
                break;
            case 1:
                if (this.ya(b, this.c7.count - b, d)) {
                    var f = new Array(c);
                    for (var g = 0; g < c; g++) {
                        f[g] = 0;
                    }
                    this.indicatorColumn.s(b, f);
                    this.yl(b, this.c7.count - b, d);
                    this.yj(true);
                }
                break;
            case 0:
                if (this.ya(b, this.c7.count - b, d)) {
                    this.indicatorColumn.v(b, c);
                    this.yl(b, this.c7.count - b, d);
                    this.yj(true);
                }
                break;
            case 4:
                if (this.ya(b, this.c7.count - b, d)) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.c7.count);
                    var h = new Array(c);
                    for (var i = 0; i < c; i++) {
                        h[i] = 0;
                    }
                    this.indicatorColumn.s(0, h);
                    this.yl(b, this.c7.count - b, d);
                    this.yj(true);
                }
                break;
        }
    };
    FinancialIndicator.prototype.get_x7 = function () {
        return 0;
    };
    Object.defineProperty(FinancialIndicator.prototype, "x7", {
        get: function () {
            return this.get_x7();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialIndicator.prototype, "yw", {
        get: function () {
            return this.c(FinancialIndicator.ym);
        },
        set: function (a) {
            this.h(FinancialIndicator.ym, a);
        },
        enumerable: false,
        configurable: true
    });
    FinancialIndicator.prototype.yg = function () {
        return -1;
    };
    Object.defineProperty(FinancialIndicator.prototype, "indicatorColumn", {
        get: function () {
            return this._indicatorColumn;
        },
        set: function (a) {
            this._indicatorColumn = a;
        },
        enumerable: false,
        configurable: true
    });
    FinancialIndicator.prototype.pa = function (a, b, c, d) {
        switch (b) {
            case "XAxis":
                this.x6.cg();
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.x6.b8 = CategoryTrendLineManagerFactory.a(this.x6.b8, this.ub, this.qt, this, this.da);
                }
                break;
        }
        _super.prototype.pa.call(this, a, b, c, d);
        if (this.x6.ca && this.x6.b8.g$b(a, b, c, d)) {
            this.pr(false);
            var f = typeCast(FinancialIndicatorView.$, this.cf);
            if (f != null && f.ca) {
                f.b8.g$b(a, b, c, d);
            }
            this.om();
        }
        switch (b) {
            case "FastItemsSource":
                if (this.c7 != null) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.c7.count);
                    var g = new Array(this.c7.count);
                    for (var h = 0; h < this.c7.count; h++) {
                        g[h] = 0;
                    }
                    this.indicatorColumn.s(0, g);
                    this.yl(0, this.c7.count, null);
                    if (this.uu != null && !this.uu.c1()) {
                        this.us.b0.e(this.hk);
                        this.pr(this.fr && c != null);
                    }
                }
                break;
            case "TrendLineBrush":
                this.pg(b);
                break;
            case FinancialIndicator.$$p[0]:
                this.nk(true, this.cg);
                this.qg();
                this.pr(false);
                this.om();
                break;
            case "OpenColumn":
            case "HighColumn":
            case "LowColumn":
            case "CloseColumn":
            case "VolumeColumn":
                if (this.c7 != null) {
                    if (this.indicatorColumn.count != this.c7.count) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.c7.count);
                        var i = new Array(this.c7.count);
                        for (var j = 0; j < this.c7.count; j++) {
                            i[j] = 0;
                        }
                        this.indicatorColumn.s(0, i);
                    }
                    if (this.ya(0, this.c7.count - 1, b)) {
                        this.yk();
                    }
                }
                break;
            case "XAxis":
                if (this.ub != null && (typeCast(ISortingAxis_$type, this.ub) !== null || typeCast(ISortingAxis_$type, c) !== null)) {
                    this.yk();
                }
                break;
            case "YAxis":
            case FinancialIndicator.$$p[1]:
                this.yk();
                this.om();
                break;
            case "TrendLineType":
                this.om();
                break;
        }
    };
    FinancialIndicator.prototype.ia = function (a, b, c) {
        if (this.indicatorColumn == null) {
            return _super.prototype.ia.call(this, a, b, c);
        }
        var d = this.getEffectiveViewport1(this.cg);
        var e = this.v2(this.cg.by, this.cg.bx, d);
        var f = new ScalerParams(0, this.cg.by, this.cg.bx, this.ub.ch, d);
        f.c = this.cv.t6;
        return this.ic(this.indicatorColumn, a, this.ub, f, e, runOn(this, this.v1), b, c);
    };
    FinancialIndicator.prototype.jg = function (a, b) {
        if (this.indicatorColumn == null) {
            return _super.prototype.jg.call(this, a, b);
        }
        return this.jh(a, b, this.ub, runOn(this, this.v1), this.indicatorColumn);
    };
    FinancialIndicator.prototype.je = function (a, b) {
        if (this.indicatorColumn == null) {
            return _super.prototype.je.call(this, a, b);
        }
        return this.jf(a, b, this.ub, runOn(this, this.v1), this.indicatorColumn);
    };
    FinancialIndicator.prototype.get_gl = function () {
        return true;
    };
    FinancialIndicator.prototype.ya = function (a, b, c) {
        if (c == null) {
            return true;
        }
        if (this.yc(a, b).contains(c)) {
            return true;
        }
        return false;
    };
    FinancialIndicator.prototype.yl = function (a, b, c) {
        this.x9(a, b);
    };
    FinancialIndicator.prototype.aq = function (a) {
        if (this.c7 == null) {
            return null;
        }
        if (a != null && a == this.uu) {
            return this.x5;
        }
        return null;
    };
    FinancialIndicator.prototype.fp = function (a) {
        var b = this.c7 != null ? this.c7.indexOf(a) : -1;
        var c = this.cg.by;
        c = c.copy();
        var d = this.cg.bx;
        var e = new Rect(0, 0, 0, 1, 1);
        var f = this.ts(this.cg);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.ub != null) {
                var g = new ScalerParams(0, e, e, this.ub.ch, f);
                var h = this.ub.ej(b, g);
                if (h < c.left + 0.1 * c.width) {
                    h = h + 0.4 * c.width;
                }
                if (h > c.right - 0.1 * c.width) {
                    h = h - 0.4 * c.width;
                }
                c.x = h - 0.5 * c.width;
            }
            if (this.uu != null && this.indicatorColumn != null && b < this.indicatorColumn.count) {
                var i = new ScalerParams(0, e, e, this.uu.ch, f);
                i.b = this.h3();
                var j = this.uu.ej(this.indicatorColumn._inner[b], i);
                if (j < c.top + 0.1 * c.height) {
                    j = j + 0.4 * c.height;
                }
                if (j > c.bottom - 0.1 * c.height) {
                    j = j - 0.4 * c.height;
                }
                c.y = j - 0.5 * c.height;
            }
            this.co.au(this.cv, c, true);
        }
        return b >= 0;
    };
    FinancialIndicator.prototype.gm = function (a, b, c) {
        var d = _super.prototype.gm.call(this, a, b, c);
        if (this.indicatorColumn == null || this.indicatorColumn.count == 0) {
            d = false;
        }
        return d;
    };
    FinancialIndicator.prototype.xh = function (a, b) {
        var _this = this;
        _super.prototype.xh.call(this, a, b);
        var c = b.by;
        var d = b.bx;
        var e = this.getEffectiveViewport1(b);
        var f = this.ub;
        var g = this.uu;
        var h = new ScalerParams(0, c, d, f.ch, e);
        var i = new ScalerParams(0, c, d, g.ch, e);
        i.b = this.h3();
        var j = this.ub.ag();
        var k = j[0];
        var l = j[1];
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var m = 0;
        var n = typeCast(ISortingAxis_$type, this.ub);
        if (n != null && n.i$b.count != this.c7.count) {
            return;
        }
        m = this.v2(c, d, e);
        var o = this.yg();
        if (o == -1) {
            o = this.trendLinePeriod;
        }
        var p = typeCast(FinancialIndicatorView.$, b);
        if (p.ca) {
            p.b8.prepareLineCore(a.p, this.trendLineType, this.indicatorColumn, o, function (q) { return _this.ub.ej(q, h); }, function (q) { return _this.uu.ej(q, i); }, ((function () {
                var $ret = new TrendResolutionParams();
                $ret.e = b.b0.b;
                $ret.f = b.b0.c;
                $ret.g = b.b0.d;
                $ret.a = m;
                $ret.d = _this.hk;
                $ret.h = d;
                $ret.i = c;
                $ret.b = l;
                $ret.c = k;
                return $ret;
            })()));
        }
        var q = this.ub.em(2, h) - this.ub.em(1, h);
        for (var r = b.b0.c; r <= b.b0.d; ++r) {
            var s = void 0;
            if (n == null) {
                s = b.b0.getBucket(r);
            }
            else {
                var t = n.i$b._inner[r];
                var u = n.i$d(t);
                var v = this.indicatorColumn._inner[r];
                var w = v;
                var x = u;
                while (r < b.b0.d) {
                    t = n.i$b._inner[r + 1];
                    x = n.i$d(t);
                    if (x - u > q) {
                        break;
                    }
                    r++;
                    var y = this.indicatorColumn._inner[r];
                    v = Math.min(v, y);
                    w = Math.max(w, y);
                }
                var z = NaN;
                if (!isNaN_(u)) {
                    z = this.ub.ej(u, h);
                }
                s = [z, v, w];
            }
            if (!isNaN_(s[0])) {
                if (this.ub != null && typeCast(ISortingAxis_$type, this.ub) !== null) {
                    s[0] = s[0] + m;
                }
                else {
                    s[0] = f.ej(s[0], h) + m;
                }
                s[1] = g.ej(s[1], i);
                if (b.b0.b > 1 || n != null) {
                    s[2] = g.ej(s[2], i);
                }
                else {
                    s[2] = s[1];
                }
                a.f.add(s);
            }
        }
        return;
    };
    FinancialIndicator.prototype.nk = function (a, b) {
        _super.prototype.nk.call(this, a, b);
        var c = b;
        c.cb(a);
        if (c.ca) {
            c.b8.g$d();
        }
    };
    FinancialIndicator.prototype.ul = function () {
        switch (this.x8) {
            case 1: return 1;
            case 2: return 1;
            case 0: return 12;
        }
        return 1;
    };
    FinancialIndicator.prototype.xj = function (a, b) {
        _super.prototype.xj.call(this, a, b);
        var c = typeCast(FinancialIndicatorView.$, b);
        var d = function (e) { return a.f._inner[e][0]; };
        var e = function (f) { return a.f._inner[f][1]; };
        if (c.ca) {
            c.b8.g$d();
            c.b8.g$g(a.p);
        }
        var f = b.bx;
        var g = this.getEffectiveViewport1(b);
        var h = 0;
        var i = this.su;
        var j = this.x1;
        if (b.b3(a)) {
            c.cb(false);
            if (a.f.count > 0) {
                switch (this.x8) {
                    case 0:
                        var k = CategorySeries.vi(a.f, a.f.count - 1, f, b.by, false);
                        c.cf(a.f.count, d, e, true, k);
                        break;
                    case 1:
                        if (this.uu != null) {
                            h = this.v6(b);
                        }
                        else {
                            h = 0.5 * (f.top + f.bottom);
                        }
                        var l = CategorySeries.vi(a.f, a.f.count - 1, f, b.by, false);
                        c.cd(a.f.count, d, e, true, h, l);
                        break;
                    case 2:
                        h = this.v6(b);
                        c.ce(a.f.count, d, e, true, h);
                        break;
                    default: throw new NotImplementedException(0);
                }
            }
            b.b5(a);
        }
        var m = a.f;
        var n = this.c7.count;
        this.uk.a2(this, this.vj(), runOn(this, this.t3), this.v8(b), this.wa(b));
        var o = false;
        var p = this.uk.b;
        if (p != null) {
            o = true;
        }
        this.uk.ak = i;
        this.uk.ag = i;
        if (o) {
            var q = new ScalerParams(0, b.by, b.bx, this.ub.ch, g);
            this.uk.f = false;
            this.xg(m, -1, n, this.ub, q, b.q);
        }
        this.uk.ad(c.cx, true, false, true, false);
        this.uk.ad(c.cz, true, false, true, false);
        this.uk.ad(c.cy, false, true, false, false);
        c.cy._opacity = 0.8 * this.uk.j * this.hg;
        this.uk.ad(c.cw, true, false, false, false);
        this.uk.ak = j;
        this.uk.ag = j;
        if (o) {
            var r = new ScalerParams(0, b.by, b.bx, this.ub.ch, g);
            this.uk.f = true;
            this.xg(m, -1, n, this.ub, r, b.q);
        }
        this.uk.ad(c.ct, true, false, true, false);
        this.uk.ad(c.cv, true, false, true, false);
        this.uk.ad(c.cu, false, true, false, false);
        c.cu._opacity = 0.8 * this.uk.j * this.hg;
        this.uk.ad(c.cs, true, false, false, false);
        c.ch();
    };
    FinancialIndicator.prototype.qf = function () {
        _super.prototype.qf.call(this);
        if (this.index < 0) {
            return;
        }
        if (this.x6.ca) {
            this.x6.ci();
        }
    };
    FinancialIndicator.prototype.yk = function () {
        if (this.x6.ca) {
            this.x6.b8.g$i();
        }
        this.x9(0, this.indicatorColumn.count);
        if (this.uu != null && !this.uu.c1()) {
            this.pr(this.fr && this.dp);
        }
    };
    FinancialIndicator.prototype.n2 = function (a) {
        _super.prototype.n2.call(this, a);
        this.a5.exportTrendlineData(this, a, this.x6.b8.g$j);
    };
    FinancialIndicator.prototype.a7 = function (a) {
        if (this.x8 == 1 || this.x8 == 2) {
            return 3;
        }
        else if (this.x8 == 0) {
            return 2;
        }
        return a;
    };
    FinancialIndicator.$t = markType(FinancialIndicator, 'FinancialIndicator', FinancialSeries.$, [ITrendLineSeries_$type]);
    FinancialIndicator.ym = DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialIndicator.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    FinancialIndicator.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialIndicator, 'raisePropertyChanged', ['DisplayType:x8:yn', [IndicatorDisplayType_$type, enumGetBox(IndicatorDisplayType_$type, 0)], 'IgnoreFirst:ye:yo', [1, 0], 'TrendLineType::yu', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::yt', [1, 1.5], 'TrendLinePeriod::ys', [1, 7], 'TrendLineBrush::yp', [Brush.$, null], 'TrendLineZIndex:yf:yv', [1, 1001], 'TrendLineDashArray:yx:yq', [DoubleCollection.$], 'TrendLineDashCap:yy:yr', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return FinancialIndicator;
}(FinancialSeries));
export { FinancialIndicator };
/**
 * @hidden
 */
var FinancialIndicatorBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialIndicatorBucketCalculator, _super);
    function FinancialIndicatorBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    FinancialIndicatorBucketCalculator.prototype.getBucket = function (a) {
        var b = a * this.b;
        var c = Math.min(b + this.b - 1, this.f.b6.indicatorColumn.count - 1);
        var d = NaN;
        var e = NaN;
        for (var f = b; f <= c; ++f) {
            var g = this.f.b6.indicatorColumn._inner[f];
            if (!isNaN_(d)) {
                if (!isNaN_(g)) {
                    d = Math.min(d, g);
                    e = Math.max(e, g);
                }
            }
            else {
                d = g;
                e = g;
            }
        }
        if (!isNaN_(d)) {
            return [0.5 * (b + c), d, e];
        }
        return [NaN, NaN, NaN];
    };
    FinancialIndicatorBucketCalculator.$t = markType(FinancialIndicatorBucketCalculator, 'FinancialIndicatorBucketCalculator', FinancialBucketCalculator.$);
    return FinancialIndicatorBucketCalculator;
}(FinancialBucketCalculator));
export { FinancialIndicatorBucketCalculator };
/**
 * @hidden
 */
var FinancialIndicatorView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialIndicatorView, _super);
    function FinancialIndicatorView(a) {
        var _this = _super.call(this, a) || this;
        _this.b6 = null;
        _this.b9 = null;
        _this.cx = ((function () {
            var $ret = new Path();
            $ret.an = new PathGeometry();
            return $ret;
        })());
        _this.ct = ((function () {
            var $ret = new Path();
            $ret.an = new PathGeometry();
            return $ret;
        })());
        _this.cy = ((function () {
            var $ret = new Path();
            $ret.an = new PathGeometry();
            return $ret;
        })());
        _this.cu = ((function () {
            var $ret = new Path();
            $ret.an = new PathGeometry();
            return $ret;
        })());
        _this.cz = ((function () {
            var $ret = new Path();
            $ret.an = new PathGeometry();
            return $ret;
        })());
        _this.cv = ((function () {
            var $ret = new Path();
            $ret.an = new PathGeometry();
            return $ret;
        })());
        _this.cw = ((function () {
            var $ret = new Path();
            $ret.an = new GeometryGroup();
            return $ret;
        })());
        _this.cs = ((function () {
            var $ret = new Path();
            $ret.an = new GeometryGroup();
            return $ret;
        })());
        _this.b7 = null;
        _this.cp = new Path();
        _this.cr = new Path();
        _this.cq = new Path();
        _this.co = new Path();
        _this.cl = new Path();
        _this.cn = new Path();
        _this.cm = new Path();
        _this.ck = new Path();
        _this.b6 = a;
        _this.b9 = ((function () {
            var $ret = new Pool$1(LineGeometry.$);
            $ret.create = runOn(_this, _this.cj);
            $ret.destroy = runOn(_this, _this.cc);
            return $ret;
        })());
        return _this;
    }
    FinancialIndicatorView.prototype.b1 = function () {
        return new FinancialIndicatorBucketCalculator(this);
    };
    FinancialIndicatorView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
            this.b6.x1 = Defaults.ah;
            this.b6.x8 = this.b6.x7;
        }
    };
    FinancialIndicatorView.prototype.cj = function () {
        return new LineGeometry();
    };
    FinancialIndicatorView.prototype.cc = function (a) {
    };
    Object.defineProperty(FinancialIndicatorView.prototype, "b8", {
        get: function () {
            if (this.b7 == null) {
                this.b7 = CategoryTrendLineManagerFactory.a(this.b7, this.e.as(), this.e.qt, this.e, this.e.da);
            }
            return this.b7;
        },
        set: function (a) {
            this.b7 = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialIndicatorView.prototype, "ca", {
        get: function () {
            return this.b7 != null;
        },
        enumerable: false,
        configurable: true
    });
    FinancialIndicatorView.prototype.cb = function (a) {
        Extensions.e(this.cx.an);
        Extensions.e(this.cy.an);
        Extensions.e(this.cz.an);
        Extensions.e(this.ct.an);
        Extensions.e(this.cu.an);
        Extensions.e(this.cv.an);
        Extensions.d(this.cw.an);
        Extensions.d(this.cs.an);
        if (a) {
            this.b9.count = 0;
        }
        this.as();
    };
    FinancialIndicatorView.prototype.ch = function () {
    };
    FinancialIndicatorView.prototype.cf = function (a, b, c, d, e) {
        IndicatorRenderer.g(a, b, c, d, this.by, this.bx, this.cx, this.ct, this.b0.b, this.e.hk, e);
        this.as();
    };
    FinancialIndicatorView.prototype.cd = function (a, b, c, d, e, f) {
        IndicatorRenderer.e(a, b, c, d, this.by, this.bx, this.cx, this.cy, this.ct, this.cu, e, this.b0.b, this.e.hk, f);
        this.as();
    };
    FinancialIndicatorView.prototype.ce = function (a, b, c, d, e) {
        IndicatorRenderer.f(a, b, c, d, this.bx, e, this.b9, this.cw, this.cs);
        this.as();
    };
    FinancialIndicatorView.prototype.ci = function () {
        this.b6.yw = null;
        if (this.b6.trendLineBrush != null) {
            this.b6.yw = this.b6.trendLineBrush;
        }
        else {
            this.b6.yw = this.b6.su;
        }
    };
    FinancialIndicatorView.prototype.be = function () {
        _super.prototype.be.call(this);
        var a = this.br();
        this.cp.an = this.cx.an;
        this.cr.an = this.cz.an;
        this.cq.an = this.cy.an;
        this.co.an = this.cw.an;
        this.cl.an = this.ct.an;
        this.cn.an = this.cv.an;
        this.cm.an = this.cu.an;
        this.ck.an = this.cs.an;
        this.cp._stroke = a;
        this.cr._stroke = a;
        this.cp.ad = this.e.hl + 3;
        this.cr.ad = this.e.hl + 3;
        this.cq._fill = a;
        this.cq._opacity = 1;
        this.co._stroke = a;
        this.co.ad = this.e.hl + 3;
        this.cl._stroke = a;
        this.cn._stroke = a;
        this.cl.ad = this.e.hl + 3;
        this.cn.ad = this.e.hl + 3;
        this.cm._fill = a;
        this.cm._opacity = 1;
        this.ck._stroke = a;
        this.ck.ad = this.e.hl + 3;
    };
    FinancialIndicatorView.prototype.a8 = function (a, b) {
        _super.prototype.a8.call(this, a, b);
        if (a.d) {
            if (b) {
                if (this.b6.x8 == 2) {
                    a.t(this.co);
                    a.t(this.ck);
                }
                else {
                    a.t(this.cq);
                    a.t(this.cp);
                    a.t(this.cr);
                    a.t(this.cm);
                    a.t(this.cl);
                    a.t(this.cn);
                }
            }
            else {
                if (this.b6.x8 == 2) {
                    a.t(this.cw);
                    a.t(this.cs);
                }
                else {
                    a.t(this.cy);
                    a.t(this.cx);
                    a.t(this.cz);
                    a.t(this.cu);
                    a.t(this.ct);
                    a.t(this.cv);
                }
            }
        }
    };
    FinancialIndicatorView.prototype.a7 = function (a, b) {
        if (a.d) {
            if (this.b6.trendLineType != 0 && !b) {
                var c = this.b8.g$j;
                c.ad = this.b6.trendLineThickness;
                c._stroke = this.b6.yw;
                c.aj = this.b6.yy;
                c.ai = this.b6.yx;
                a.v(c);
            }
        }
        _super.prototype.a7.call(this, a, b);
    };
    FinancialIndicatorView.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
        this.e.a5.exportPathData(a, this.cw, "positiveColumnsShape", ["Positive", "Main"]);
        this.e.a5.exportPathData(a, this.cs, "negativeColumnsShape", ["Negative"]);
        this.e.a5.exportPathData(a, this.cx, "positive0", ["Positive", "Main"]);
        this.e.a5.exportPathData(a, this.cz, "positive1", ["Positive"]);
        this.e.a5.exportPathData(a, this.cy, "positive01", ["PositiveFill"]);
        this.e.a5.exportPathData(a, this.ct, "negative0", ["Negative", "Main"]);
        this.e.a5.exportPathData(a, this.cv, "negative1", ["Negative"]);
        this.e.a5.exportPathData(a, this.cu, "negative01", ["NegativeFill"]);
    };
    FinancialIndicatorView.prototype.cg = function () {
        if (this.ca) {
            this.b7 = CategoryTrendLineManagerFactory.a(this.b7, this.e.as(), this.e.qt, this.e, this.e.da);
        }
    };
    FinancialIndicatorView.$t = markType(FinancialIndicatorView, 'FinancialIndicatorView', FinancialSeriesView.$);
    return FinancialIndicatorView;
}(FinancialSeriesView));
export { FinancialIndicatorView };
