/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { ShapeSeriesBase } from "./ShapeSeriesBase";
import { ShapeAxisInfoCache } from "./ShapeAxisInfoCache";
import { StyleSelector } from "./StyleSelector";
import { DependencyProperty } from "igniteui-angular-core";
import { Style } from "igniteui-angular-core";
import { MarkerType_$type } from "./MarkerType";
import { DataTemplate } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { CollisionAvoidanceType_$type } from "./CollisionAvoidanceType";
import { MarkerOutlineMode_$type } from "./MarkerOutlineMode";
import { MarkerFillMode_$type } from "./MarkerFillMode";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { Base, runOn, enumGetBox, Number_$type, typeCast, fromEnum, markType, markDep, PointUtil } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { ShapeSeriesViewBase } from "./ShapeSeriesViewBase";
import { Marker } from "./Marker";
import { MarkerSeries } from "./MarkerSeries";
import { BrushUtil } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { RectUtil } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { DataTemplateMeasureInfo } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { Defaults } from "./Defaults";
import { DataTemplatePassInfo } from "igniteui-angular-core";
import { DataTemplateRenderInfo } from "igniteui-angular-core";
import { MarkerVisualData } from "./MarkerVisualData";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
var ScatterPolygonSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterPolygonSeries, _super);
    function ScatterPolygonSeries() {
        var _this = _super.call(this) || this;
        _this.w8 = null;
        _this.w5 = new ScalerParams(1, ScatterPolygonSeries.ye, ScatterPolygonSeries.ye, false);
        _this.w6 = new ScalerParams(1, ScatterPolygonSeries.ye, ScatterPolygonSeries.ye, false);
        _this.xu = null;
        _this.w0 = 1;
        _this.ww = 1;
        _this.ab = ScatterPolygonSeries.$;
        return _this;
    }
    ScatterPolygonSeries.prototype.bc = function () {
        return new ScatterPolygonSeries();
    };
    ScatterPolygonSeries.prototype.get_e4 = function () {
        return true;
    };
    ScatterPolygonSeries.prototype.get_ez = function () {
        return true;
    };
    ScatterPolygonSeries.prototype.vb = function () {
        return this.xa();
    };
    ScatterPolygonSeries.prototype.wd = function (a) {
        var _this = this;
        var b = a;
        b.cy(this.yg);
        b.cz(this.w9);
        _super.prototype.wd.call(this, a);
        if (this.dm(a)) {
            return;
        }
        var c, d;
        var e = a.getViewInfo(c, d);
        c = e.p0;
        d = e.p1;
        var f = this.getEffectiveViewport1(a);
        this.w5 = new ScalerParams(1, d, c, this.uf.ch);
        this.w5.c = f;
        this.w6 = new ScalerParams(1, d, c, this.uh.ch);
        this.w6.c = f;
        if (c.width < 1 || c.height < 1) {
            return;
        }
        this.w8 = ((function () {
            var $ret = new ShapeAxisInfoCache();
            $ret.a = _this.uf;
            $ret.b = _this.uh;
            $ret.e = _this.uf.ch;
            $ret.f = _this.uh.ch;
            $ret.d = _this.c7;
            $ret.c = _this.uu;
            return $ret;
        })());
        if (this.xa()) {
            var g = new Dictionary$2(Base.$, OwnedPoint.$, 0);
            b.dg.l(g, 400, d, c, this.hk);
            b.dg.j(g, false);
            if (this.u9()) {
                this.xr(a);
            }
        }
    };
    ScatterPolygonSeries.prototype.xr = function (a) {
        var _this = this;
        a.dk = true;
        this.um.ay(this, this.u9(), runOn(this, this.t9));
        var b = this.um.d;
        var c = b != null;
        var d = this.getEffectiveViewport1(a);
        var e = this.c7 == null ? 0 : this.c7.count;
        a.dw(function (f) {
            if (f._visibility == 0) {
                var g = f.ak;
                var h = f.content;
                if (h == null) {
                    h = new DataContext();
                    f.content = h;
                }
                if (c) {
                    _this.v8(g, e, a.q);
                }
                _this.um.ac(f, h);
            }
        });
    };
    ScatterPolygonSeries.prototype.xa = function () {
        return this.xu != null && ((this.w4 != 1 && this.w4 != 0) || this.xv != null);
    };
    ScatterPolygonSeries.prototype.cd = function () {
        return new ScatterPolygonSeriesView(this);
    };
    ScatterPolygonSeries.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.w7 = a;
    };
    ScatterPolygonSeries.prototype.get_hasMarkers = function () {
        return true;
    };
    ScatterPolygonSeries.prototype.s1 = function () {
        return this.ya;
    };
    ScatterPolygonSeries.prototype.s2 = function () {
        return this.yb;
    };
    ScatterPolygonSeries.prototype.qx = function () {
        return this.xt;
    };
    ScatterPolygonSeries.prototype.ky = function () {
        return this.kz(this, this.xu);
    };
    ScatterPolygonSeries.prototype.ht = function () {
        return this.xc;
    };
    Object.defineProperty(ScatterPolygonSeries.prototype, "w1", {
        get: function () {
            return this.w0;
        },
        set: function (a) {
            this.w0 = a;
        },
        enumerable: false,
        configurable: true
    });
    ScatterPolygonSeries.prototype.w3 = function () {
        if (this.w2 == 0) {
            return 1;
        }
        return this.w2;
    };
    ScatterPolygonSeries.prototype.qj = function (a) {
        _super.prototype.qj.call(this, a);
        this.w2 = a;
    };
    Object.defineProperty(ScatterPolygonSeries.prototype, "wx", {
        get: function () {
            return this.ww;
        },
        set: function (a) {
            this.ww = a;
        },
        enumerable: false,
        configurable: true
    });
    ScatterPolygonSeries.prototype.wz = function () {
        if (this.wy == 0) {
            return 2;
        }
        return this.wy;
    };
    ScatterPolygonSeries.prototype.qi = function (a) {
        _super.prototype.qi.call(this, a);
        this.wy = a;
    };
    ScatterPolygonSeries.prototype.qk = function (a) {
        _super.prototype.qk.call(this, a);
        this.xc = a;
    };
    ScatterPolygonSeries.prototype.qf = function () {
        _super.prototype.qf.call(this);
        if (this.index < 0) {
            return;
        }
        if (this.xv != null) {
            this.w7.dv();
            this.w7.ds();
        }
        else {
            var a = MarkerSeries.ud(this, this.w4);
            var b = MarkerSeries.ul(a);
            if (b == null) {
                this.xt = MarkerSeries.uz;
            }
            else {
                this.w7.dp(b);
            }
        }
        if (this.yc != null && this.w4 != 13) {
            this.p6("ActualMarkerBrush");
            var c = this.ya;
            this.w7.dt();
            this.w7.dq();
            var d = this.ya;
            var e = this.ev("ActualMarkerBrush", this.g2.f > 0 ? this.g2.d() : null, c, d);
            this.p8("ActualMarkerBrush", e);
        }
        else {
            if (this.w4 == 13) {
                this.ya = this.cg.bt();
            }
            else {
                if (this.wx != 2) {
                    if (this.cv != null) {
                        var f = this.cv.s2(this.index);
                        if (!isNaN_(this.hj) && this.hj != 1) {
                            f = BrushUtil.q(f, this.hj);
                        }
                        this.ya = f;
                    }
                    else {
                        this.ya = null;
                    }
                }
            }
        }
        if (this.yd != null) {
            this.w7.du();
            this.w7.dr();
        }
        else {
            if (this.w4 == 13) {
                this.yb = this.cg.bt();
            }
            else {
                if (this.w2 == 2) {
                    this.yb = this.ya;
                }
                else {
                    this.yb = this.cv == null ? null : this.cv.s3(this.index);
                }
            }
        }
        if (this.wx == 2 && this.yc == null && this.w4 != 13) {
            if (this.yb != null) {
                var g = this.yb;
                if (!isNaN_(this.hj) && this.hj != 1) {
                    g = BrushUtil.q(g, this.hj);
                }
                this.ya = g;
            }
            else {
                this.ya = null;
            }
        }
    };
    ScatterPolygonSeries.prototype.ot = function () {
        _super.prototype.ot.call(this);
        this.w1 = this.w3();
        this.wx = this.wz();
    };
    ScatterPolygonSeries.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        switch (b) {
            case ScatterPolygonSeries.$$p[3]:
            case ScatterPolygonSeries.$$p[11]:
            case ScatterPolygonSeries.$$p[7]:
            case ScatterPolygonSeries.$$p[9]:
            case ScatterPolygonSeries.$$p[10]:
                this.pg(b);
                this.o4();
                break;
            case ScatterPolygonSeries.$$p[6]:
                this.w1 = this.w3();
                this.pg(null);
                this.o4();
                break;
            case ScatterPolygonSeries.$$p[5]:
                this.wx = this.wz();
                this.pg(null);
                this.o4();
                break;
            case ScatterPolygonSeries.$$p[2]:
                this.xu = d;
                if (c == MarkerSeries.uz || d == MarkerSeries.uz || (c == null || d != null)) {
                    this.w7.dx();
                    this.pr(false);
                }
                this.cg.bl();
                if (this.toolTip != null && this.ew) {
                    this.a3.a$aj(this, this.toolTip);
                }
                this.pr(false);
                this.om();
                break;
            case ScatterPolygonSeries.$$p[12]:
                this.w7.cy(this.yg);
                this.pr(false);
                this.om();
                break;
            case ScatterPolygonSeries.$$p[13]:
                this.w7.cz(this.w9);
                this.pr(false);
                this.om();
                break;
            case ScatterPolygonSeries.$$p[4]:
                this.pr(false);
                this.om();
                break;
            case ScatterPolygonSeries.$$p[0]:
            case ScatterPolygonSeries.$$p[1]:
                if (this.xa()) {
                    this.pr(false);
                }
                break;
        }
    };
    ScatterPolygonSeries.prototype.au = function (a, b) {
        var c = this.w7.b4(a);
        var d = null;
        if (c != null) {
            d = c.content;
        }
        if (d != null) {
            return d;
        }
        return _super.prototype.au.call(this, a, b);
    };
    ScatterPolygonSeries.prototype.xs = function (a, b) {
        var e_1, _a, e_2, _b;
        var c = new List$1(Base.$, 0);
        try {
            for (var _c = __values(fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                b.h(e);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    ScatterPolygonSeries.prototype.dt = function (a, b, c, d) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var e = this.uf;
        var f = new ScalerParams(1, this.cv.tr, this.ty, e.ch);
        f.c = this.getEffectiveViewport1(this.cg);
        var g = this.uh;
        var h = new ScalerParams(1, this.cv.tr, this.ty, g.ch);
        h.c = this.getEffectiveViewport1(this.cg);
        a.clear();
        this.w7.dw(function (i) {
            if (i._visibility == 0) {
                var j = new SeriesPointOfInterest();
                var k = i.n;
                var l = i.o;
                if (k < _this.ty.left || k > _this.ty.right || l < _this.ty.top || l > _this.ty.bottom) {
                    return;
                }
                j.b = e.em(k, f);
                j.c = g.em(l, h);
                j.a = i.content;
                a.add(j);
            }
        });
        return true;
    };
    ScatterPolygonSeries.prototype.wu = function (a, b, c, d, e) {
        var _this = this;
        if (c == null || c.length != this.w8.d.count) {
            c = new Array(this.w8.d.count);
            for (var f = 0; f < this.w8.d.count; f++) {
                c[f] = PointUtil.create();
            }
        }
        var g = ((function () {
            var $ret = new ScalerParams(1, d, e, _this.uf.ch);
            $ret.c = _this.getEffectiveViewport1(a);
            return $ret;
        })());
        var h = ((function () {
            var $ret = new ScalerParams(1, d, e, _this.uh.ch);
            $ret.c = _this.getEffectiveViewport1(a);
            return $ret;
        })());
        var i = this.tq(a);
        var j = this.w8.a.em(i.left, g);
        var k = this.w8.a.em(i.right, g);
        var l = this.w8.b.em(i.bottom, h);
        var m = this.w8.b.em(i.top, h);
        if (this.w8.e) {
            var n = j;
            j = k;
            k = n;
        }
        if (this.w8.f) {
            var o = l;
            l = m;
            m = o;
        }
        var p = this.w8;
        var q = p.a;
        var r = p.b;
        var s;
        var t;
        var u = g.d.left;
        var v = g.d.right;
        var w = h.d.top;
        var x = h.d.bottom;
        for (var y = 0; y < this.w8.d.count; y++) {
            s = 0;
            t = 0;
            var z = null;
            var aa = a.cc.tryGetValue(y, z);
            z = aa.p1;
            if (z == null) {
                c[y].x = NaN;
                c[y].y = NaN;
            }
            else {
                var ab = z.c;
                var ac = RectUtil.l(ab);
                s = ac.x;
                t = ac.y;
                if (s >= u && s <= v && t >= w && t <= x) {
                    c[y].x = s;
                    c[y].y = t;
                }
                else {
                    c[y].x = NaN;
                    c[y].y = NaN;
                }
            }
        }
        return c;
    };
    ScatterPolygonSeries.prototype.xb = function (a, b) {
        var e_3, _a;
        if (b == null) {
            b = new List$1(Number_$type, 2, a.e);
        }
        else {
            b.clear();
        }
        var c = 0;
        var d = this.c7;
        try {
            for (var _b = __values(fromEnum(a.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                b.add(d.indexOf(e));
                c++;
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        return b;
    };
    ScatterPolygonSeries.$t = markType(ScatterPolygonSeries, 'ScatterPolygonSeries', ShapeSeriesBase.$);
    ScatterPolygonSeries.ye = new Rect(0, 0, 0, 1, 1);
    ScatterPolygonSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterPolygonSeries, 'raisePropertyChanged', ['ActualMarkerBrush:ya:xw', [Brush.$], 'ActualMarkerOutline:yb:xx', [Brush.$], 'ActualMarkerTemplate:xt:xy', [DataTemplate.$, null], 'MarkerBrush:yc:xz', [Brush.$], 'MarkerCollisionAvoidance:wv:x0', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerFillMode:wy:x1', [MarkerFillMode_$type, enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:w2:x2', [MarkerOutlineMode_$type, enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:yd:x3', [Brush.$], 'MarkerStyle:yf:x4', [Style.$], 'MarkerTemplate:xv:x5', [DataTemplate.$, null], 'MarkerThickness:xc:x6', [1, DeviceUtils.g(2)], 'MarkerType:w4:x7', [MarkerType_$type, enumGetBox(MarkerType_$type, 1)], 'ShapeStyle:yg:x8', [Style.$, null], 'ShapeStyleSelector:w9:x9', [StyleSelector.$, null]]);
    return ScatterPolygonSeries;
}(ShapeSeriesBase));
export { ScatterPolygonSeries };
/**
 * @hidden
 */
var ScatterPolygonSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterPolygonSeriesView, _super);
    function ScatterPolygonSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.dk = false;
        _this.db = null;
        _this.dm = null;
        _this.dh = null;
        _this.df = null;
        _this.dj = false;
        _this.di = null;
        _this.dn = null;
        _this.dc = new Marker();
        _this.d4 = null;
        _this.dc = new Marker();
        _this.dc.content = new DataContext();
        _this.dh = a;
        _this.di = new HashPool$2(Base.$, Marker.$);
        _this.dn = new List$1(Marker.$, 0);
        _this.dy(_this.di);
        _this.df = new NumericMarkerManager(1, function (b) { return _this.di.item(b); }, function (b) { return _this.dh.w8.d.item(b); }, runOn(_this, _this.d2), runOn(_this, _this.da), runOn(_this, _this.dl), function () { return _this.dh.wv; });
        _this.df.q = runOn(_this, _this.d5);
        return _this;
    }
    ScatterPolygonSeriesView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
            this.dh.yd = Defaults.am;
            this.dh.iv = Defaults.z;
            this.dh.xc = Defaults.y;
            this.dh.w4 = Defaults.f;
            this.dh.wy = Defaults.b;
        }
    };
    Object.defineProperty(ScatterPolygonSeriesView.prototype, "dg", {
        get: function () {
            return this.df;
        },
        enumerable: false,
        configurable: true
    });
    ScatterPolygonSeriesView.prototype.d2 = function (a) {
        this.dh.xs(a, this.di);
    };
    ScatterPolygonSeriesView.prototype.da = function () {
        this.db = this.dh.wu(this, this.di, this.db, this.by, this.bx);
        return this.db;
    };
    ScatterPolygonSeriesView.prototype.dl = function () {
        this.dm = this.dh.xb(this.di, this.dm);
        return this.dm;
    };
    ScatterPolygonSeriesView.prototype.c5 = function (a, b) {
        return this.c6(a, b, true);
    };
    ScatterPolygonSeriesView.prototype.cm = function (a, b, c) {
        _super.prototype.cm.call(this, a, b, c);
        ShapeSeriesViewBase.cl(this, a, b);
    };
    ScatterPolygonSeriesView.prototype.ck = function (a, b) {
        var c = a;
        if (c == null) {
            return;
        }
        c.an = b;
    };
    ScatterPolygonSeriesView.prototype.dw = function (a) {
        this.di.f(a);
    };
    ScatterPolygonSeriesView.prototype.dy = function (a) {
        a.create = runOn(this, this.de);
        a.destroy = runOn(this, this.d0);
        a.activate = runOn(this, this.dz);
        a.disactivate = runOn(this, this.d1);
    };
    ScatterPolygonSeriesView.prototype.de = function () {
        var _this = this;
        var a = new Marker();
        if (!this.dj) {
            a.content = ((function () {
                var $ret = new DataContext();
                $ret.series = _this.e;
                return $ret;
            })());
        }
        a.ah = this.e.xt;
        this.dn.add(a);
        return a;
    };
    ScatterPolygonSeriesView.prototype.b4 = function (a) {
        var b = this.dd(a, 0);
        if (b == null) {
            b = this.dd(a, 3);
        }
        return b;
    };
    ScatterPolygonSeriesView.prototype.dd = function (a, b) {
        var c;
        var d;
        var e;
        var f;
        for (var g = this.dn.count - 1; g >= 0; g--) {
            var h = this.dn._inner[g];
            if (h._visibility == 1 || h._opacity == 0) {
                continue;
            }
            c = (h.m / 2) + b;
            d = (h.l / 2) + b;
            e = h.ai;
            f = h.aj;
            if ((h.n + e) - c <= a.x && (h.n + e) + c >= a.x && (h.o + f) - d <= a.y && (h.o + f) + d >= a.y) {
                return h;
            }
        }
        return null;
    };
    ScatterPolygonSeriesView.prototype.d0 = function (a) {
        a.content = null;
        this.dn.remove(a);
    };
    ScatterPolygonSeriesView.prototype.dz = function (a) {
        a._visibility = 0;
    };
    ScatterPolygonSeriesView.prototype.d1 = function (a) {
        if (a.content != null) {
            (typeCast(DataContext.$, a.content)).item = null;
        }
        a._visibility = 1;
    };
    ScatterPolygonSeriesView.prototype.d3 = function (a) {
        this.dj = a;
    };
    ScatterPolygonSeriesView.prototype.bj = function (a, b) {
        _super.prototype.bj.call(this, a, b);
        if (!this.dk) {
            var c = a;
            var d = c.content;
            if (d != null) {
                if (this.dh.ya != null) {
                    d.actualItemBrush = this.dh.ya;
                }
                else {
                    d.actualItemBrush = this.b6.su;
                }
                if (this.dh.ya != null) {
                    d.outline = this.dh.yb;
                }
                else {
                    d.outline = this.b6.sx;
                }
                d.thickness = this.dh.xc;
            }
        }
    };
    ScatterPolygonSeriesView.prototype.bk = function (a, b) {
        _super.prototype.bk.call(this, a, b);
        var c = a;
        this.dc._visibility = c._visibility;
        this.dc.ah = c.ah;
        this.dc.width = c.width;
        this.dc.height = c.height;
        this.dc.m = c.m;
        this.dc.l = c.l;
        this.dc.n = c.n;
        this.dc.o = c.o;
        var d = this.bs(b);
        var e = this.dc.content;
        var f = c.content;
        e.item = f.item;
        e.series = f.series;
        e.thickness = f.thickness;
        if (e != null) {
            e.actualItemBrush = d;
            e.outline = d;
            e.thickness = this.dh.xc + 3;
        }
    };
    ScatterPolygonSeriesView.prototype.a7 = function (a, b) {
        _super.prototype.a7.call(this, a, b);
        var c = new DataTemplatePassInfo();
        c.isHitTestRender = b;
        c.context = a.h();
        c.viewportTop = this.bx.top;
        c.viewportLeft = this.bx.left;
        c.viewportWidth = this.bx.width;
        c.viewportHeight = this.bx.height;
        c.passID = "Markers";
        var d = new DataTemplateRenderInfo();
        d.passInfo = c;
        d.isHitTestRender = b;
        var e = new DataTemplateMeasureInfo();
        e.passInfo = c;
        var f = false;
        var g = a.h();
        e.context = g;
        d.context = g;
        var h = 0;
        var i = 0;
        if (this.dh.xt != null && this.dh.xt.passStarting != null) {
            this.dh.xt.passStarting(c);
        }
        for (var j = 0; j < this.dn.count; j++) {
            var k = this.dn._inner[j];
            if (k._visibility == 1) {
                continue;
            }
            this.bi(k, j, b);
            if (b) {
                k = this.dc;
            }
            if (!f) {
                e.width = k.width;
                e.height = k.height;
                e.renderOffsetX = 0;
                e.renderOffsetY = 0;
                e.renderContext = a;
                var l = k.ah;
                if (l.measure != null) {
                    e.data = k.content;
                    l.measure(e);
                    f = e.isConstant;
                    if (f) {
                        h = e.width;
                        i = e.height;
                    }
                }
                d.availableWidth = e.width;
                d.availableHeight = e.height;
                d.renderOffsetX = e.renderOffsetX;
                d.renderOffsetY = e.renderOffsetY;
                d.renderContext = a;
            }
            else {
                d.availableWidth = h;
                d.availableHeight = i;
            }
            if (!isNaN_(k.width) && !isInfinity(k.width)) {
                d.availableWidth = k.width;
            }
            if (!isNaN_(k.height) && !isInfinity(k.height)) {
                d.availableHeight = k.height;
            }
            a.q(d, k);
            k.m = d.availableWidth;
            k.l = d.availableHeight;
            k.ai = d.renderOffsetX;
            k.aj = d.renderOffsetY;
        }
        if (this.dh.xt != null && this.dh.xt.passCompleted != null) {
            this.dh.xt.passCompleted(c);
        }
    };
    ScatterPolygonSeriesView.prototype.dv = function () {
        this.dh.xt = null;
    };
    ScatterPolygonSeriesView.prototype.ds = function () {
        this.dh.xt = null;
        this.dh.xt = this.dh.xv;
    };
    ScatterPolygonSeriesView.prototype.dt = function () {
        this.dh.ya = null;
    };
    ScatterPolygonSeriesView.prototype.dq = function () {
        this.dh.ya = null;
        if (!isNaN_(this.e.hj) && this.e.hj != 1) {
            var a = BrushUtil.q(this.dh.yc, this.e.hj);
            this.dh.ya = a;
        }
        else {
            this.dh.ya = this.dh.yc;
        }
    };
    ScatterPolygonSeriesView.prototype.du = function () {
        this.dh.yb = null;
    };
    ScatterPolygonSeriesView.prototype.dr = function () {
        this.dh.yb = null;
        this.dh.yb = this.dh.yd;
    };
    ScatterPolygonSeriesView.prototype.dp = function (a) {
        switch (a) {
            case "CircleMarkerTemplate":
                this.dh.xt = this.dh.cv.p2;
                break;
            case "TriangleMarkerTemplate":
                this.dh.xt = this.dh.cv.qb;
                break;
            case "PyramidMarkerTemplate":
                this.dh.xt = this.dh.cv.p8;
                break;
            case "SquareMarkerTemplate":
                this.dh.xt = this.dh.cv.p9;
                break;
            case "DiamondMarkerTemplate":
                this.dh.xt = this.dh.cv.p3;
                break;
            case "PentagonMarkerTemplate":
                this.dh.xt = this.dh.cv.p6;
                break;
            case "HexagonMarkerTemplate":
                this.dh.xt = this.dh.cv.p4;
                break;
            case "TetragramMarkerTemplate":
                this.dh.xt = this.dh.cv.p6;
                break;
            case "PentagramMarkerTemplate":
                this.dh.xt = this.dh.cv.p7;
                break;
            case "HexagramMarkerTemplate":
                this.dh.xt = this.dh.cv.p5;
                break;
        }
    };
    ScatterPolygonSeriesView.prototype.dx = function () {
        var e_4, _a;
        try {
            for (var _b = __values(fromEnum(this.dn)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.ah = this.dh.xt;
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.as();
    };
    ScatterPolygonSeriesView.prototype.d5 = function (a) {
        if (this.d4 == null) {
            this.d4 = new DataTemplateMeasureInfo();
            this.d4.context = this.k.h();
        }
        this.d4.width = a.width;
        this.d4.height = a.height;
        this.d4.data = a.content;
        var b = a.ah;
        if (b.measure != null) {
            b.measure(this.d4);
        }
        return new Size(1, this.d4.width, this.d4.height);
    };
    ScatterPolygonSeriesView.prototype.an = function (a) {
        var e_5, _a;
        var b = a;
        _super.prototype.an.call(this, b);
        try {
            for (var _b = __values(fromEnum(this.di.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = this.di.item(c);
                if (d._visibility != 1) {
                    var e = typeCast(ScatterPolygonSeries.$, this.e);
                    var f = this.e.a5.getMarkerVisualData(e, d, e.xt);
                    b.markerShapes.add(typeCast(MarkerVisualData.$, f));
                }
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
    };
    ScatterPolygonSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.a3.a$r(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.dh.title + "</span><br/>";
        a += "</div>";
        return a;
    };
    ScatterPolygonSeriesView.$t = markType(ScatterPolygonSeriesView, 'ScatterPolygonSeriesView', ShapeSeriesViewBase.$);
    return ScatterPolygonSeriesView;
}(ShapeSeriesViewBase));
export { ScatterPolygonSeriesView };
