/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-angular-core";
import { HighlightingInfo } from "igniteui-angular-core";
import { ShapeItemSearchMode_$type } from "./ShapeItemSearchMode";
import { IEnumerable$1_$type, enumGetBox, Number_$type, Point_$type, String_$type, typeCast, runOn, delegateCombine, fromEnum, Array_$type, markType, markDep } from "igniteui-angular-core";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { StyleShapeEventArgs } from "./StyleShapeEventArgs";
import { FrameworkElement } from "igniteui-angular-core";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { Tuple$2 } from "igniteui-angular-core";
import { ShapeHitRegion } from "./ShapeHitRegion";
import { RectUtil } from "igniteui-angular-core";
import { Tuple$3 } from "igniteui-angular-core";
import { GeometryUtil } from "igniteui-angular-core";
import { AssigningShapeStyleEventArgs } from "./AssigningShapeStyleEventArgs";
import { AssigningShapeMarkerStyleEventArgs } from "./AssigningShapeMarkerStyleEventArgs";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { PointCollectionUtil } from "igniteui-angular-core";
import { FlattenedShape } from "./FlattenedShape";
import { SeriesView } from "./SeriesView";
import { Clipper } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { Dictionary$2 } from "igniteui-angular-core";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { PolySimplification } from "igniteui-angular-core";
import { DefaultFlattener } from "./DefaultFlattener";
import { AxisRange } from "./AxisRange";
import { Style } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { boxArray$1 } from "igniteui-angular-core";
import { InvalidOperationException } from "igniteui-angular-core";
import { isNaN_, truncate } from "igniteui-angular-core";
import { FastItemObjectColumn } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { PointCollection } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { PolyLineSegment } from "igniteui-angular-core";
import { PathFigure } from "igniteui-angular-core";
import { PolygonUtil } from "igniteui-angular-core";
/**
 * @hidden
 */
var ShapeSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ShapeSeriesBase, _super);
    function ShapeSeriesBase() {
        var _this = _super.call(this) || this;
        _this.uw = false;
        _this.uv = false;
        _this.ur = null;
        _this.us = null;
        _this.ui = 1;
        _this.t7 = null;
        _this.t8 = null;
        _this.assigningShapeStyle = null;
        _this.assigningShapeMarkerStyle = null;
        _this.um = null;
        _this.ut = null;
        _this.ue = null;
        _this.ug = null;
        _this.vg = 0;
        _this.vc = null;
        _this.t4 = null;
        _this.t6 = null;
        _this.t5 = null;
        _this.t3 = null;
        _this.wr = null;
        _this.vj = 0;
        _this.styleShape = null;
        _this.um = new ShapeSeriesRenderManager();
        FastItemObjectColumn.m();
        _this.vj = _this.vi;
        _this.wr = Rect.empty;
        return _this;
    }
    ShapeSeriesBase.prototype.nh = function () {
        _super.prototype.nh.call(this);
        this.uf = null;
        this.uh = null;
    };
    ShapeSeriesBase.prototype.ag = function () {
        return [this.uf, this.uh];
    };
    ShapeSeriesBase.prototype.jv = function (a, b) {
        var c = this.lw(b);
        if (c == ShapeSeriesBase.$$p[6]) {
            return this.jw(a, b, this.vy);
        }
        return null;
    };
    ShapeSeriesBase.prototype.get_et = function () {
        return true;
    };
    ShapeSeriesBase.prototype.get_dv = function () {
        return true;
    };
    ShapeSeriesBase.prototype.up = function (a, b, c) {
        var d = this.te(b);
        var e = this.un.c2(d, false);
        var f = -1;
        if (e == null) {
            if (a != null) {
                f = this.c7.indexOf(a);
            }
            else {
                return null;
            }
        }
        else if (e.dataContext != null) {
            f = e.dataContext.c;
        }
        if (f == -1) {
            return null;
        }
        var g = new HighlightingInfo();
        g.i = this;
        g.g = f;
        g.f = f;
        g.c = false;
        if (c != null && c.g == g.g && c.f == g.f) {
            return c;
        }
        return g;
    };
    ShapeSeriesBase.prototype.uq = function (a, b, c) {
        var d = this.un.b4(this.te(b));
        var e = -1;
        if (d == null) {
            if (a != null) {
                e = this.c7.indexOf(a);
            }
            else {
                return null;
            }
        }
        else {
            e = d.ak;
        }
        if (e == -1) {
            return null;
        }
        var f = new HighlightingInfo();
        f.i = this;
        f.g = e;
        f.f = e;
        f.c = false;
        f.d = true;
        if (c != null && c.g == f.g && c.f == f.f) {
            return c;
        }
        return f;
    };
    Object.defineProperty(ShapeSeriesBase.prototype, "uj", {
        get: function () {
            return this.ui;
        },
        set: function (a) {
            var b = this.ui;
            this.ui = a;
            if (b != this.ui) {
                this.raisePropertyChanged("ActualItemSearchMode", enumGetBox(ShapeItemSearchMode_$type, b), enumGetBox(ShapeItemSearchMode_$type, this.ui));
            }
        },
        enumerable: false,
        configurable: true
    });
    ShapeSeriesBase.prototype.uk = function () {
        if (this.ul != 0) {
            return this.ul;
        }
        return 1;
    };
    ShapeSeriesBase.prototype.hw = function (a) {
        switch (this.uj) {
            case 1: return this.v4(a).c;
            case 2: return this.vh(a);
            case 3: return this.vh(a);
        }
        return -1;
    };
    ShapeSeriesBase.prototype.v4 = function (a) {
        var b = this.te(a);
        var c = { $type: Point_$type, x: NaN, y: NaN };
        var d = this.un.ce;
        if (d == null) {
            return new Tuple$2(Number_$type, Point_$type, -1, c);
        }
        var e = this.un.b5(b, false, !this.ux);
        if (e != null) {
            c = RectUtil.l(e.d);
            return new Tuple$2(Number_$type, Point_$type, e.b, c);
        }
        var f = b.x;
        var g = b.y;
        if (this.c7 == null || this.uf == null || this.uh == null || this.vc == null) {
            return new Tuple$2(Number_$type, Point_$type, -1, c);
        }
        if (this.c7.count > this.vm) {
            return new Tuple$2(Number_$type, Point_$type, -1, c);
        }
        var h = 1.7976931348623157E+308;
        var i = -1;
        for (var j = 0; j < d.count; j++) {
            var k = d._inner[j].d;
            var l = RectUtil.g(k, b);
            if (l < h) {
                h = l;
                i = d._inner[j].b;
                c = RectUtil.l(d._inner[j].d);
            }
        }
        return new Tuple$2(Number_$type, Point_$type, i, c);
    };
    ShapeSeriesBase.prototype.v3 = function (a) {
        var b = this.te(a);
        var c = b.x;
        var d = b.y;
        var e = { $type: Point_$type, x: NaN, y: NaN };
        if (this.c7 == null || this.uf == null || this.uh == null || this.vc == null) {
            return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
        }
        if (this.c7.count > this.vm) {
            return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
        }
        var f = 1.7976931348623157E+308;
        var g = this.un.ce;
        if (g == null) {
            return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
        }
        var h = this.un.b5(b, false, !this.ux);
        if (h != null) {
            var i = RectUtil.l(h.d);
            var j = this.v2(b, h.a, this.ux);
            return new Tuple$3(Number_$type, Point_$type, Point_$type, h.b, j.d, i);
        }
        for (var k = 0; k < g.count; k++) {
            var l = g._inner[k].d;
            var m = RectUtil.g(l, b);
            var n = (l.width * l.width) + (l.height * l.height) + m;
            if (n <= f) {
                f = n;
            }
        }
        var o = 1.7976931348623157E+308;
        var p = -1;
        for (var q = 0; q < g.count; q++) {
            var r = g._inner[q].d;
            var s = RectUtil.g(r, b);
            if (s < f) {
                var t = this.v2(b, g._inner[q].a, this.ux);
                if (t.c < o) {
                    o = t.c;
                    e = t.d;
                    p = q;
                }
            }
        }
        if (p >= 0) {
            return new Tuple$3(Number_$type, Point_$type, Point_$type, g._inner[p].b, e, RectUtil.l(g._inner[p].d));
        }
        return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
    };
    ShapeSeriesBase.prototype.get_ux = function () {
        return true;
    };
    Object.defineProperty(ShapeSeriesBase.prototype, "ux", {
        get: function () {
            return this.get_ux();
        },
        enumerable: false,
        configurable: true
    });
    ShapeSeriesBase.prototype.v2 = function (a, b, c) {
        var d = { $type: Point_$type, x: NaN, y: NaN };
        var e = 1.7976931348623157E+308;
        var f = { $type: Point_$type, x: NaN, y: NaN };
        var g = false;
        var h = -1;
        for (var i = 0; i < b.count; i++) {
            var j = b._inner[i];
            if (i >= 1) {
                var k = GeometryUtil.d(a, d, j);
                if (k < e) {
                    e = k;
                    g = true;
                    h = i;
                }
            }
            d = j;
        }
        if (c) {
            var l = b._inner[0];
            var m = GeometryUtil.d(a, d, l);
            if (m < e) {
                e = m;
                var n = GeometryUtil.i(a, d, l);
                f = { $type: Point_$type, x: d.x + (l.x - d.x) * n, y: d.y + (l.y - d.y) * n };
                return new Tuple$2(Number_$type, Point_$type, e, f);
            }
        }
        if (g) {
            var o = b._inner[h - 1];
            var p = b._inner[h];
            var q = GeometryUtil.i(a, o, p);
            f = { $type: Point_$type, x: o.x + (p.x - o.x) * q, y: o.y + (p.y - o.y) * q };
        }
        return new Tuple$2(Number_$type, Point_$type, e, f);
    };
    ShapeSeriesBase.prototype.vh = function (a) {
        return this.v3(a).c;
    };
    ShapeSeriesBase.prototype.tj = function (a, b, c) {
        if (this.uf == null || this.uh == null || this.vc == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        switch (this.uj) {
            case 1:
                var d = this.v4(a);
                return d.d;
            case 2:
                var e = this.v3(a);
                return e.e;
            case 3:
                var f = this.v3(a);
                return f.d;
        }
        return { $type: Point_$type, x: NaN, y: NaN };
    };
    ShapeSeriesBase.prototype.js = function (a) {
        var b = this.i9(a);
        if (this.c7 != null && b >= 0 && b < this.c7.count) {
            return this.c7.item(b);
        }
        return null;
    };
    ShapeSeriesBase.prototype.uo = function (a, b, c) {
        var d = new HighlightingInfo();
        d.i = this;
        d.g = 0;
        d.f = this.c7.count - 1;
        d.c = true;
        if (c != null && c.g == d.g && c.f == d.f) {
            return c;
        }
        return d;
    };
    ShapeSeriesBase.prototype.c0 = function (a, b, c) {
        if (this.dv && this.fd(this.bp) && !c) {
            var d = this.up(a, b, this.ur);
            this.ur = d;
            return d;
        }
        else {
            var e = this.uo(a, b, this.ur);
            this.ur = e;
            return e;
        }
    };
    ShapeSeriesBase.prototype.c1 = function (a, b, c) {
        if (this.fd(this.bp) && !c) {
            var d = this.uq(a, b, this.us);
            this.us = d;
            return d;
        }
        else {
            var e = this.uo(a, b, this.us);
            e.d = true;
            this.us = e;
            return e;
        }
    };
    ShapeSeriesBase.prototype.va = function () {
        return (this.assigningShapeStyle != null && this.uw) || (this.bp != 1);
    };
    ShapeSeriesBase.prototype.u9 = function () {
        return (this.assigningShapeMarkerStyle != null && this.uv) || (this.bp != 1);
    };
    Object.defineProperty(ShapeSeriesBase.prototype, "vp", {
        get: function () {
            return this.c(ShapeSeriesBase.wh);
        },
        set: function (a) {
            this.h(ShapeSeriesBase.wh, a);
        },
        enumerable: false,
        configurable: true
    });
    ShapeSeriesBase.prototype.fo = function () {
        return this.highlightedItemsSource != null || this.vp != null;
    };
    ShapeSeriesBase.prototype.g1 = function () {
        var a = _super.prototype.g1.call(this);
        {
            var b = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.ad = "ShapeMemberPath";
                $ret.p = true;
                $ret.y = "HighlightedShapeMemberPath";
                $ret.q = true;
                return $ret;
            })());
            b.valueResolving = delegateCombine(b.valueResolving, runOn(this, this.v6));
            a.add(b);
        }
        {
            var c = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Brush";
                $ret.p = true;
                $ret.y = "ActualBrush";
                $ret.q = true;
                return $ret;
            })());
            c.valueResolving = delegateCombine(c.valueResolving, runOn(this, this.pz));
            a.add(c);
        }
        {
            var d = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Outline";
                $ret.p = true;
                $ret.y = "ActualOutline";
                $ret.q = true;
                return $ret;
            })());
            d.valueResolving = delegateCombine(d.valueResolving, runOn(this, this.pz));
            a.add(d);
        }
        return a;
    };
    ShapeSeriesBase.prototype.v6 = function (a, b) {
        if (this.vp != null) {
            b.value = this.vp;
            return;
        }
        b.value = this.vy;
    };
    Object.defineProperty(ShapeSeriesBase.prototype, "uu", {
        get: function () {
            return this.ut;
        },
        set: function (a) {
            var b = this.uu != a;
            if (b) {
                var c = this.uu;
                this.ut = a;
                this.raisePropertyChanged("ShapeColumn", c, this.uu);
            }
        },
        enumerable: false,
        configurable: true
    });
    ShapeSeriesBase.prototype.u1 = function (array_) {
        var a = (Array.isArray(array_));
        return a;
    };
    ShapeSeriesBase.u5 = function (a) {
        if (a == null) {
            return true;
        }
        var val_ = a;
        return (val_ == undefined);
    };
    ShapeSeriesBase.prototype.convertToListList = function (a) {
        if (a == null) {
            return null;
        }
        var b = new List$1(List$1.$.specialize(Point_$type), 0);
        var c;
        var curr_;
        var d;
        var e;
        var f = false;
        var g = false;
        for (var h = 0; h < a.length; h++) {
            c = a[h];
            if (c == null) {
                continue;
            }
            var i = new List$1(Point_$type, 0);
            for (var j = 0; j < c.length; j++) {
                curr_ = c[j];
                if (f) {
                    d = (curr_.X);
                    e = (curr_.Y);
                }
                else {
                    d = (curr_.x);
                    e = (curr_.y);
                }
                if (!g) {
                    if ((isNaN_(d) || ShapeSeriesBase.u5(d)) && (isNaN_(e) || ShapeSeriesBase.u5(e))) {
                        d = (curr_.X);
                        e = (curr_.Y);
                        if (!isNaN_(d) && !ShapeSeriesBase.u5(d) && !isNaN_(e) && !ShapeSeriesBase.u5(e)) {
                            g = true;
                            f = true;
                        }
                    }
                    else {
                        g = true;
                    }
                }
                i.add({ $type: Point_$type, x: d, y: e });
            }
            b.add(i);
        }
        return b;
    };
    ShapeSeriesBase.prototype.c6 = function (a) {
        if (this.c7 != null && this.u1(this.itemsSource) && a != null && a.split('!').length != 2) {
            if (this.coercionMethods == null) {
                this.coercionMethods = {};
            }
            var methods_ = this.coercionMethods;
            methods_.convertToListList = this.convertToListList;
            a += "!convertToListList";
        }
        return _super.prototype.c6.call(this, a);
    };
    ShapeSeriesBase.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        var e = false;
        var f = false;
        switch (b) {
            case ShapeSeriesBase.$$p[2]:
                this.uj = this.uk();
                break;
            case "FastItemsSource":
                var g = typeCast(IFastItemsSource_$type, c);
                if (g != null) {
                    g.deregisterColumn(this.uu);
                    this.uu = null;
                }
                var h = typeCast(IFastItemsSource_$type, d);
                if (h != null) {
                    this.uu = this.c6(this.vy);
                }
                e = this.uf != null && !this.uf.c1();
                f = this.uh != null && !this.uh.c1();
                if (e || f) {
                    this.pr(this.fr && c != null);
                }
                break;
            case ShapeSeriesBase.$$p[6]:
                if (this.c7 != null) {
                    this.c7.deregisterColumn(this.uu);
                    this.uu = this.c6(this.vy);
                }
                break;
            case "ShapeColumn":
                this.we();
                e = this.uf != null && !this.uf.c1();
                f = this.uh != null && !this.uh.c1();
                if (e || f) {
                    this.pr(this.fr && this.dp);
                }
                this.om();
                break;
            case ShapeSeriesBase.$$p[7]:
            case ShapeSeriesBase.$$p[8]:
                this.ue = this.uf;
                this.ug = this.uh;
                var i = c;
                var j = d;
                this.wf(i);
                this.v7(j);
                if ((j != null && !j.c1()) || (j == null && i != null)) {
                    this.pr(false);
                }
                this.om();
                break;
            case "ActualResolution":
                this.vg = this.hk;
                this.om();
                break;
            case "ActualBrush":
                this.pr(false);
                break;
            case ShapeSeriesBase.$$p[5]:
                this.vj = this.vi;
                this.pr(false);
                this.om();
                break;
            case "ActualThickness":
                this.pr(false);
                this.om();
                break;
            case ShapeSeriesBase.$$p[1]:
                this.uw = this.u8();
                this.pr(false);
                break;
            case ShapeSeriesBase.$$p[0]:
                this.uv = this.u7();
                this.pr(false);
                break;
        }
    };
    ShapeSeriesBase.prototype.u8 = function () {
        return this.u4;
    };
    ShapeSeriesBase.prototype.u7 = function () {
        return this.u3;
    };
    ShapeSeriesBase.prototype.uz = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    ShapeSeriesBase.prototype.uy = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    ShapeSeriesBase.prototype.we = function () {
        this.vc = null;
        if (this.uu == null) {
            return;
        }
        this.vc = new List$1(Rect.$, 2, this.uu.count);
        for (var a = 0; a < this.uu.count; a++) {
            this.vc.add(PointCollectionUtil.j(this.uu.item(a)));
        }
    };
    ShapeSeriesBase.prototype.ws = function (a) {
        if (typeCast(IEnumerable$1_$type.specialize(IEnumerable$1_$type.specialize(Point_$type)), a) !== null) {
            return PointCollectionUtil.h(a);
        }
        else if (typeCast(IEnumerable$1_$type.specialize(Point_$type), a) !== null) {
            return PointCollectionUtil.g(a);
        }
        return Rect.empty;
    };
    ShapeSeriesBase.prototype.ve = function (a, b, c, d, e, f, g) {
        var e_1, _a;
        return this.vf(a, b, c, d, e, f, g);
        if (typeCast(List$1.$.specialize(List$1.$.specialize(Point_$type)), c) !== null) {
            return this.vf(a, b, c, d, e, f, g);
        }
        else if (typeCast(IEnumerable$1_$type.specialize(IEnumerable$1_$type.specialize(Point_$type)), c) !== null) {
            var h = c;
            var i = new List$1(FlattenedShape.$, 0);
            var j = null;
            try {
                for (var _b = __values(fromEnum(h)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var k = _c.value;
                    j = this.ud(a, b, PointCollectionUtil.b(k), d, e, f, g);
                    if (j == null) {
                        continue;
                    }
                    i.add(j);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return i;
        }
        else if (typeCast(IEnumerable$1_$type.specialize(Point_$type), c) !== null) {
            var l = c;
            var m = this.ud(a, b, PointCollectionUtil.b(l), d, e, f, g);
            var n = new List$1(FlattenedShape.$, 0);
            if (m != null) {
                n.add(m);
            }
            return n;
        }
        else {
            throw new InvalidOperationException(1, "Unrecognized data in ShapeColumn");
        }
    };
    ShapeSeriesBase.prototype.get_u2 = function () {
        return true;
    };
    Object.defineProperty(ShapeSeriesBase.prototype, "u2", {
        get: function () {
            return this.get_u2();
        },
        enumerable: false,
        configurable: true
    });
    ShapeSeriesBase.prototype.vb = function () {
        return false;
    };
    ShapeSeriesBase.prototype.ps = function (a) {
        this.wd(this.cg);
    };
    ShapeSeriesBase.prototype.pq = function (a, b, c, d, e) {
        _super.prototype.pq.call(this, a, b, c, d, e);
        var f = this.a3.a$h.item(d);
        var g = f;
        f.a3(c);
        if (this.dm(f)) {
            return;
        }
        this.wd(f);
    };
    ShapeSeriesBase.prototype.wd = function (a) {
        var _this = this;
        if (this.dm(a)) {
            return;
        }
        var b;
        var c;
        var d = a;
        var e = a.getViewInfo(c, b);
        c = e.p0;
        b = e.p1;
        if (c.width < 1 || c.height < 1 || this.uu == null) {
            return;
        }
        var f = this.uf;
        var g = this.uh;
        var h = this.getEffectiveViewport1(a);
        var i = new ScalerParams(1, b, c, f.ch);
        i.c = h;
        var j = new ScalerParams(1, b, c, g.ch);
        j.c = h;
        if (!this.f1) {
            d.cu();
            var k = new Rect(0, 0, 0, 0, 0);
            var l = void 0;
            var m = void 0;
            var n = void 0;
            var o = void 0;
            var p = this.uu.count;
            if (this.t6 == null || this.t6.length != p) {
                this.t6 = new Array(p);
                this.t4 = new Array(p);
                this.t5 = new Array(p);
                this.t3 = new Array(p);
            }
            var q = this.t6;
            var r = this.t4;
            var s = this.t5;
            var t = this.t3;
            var u = void 0;
            for (var v = 0; v < p; v++) {
                u = this.vc._inner[v];
                q[v] = u.top;
                r[v] = u.left;
                s[v] = u.right;
                t[v] = u.bottom;
            }
            this.ue.hn(boxArray$1(r), 0, r.length, i);
            this.ue.hn(boxArray$1(s), 0, s.length, i);
            this.ug.hn(boxArray$1(q), 0, q.length, j);
            this.ug.hn(boxArray$1(t), 0, t.length, j);
            d.cv(r, q, s, t);
            var w = this.uu;
            var x = this.c7;
            this.wg(d);
            var y = c.left;
            var z = c.right;
            var aa = c.top;
            var ab = c.bottom;
            var ac = null;
            if (this.wr.isEmpty) {
                ac = null;
            }
            else {
                ac = new Clipper(1, this.wr.left, this.wr.bottom, this.wr.right, this.wr.top, this.u2);
            }
            var ad = this.vb();
            if (ad) {
                d.cc.clear();
            }
            var ae = false;
            var af = true;
            var ag = 0;
            if (this.cv != null) {
                if (this.cv.fc()) {
                    var ah = this.cv.lp(b, i);
                    ae = ah.c;
                    ag = ah.d;
                }
            }
            var ai = void 0;
            for (var aj = 0; aj < p; aj++) {
                n = r[aj];
                l = q[aj];
                m = t[aj];
                o = s[aj];
                k.x = Math.min(n, o);
                k.y = Math.min(l, m);
                k.width = Math.max(n, o) - k.x;
                k.height = Math.max(l, m) - k.y;
                if (k.intersectsWith(c)) {
                    if (k.x < y || k.y < aa || k.x > z || k.y > ab) {
                        ai = ac;
                    }
                    else {
                        ai = null;
                    }
                    var ak = this.ve(a, ai, w.item(aj), i, j, 0, ag);
                    if (ad) {
                        ShapeSeriesBase.wc(d, aj, ak);
                    }
                    d.ci(aj, x.item(aj), k, ak);
                }
                else if (ae) {
                    k.x = k.x + ag;
                    if (k.intersectsWith(c)) {
                        if (k.x < y || k.y < aa || k.x > z || k.y > ab) {
                            ai = ac;
                        }
                        else {
                            ai = null;
                        }
                        var al = this.ve(a, ai, w.item(aj), i, j, ag, ag);
                        if (ad) {
                            ShapeSeriesBase.wc(d, aj, al);
                        }
                        d.ci(aj, x.item(aj), k, al);
                    }
                }
            }
            d.ct();
        }
        var am = this.va();
        this.um.az(this, this.va(), runOn(this, this.t9));
        var an = false;
        var ao = this.um.b;
        if (ao != null) {
            an = true;
        }
        var ap = a.q;
        var aq = this.fc;
        var ar = d.ca;
        d.cp(function (as) {
            var at = as.dataContext != null ? as.dataContext.item : null;
            var au = as.dataContext != null ? as.dataContext.c : -1;
            d.cm(as, at, am);
            if (an) {
                _this.v9(as, aq, au, _this.uu.count, ap, ar);
            }
            else {
                if (ar) {
                    {
                        _this.um.a1(as, _this.hi, ar);
                    }
                }
            }
            {
                _this.um.ad(as, false, false, false, false);
            }
        });
    };
    ShapeSeriesBase.prototype.v9 = function (a, b, c, d, e, f) {
        var g = this.bp != 1;
        this.um.a0(this.um.b, c, d, false);
        {
            this.um.a1(a, this.hi, f);
        }
        var h = this.um.ax;
        var i = null;
        var j = this.c7;
        if (g && this.cv != null) {
            i = this.cv.c2.getHighlightingInfo(this, j, h.o, h.n, false);
            h.b = i;
        }
        h.f = e;
        this.wb(h);
        this.um.z(this, i, e, g, false);
    };
    ShapeSeriesBase.prototype.v8 = function (a, b, c) {
        var d = this.bp != 1;
        this.um.a0(this.um.d, a, b, true);
        this.um.aa(this.hi);
        var e = this.um.aw;
        var f = null;
        var g = this.c7;
        var h = null;
        if (d && this.cv != null) {
            f = this.cv.c2.getHighlightingInfo(this, g, e.o, e.n, true);
            if (this.cv.c2.isCrossContextHighlight(this)) {
                h = this.cv.c2.getHighlightingInfo(this, g, e.o, e.n, true);
            }
            e.b = f;
        }
        e.f = c;
        this.wa(e);
        this.um.y(this, f, c, d, e.l, this.cv.c2.sumHighlightingProgress);
    };
    ShapeSeriesBase.prototype.wb = function (a) {
        if (this.assigningShapeStyle != null && this.uw) {
            this.assigningShapeStyle(this, a);
        }
    };
    ShapeSeriesBase.prototype.wa = function (a) {
        if (this.assigningShapeMarkerStyle != null && this.uv) {
            this.assigningShapeMarkerStyle(this, a);
        }
    };
    ShapeSeriesBase.prototype.t9 = function (a, b) {
        return this.ua(a, b);
    };
    ShapeSeriesBase.prototype.ua = function (a, b) {
        if (b < a || a < 0 || a > this.uu.count || b < 0 || b > this.uu.count) {
            return null;
        }
        var c = new Array((b - a) + 1);
        for (var d = a; d <= b; d++) {
            var e = d;
            c[d - a] = this.c7.item(d);
        }
        return c;
    };
    ShapeSeriesBase.wc = function (a, b, c) {
        var d = 0;
        var e = null;
        for (var f = 0; f < c.count; f++) {
            var g = c._inner[f];
            var h = g.b.width * g.b.height;
            if (h > d) {
                d = h;
                e = g;
            }
        }
        a.cc.addItem(b, e);
    };
    ShapeSeriesBase.prototype.oc = function () {
        _super.prototype.oc.call(this);
        if (this.uf != null) {
            this.uf.h7();
        }
        if (this.uh != null) {
            this.uh.h7();
        }
    };
    ShapeSeriesBase.prototype.qp = function (a, b) {
        this.pr(false);
    };
    ShapeSeriesBase.prototype.qo = function (a, b) {
        this.pr(false);
    };
    ShapeSeriesBase.prototype.np = function (a, b, c, d) {
        _super.prototype.np.call(this, a, b, c, d);
        switch (a) {
            case 3:
                if (d == this.vy) {
                    this.vc._inner[b] = this.ws(this.uu.item(b));
                }
                break;
            case 1:
                for (var e = b; e < b + c; e++) {
                    this.vc.insert(e, this.ws(this.uu.item(e)));
                }
                break;
            case 0:
                this.vc.v(b, c);
                break;
            case 2:
                for (var f = b; f < b + c; f++) {
                    this.vc._inner[f] = this.ws(this.uu.item(f));
                }
                break;
            case 4:
                this.we();
                break;
        }
        this.pr(false);
    };
    ShapeSeriesBase.prototype.gm = function (a, b, c) {
        var d = true;
        if (!_super.prototype.gm.call(this, a, b, c) || (this.u6 && this.uu == null) || b.isEmpty || a.isEmpty || this.uf == null || this.uh == null || this.uf.bi == null || this.uh.bi == null || this.uf.lx == this.uf.lw || this.uh.lx == this.uh.lw || this.uu == null || this.uu.count == 0 || this.vc == null || this.vc.count == 0 || this.vc.count != this.uu.count) {
            d = false;
        }
        return d;
    };
    ShapeSeriesBase.prototype.get_u6 = function () {
        return true;
    };
    Object.defineProperty(ShapeSeriesBase.prototype, "u6", {
        get: function () {
            return this.get_u6();
        },
        enumerable: false,
        configurable: true
    });
    ShapeSeriesBase.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.un = typeCast(ShapeSeriesViewBase.$, a);
    };
    ShapeSeriesBase.prototype.vf = function (a, b, c, d, e, f, g) {
        var h = new List$1(FlattenedShape.$, 0);
        var i;
        var j = c.count;
        for (var k = 0; k < j; k++) {
            i = c._inner[k];
            var l = this.ud(a, b, i, d, e, f, g);
            if (l == null) {
                continue;
            }
            h.add(l);
        }
        return h;
    };
    ShapeSeriesBase.prototype.ud = function (a, b, c, d, e, f, g) {
        var h = this.v5(c, d, e);
        var i = h.c;
        var j = h.d;
        var k = i.length;
        var l = 1.7976931348623157E+308;
        var m = 1.7976931348623157E+308;
        var n = -1.7976931348623157E+308;
        var o = -1.7976931348623157E+308;
        var p;
        var q;
        if (f != 0) {
            for (var r = 0; r < k; r++) {
                i[r] = i[r] + f;
            }
        }
        for (var s = 0; s < k; s++) {
            p = i[s];
            q = j[s];
            l = p < l ? p : l;
            m = q < m ? q : m;
            n = p > n ? p : n;
            o = q > o ? q : o;
        }
        var t = !(l > this.wr.right || n < this.wr.left || m > this.wr.bottom || o < this.wr.top);
        if (!t && f == 0 && g != 0) {
            if (g != 0) {
                for (var u = 0; u < k; u++) {
                    i[u] = i[u] + g;
                }
            }
            for (var v = 0; v < k; v++) {
                p = i[v];
                q = j[v];
                l = p < l ? p : l;
                m = q < m ? q : m;
                n = p > n ? p : n;
                o = q > o ? q : o;
            }
            t = !(l > this.wr.right || n < this.wr.left || m > this.wr.bottom || o < this.wr.top);
        }
        if (!t) {
            return null;
        }
        var w = b != null && (l < this.wr.left || m < this.wr.top || n > this.wr.right || o > this.wr.bottom);
        var x = new Rect(0, l, m, n - l, o - m);
        if (!a.cb(x)) {
            return null;
        }
        l = l < this.wr.left ? this.wr.left : l;
        n = n > this.wr.right ? this.wr.right : n;
        m = m < this.wr.top ? this.wr.top : m;
        o = o > this.wr.bottom ? this.wr.bottom : o;
        var y = PolySimplification.b(h, this.hk);
        var z = new DefaultFlattener().c(h.c, h.d, y, this.vg);
        var aa = z.count;
        if (w) {
            var ab = new List$1(Point_$type, 0);
            b.i = ab;
            for (var ac = 0; ac < aa; ac++) {
                b.j(z._inner[ac]);
            }
            b.i = null;
            z = ab;
        }
        if (z == null || z.count == 0) {
            return null;
        }
        var ad = new FlattenedShape();
        ad.a = z;
        ad.b = new Rect(0, l, m, n - l, o - m);
        ad.c = x;
        return ad;
    };
    ShapeSeriesBase.prototype.v5 = function (a, b, c) {
        var d = this.ue;
        var e = this.ug;
        var f = a.count;
        var g = new Array(f);
        var h = new Array(f);
        for (var i = 0; i < f; i++) {
            g[i] = a._inner[i].x;
            h[i] = a._inner[i].y;
        }
        d.hn(boxArray$1(g), 0, g.length, b);
        e.hn(boxArray$1(h), 0, h.length, c);
        return new Tuple$2(Array_$type, Array_$type, g, h);
    };
    ShapeSeriesBase.prototype.wg = function (a) {
        a.c0();
    };
    ShapeSeriesBase.prototype.nk = function (a, b) {
        _super.prototype.nk.call(this, a, b);
        var c = b;
        c.cn();
    };
    ShapeSeriesBase.prototype.v7 = function (a) {
        if (a != null) {
            a.ct(this);
        }
    };
    ShapeSeriesBase.prototype.wf = function (a) {
        if (a != null) {
            a.b0(this);
        }
    };
    ShapeSeriesBase.prototype.au = function (a, b) {
        var c = this.un.c2(a, b);
        var d = null;
        if (c != null) {
            d = c.dataContext;
        }
        if (d != null) {
            return d;
        }
        return _super.prototype.au.call(this, a, b);
    };
    ShapeSeriesBase.prototype.vn = function (a) {
        return this.c7.item(a);
    };
    ShapeSeriesBase.prototype.get_gg = function () {
        return true;
    };
    ShapeSeriesBase.prototype.set_gg = function (a) {
        _super.prototype.set_gg.call(this, a);
    };
    ShapeSeriesBase.prototype.aq = function (a) {
        var e_2, _a, e_3, _b;
        if (typeCast(NumericXAxis.$, a) !== null && this.vc != null) {
            var b = 1.7976931348623157E+308;
            var c = -1.7976931348623157E+308;
            try {
                for (var _c = __values(fromEnum(this.vc)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var d = _d.value;
                    b = Math.min(b, d.left);
                    c = Math.max(c, d.right);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            return new AxisRange(b, c);
        }
        if (typeCast(NumericYAxis.$, a) !== null && this.vc != null) {
            var e = 1.7976931348623157E+308;
            var f = -1.7976931348623157E+308;
            try {
                for (var _e = __values(fromEnum(this.vc)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var g = _f.value;
                    e = Math.min(e, g.top);
                    f = Math.max(f, g.bottom);
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            return new AxisRange(e, f);
        }
        return null;
    };
    ShapeSeriesBase.prototype.get_fb = function () {
        return true;
    };
    ShapeSeriesBase.prototype.get_ez = function () {
        return true;
    };
    Object.defineProperty(ShapeSeriesBase.prototype, "u0", {
        get: function () {
            return this.styleShape != null;
        },
        enumerable: false,
        configurable: true
    });
    ShapeSeriesBase.prototype.wt = function (a, b, c) {
        if (this.styleShape != null) {
            if (this.un.c9 != null && c == this.un.c9) {
                c = new Style();
                var d = this.un.c9;
                c.fill = d.fill;
                c.opacity = d.opacity;
                c.stroke = d.stroke;
                c.strokeThickness = d.strokeThickness;
            }
            else {
                if (c != null) {
                    var e = new Style();
                    e.fill = c.fill;
                    e.opacity = c.opacity;
                    e.stroke = c.stroke;
                    e.strokeThickness = c.strokeThickness;
                    c = e;
                }
                else {
                    c = new Style();
                }
            }
            var f = new StyleShapeEventArgs(a, b, c);
            this.styleShape(this, f);
            return f.d();
        }
        return c;
    };
    ShapeSeriesBase.$t = markType(ShapeSeriesBase, 'ShapeSeriesBase', Series.$);
    ShapeSeriesBase.wh = DependencyProperty.i("HighlightedValueMemberPath", String_$type, ShapeSeriesBase.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("HighlightedValueMemberPath", b.oldValue, b.newValue); }));
    ShapeSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, ShapeSeriesBase, 'raisePropertyChanged', ['IsCustomShapeMarkerStyleAllowed:u3:wi', [0, false], 'IsCustomShapeStyleAllowed:u4:wj', [0, false], 'ItemSearchMode:ul:wk', [ShapeItemSearchMode_$type, enumGetBox(ShapeItemSearchMode_$type, 0)], 'ItemSearchPointsThreshold:vl:wl', [1, 10000], 'ItemSearchThreshold:vm:wm', [1, 10000], 'ShapeFilterResolution:vi:wn', [1, 2], 'ShapeMemberPath:vy:wo', [2, null], 'XAxis:uf:wp', [NumericXAxis.$, null], 'YAxis:uh:wq', [NumericYAxis.$, null]]);
    return ShapeSeriesBase;
}(Series));
export { ShapeSeriesBase };
/**
 * @hidden
 */
var ShapeSeriesRenderManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ShapeSeriesRenderManager, _super);
    function ShapeSeriesRenderManager() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.aw = null;
        _this.ax = null;
        return _this;
    }
    ShapeSeriesRenderManager.prototype.c = function () {
        this.aw = new AssigningShapeMarkerStyleEventArgs();
        return this.aw;
    };
    ShapeSeriesRenderManager.prototype.a = function () {
        this.ax = new AssigningShapeStyleEventArgs();
        return this.ax;
    };
    ShapeSeriesRenderManager.prototype.a1 = function (a, b, c) {
        this.ag = this.ak;
        this.ah = this.al;
        this.m = this.t;
        this.am = this.an;
        this.ao = this.ar;
        this.k = this.r;
        this.l = this.s;
        this.j = this.q;
        if (c) {
            if (a._fill != null) {
                this.ag = a._fill;
            }
            if (a._stroke != null) {
                this.ah = a._stroke;
            }
            if (!isNaN_(a.ad) && (a.y == null || !isNaN_(a.y.strokeThickness))) {
                this.m = a.ad;
            }
        }
        var d = this.b;
        if (d != null) {
            d.p = this.ag;
            d.q = this.ah;
            d.t = this.m;
            d.u = this.am;
            d.v = this.ao;
            d.r = this.k;
            d.s = this.l;
            d.k = this.j;
            d.e = this.f;
            d.i = b;
            d.d = false;
        }
    };
    ShapeSeriesRenderManager.prototype.ay = function (a, b, c) {
        this.w(a, b, c);
    };
    ShapeSeriesRenderManager.prototype.az = function (a, b, c) {
        this.x(a, b, c);
    };
    ShapeSeriesRenderManager.prototype.a0 = function (a, b, c, d) {
        if (b == -1) {
            a.c = false;
            a.o = 0;
            a.n = c - 1;
        }
        else {
            if (d) {
                a.o = b;
                a.n = b;
            }
            else {
                a.c = false;
                a.o = b;
                a.n = b;
            }
        }
    };
    ShapeSeriesRenderManager.$t = markType(ShapeSeriesRenderManager, 'ShapeSeriesRenderManager', SeriesRenderManager.$);
    return ShapeSeriesRenderManager;
}(SeriesRenderManager));
export { ShapeSeriesRenderManager };
/**
 * @hidden
 */
var ShapeSeriesViewBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ShapeSeriesViewBase, _super);
    function ShapeSeriesViewBase(a) {
        var _this = _super.call(this, a) || this;
        _this.cc = null;
        _this.b6 = null;
        _this.cd = new List$1(ShapeHitRegion.$, 0);
        _this.ch = 0;
        _this.cg = null;
        _this.b9 = null;
        _this.c7 = new Path();
        _this.b7 = null;
        _this.c8 = null;
        _this.b1 = null;
        _this.b3 = null;
        _this.b2 = null;
        _this.b0 = null;
        _this.b6 = a;
        _this.b9 = _this.b8();
        _this.cg = new List$1(Path.$, 0);
        _this.cc = new Dictionary$2(Number_$type, FlattenedShape.$, 0);
        return _this;
    }
    ShapeSeriesViewBase.prototype.b4 = function (a) {
        return null;
    };
    Object.defineProperty(ShapeSeriesViewBase.prototype, "ce", {
        get: function () {
            return this.cd;
        },
        enumerable: false,
        configurable: true
    });
    ShapeSeriesViewBase.prototype.b8 = function () {
        var _this = this;
        return ((function () {
            var $ret = new Pool$1(FrameworkElement.$);
            $ret.create = runOn(_this, _this.c1);
            $ret.activate = runOn(_this, _this.cq);
            $ret.disactivate = runOn(_this, _this.cr);
            $ret.destroy = runOn(_this, _this.cs);
            return $ret;
        })());
    };
    ShapeSeriesViewBase.prototype.cb = function (a) {
        return a.width >= this.b6.vj && a.height >= this.b6.vj;
    };
    ShapeSeriesViewBase.cf = function (a) {
        var b = new List$1(PointCollection.$, 0);
        var c;
        var d = a.count;
        for (var e = 0; e < d; e++) {
            c = a._inner[e];
            var f = new PointCollection(1, c.a);
            b.add(f);
        }
        return b;
    };
    Object.defineProperty(ShapeSeriesViewBase.prototype, "ca", {
        get: function () {
            return this.c8 != null || this.b7 != null || this.b6.u0;
        },
        enumerable: false,
        configurable: true
    });
    ShapeSeriesViewBase.prototype.ci = function (a, b, c, d) {
        if (d != null && d.count > 0) {
            var e = ShapeSeriesViewBase.cf(d);
            c.intersect(this.bx);
            if (!this.cb(c)) {
            }
            else {
                var f = this.c5(a, e);
                if (f != null) {
                    var g = this.c4(this.ch, b);
                    for (var h = 0; h < d.count; h++) {
                        var i = new ShapeHitRegion();
                        i.d = d._inner[h].b;
                        i.a = d._inner[h].a;
                        i.b = a;
                        i.c = g;
                        this.cd.add(i);
                    }
                    this.ck(g, f);
                    this.ch = this.ch + 1;
                }
            }
        }
    };
    ShapeSeriesViewBase.prototype.c4 = function (a, b) {
        var c = this.b9.item(this.ch);
        if (c.dataContext != null) {
            c.dataContext.item = b;
            c.dataContext.c = a;
        }
        return c;
    };
    ShapeSeriesViewBase.cl = function (a, b, c) {
        if (b._fill == null) {
            b._fill = a.e.su;
        }
        if (b._stroke == null) {
            b._stroke = a.e.sx;
        }
        if (b.y == null) {
            b.ad = a.e.hl;
        }
    };
    ShapeSeriesViewBase.prototype.cp = function (a) {
        for (var b = 0; b < this.b9.a.count; b++) {
            var c = this.b9.a._inner[b];
            a(c);
        }
    };
    ShapeSeriesViewBase.prototype.cm = function (a, b, c) {
        if (a == null) {
            return;
        }
        this.co(a, c);
        var d = false;
        if (this.b7 != null) {
            var e = this.b7.selectStyle(b, a);
            if (e != null) {
                d = true;
            }
            if (a.y != e) {
                a.y = e;
                this.k.j(a, a.y);
            }
        }
        if (!d) {
            if (a.y != this.c8) {
                a.y = this.c8;
                this.k.j(a, a.y);
            }
        }
        var f = this.b6.wt(b, a, a.y);
        if (a.y != f) {
            a.y = f;
            this.k.j(a, a.y);
        }
    };
    ShapeSeriesViewBase.prototype.co = function (a, b) {
    };
    ShapeSeriesViewBase.prototype.cj = function (a, b) {
        var c = truncate(Math.floor(a.left));
        var d = truncate(Math.ceil(a.right));
        var e = truncate(Math.floor(a.top));
        var f = truncate(Math.ceil(a.bottom));
        for (var g = c; g < d; g++) {
            for (var h = e; h < f; h++) {
                this.cx(g, h, b);
            }
        }
    };
    ShapeSeriesViewBase.prototype.cx = function (a, b, c) {
    };
    ShapeSeriesViewBase.prototype.cu = function () {
        this.ch = 0;
    };
    ShapeSeriesViewBase.prototype.ct = function () {
        this.b9.count = this.ch;
        this.as();
    };
    ShapeSeriesViewBase.prototype.cw = function (a, b) {
    };
    ShapeSeriesViewBase.prototype.cn = function () {
        this.b9.count = 0;
        this.as();
    };
    ShapeSeriesViewBase.prototype.c1 = function () {
        var a = this.b6;
        var b = ((function () {
            var $ret = new Path();
            $ret.dataContext = ((function () {
                var $ret = new DataContext();
                $ret.series = a;
                return $ret;
            })());
            return $ret;
        })());
        this.cg.add(b);
        return b;
    };
    ShapeSeriesViewBase.prototype.cq = function (a) {
        a._visibility = 0;
    };
    ShapeSeriesViewBase.prototype.cr = function (a) {
        a.dataContext.item = null;
        a._visibility = 1;
    };
    ShapeSeriesViewBase.prototype.cs = function (a) {
        this.cg.remove(a);
    };
    ShapeSeriesViewBase.prototype.c6 = function (a, b, c) {
        if (b == null) {
            return null;
        }
        var d = new PathGeometry();
        var e;
        var f = b.count;
        for (var g = 0; g < f; g++) {
            e = b._inner[g];
            if (e.count < 1) {
                continue;
            }
            var h = new PolyLineSegment();
            h._points = e;
            var i = new PathFigure();
            i._isFilled = c;
            i._isClosed = c;
            i._startPoint = e._inner[0];
            i._segments.add(h);
            d.c.add(i);
        }
        return d;
    };
    ShapeSeriesViewBase.prototype.ac = function (a) {
        return this.cg._inner[a];
    };
    ShapeSeriesViewBase.prototype.ab = function (a) {
        var b = this.cg._inner[a];
        this.c7._visibility = b._visibility;
        this.c7.an = b.an;
        var c = this.bs(a);
        this.c7._fill = c;
        this.c7._stroke = c;
        this.c7.ad = this.e.hl + 3;
        return this.c7;
    };
    ShapeSeriesViewBase.prototype.a8 = function (a, b) {
        _super.prototype.a8.call(this, a, b);
        for (var c = 0; c < this.cg.count; c++) {
            var d = this.aa(c, b);
            if (d._visibility != 1) {
                a.t(d);
            }
        }
    };
    Object.defineProperty(ShapeSeriesViewBase.prototype, "c9", {
        get: function () {
            return this.c8;
        },
        enumerable: false,
        configurable: true
    });
    ShapeSeriesViewBase.prototype.cz = function (a) {
        this.b7 = a;
    };
    ShapeSeriesViewBase.prototype.cy = function (a) {
        this.c8 = a;
    };
    ShapeSeriesViewBase.prototype.c2 = function (a, b) {
        return this.c3(a, b, false);
    };
    ShapeSeriesViewBase.prototype.c3 = function (a, b, c) {
        var d = this.b5(a, b, c);
        if (d == null) {
            return null;
        }
        return d.c;
    };
    ShapeSeriesViewBase.prototype.b5 = function (a, b, c) {
        if (this.cd.count == 0) {
            return null;
        }
        var d = a.x;
        var e = a.y;
        var f = this.cd.count;
        var g = this.cd;
        var h = null;
        for (var i = 0; i < f; i++) {
            h = g._inner[i];
            if (h.a == null || h.a.count == 0) {
                continue;
            }
            if (d >= h.d.left && d <= h.d.right && e >= h.d.top && e <= h.d.bottom) {
                if (c) {
                    var j = this.b6.hl / 2 + this.b6.hz(b);
                    if (GeometryUtil.b(a, h.a._inner[0], h.a, j)) {
                        return h;
                    }
                }
                else {
                    if (PolygonUtil.b(h.a, a)) {
                        return h;
                    }
                }
            }
        }
        return null;
    };
    ShapeSeriesViewBase.prototype.cv = function (a, b, c, d) {
        this.b1 = a;
        this.b3 = b;
        this.b2 = c;
        this.b0 = d;
        this.cd.clear();
    };
    ShapeSeriesViewBase.prototype.c0 = function () {
        var _this = this;
        var a = this.bx;
        var b = ((function () {
            var $ret = new Path();
            $ret.y = _this.c8;
            return $ret;
        })());
        b.ad = 1;
        if (this.k != null) {
            this.k.j(b, b.y);
        }
        this.b6.wr = RectUtil.r(a, b.ad);
    };
    ShapeSeriesViewBase.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
        if (this.b9.a == null) {
            return;
        }
        for (var b = 0; b < this.b9.a.count; b++) {
            var c = typeCast(Path.$, this.b9.a._inner[b]);
            if (c._visibility != 1) {
                this.e.a5.exportPathData(a, c, "shape" + b, ["Main "]);
            }
        }
    };
    ShapeSeriesViewBase.$t = markType(ShapeSeriesViewBase, 'ShapeSeriesViewBase', SeriesView.$);
    return ShapeSeriesViewBase;
}(SeriesView));
export { ShapeSeriesViewBase };
