import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Type, Point } from "igniteui-angular-core";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-angular-core";
import { TrendLineType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { RadialFrame } from "./RadialFrame";
import { SeriesView } from "./SeriesView";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { AxisRange } from "./AxisRange";
import { RadialBaseView } from "./RadialBaseView";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { Clipper } from "igniteui-angular-core";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { PointCollection } from "igniteui-angular-core";
import { RenderSurface } from "./RenderSurface";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class AnchoredRadialBucketCalculator extends RadialBucketCalculator {
    static $t: Type;
    private f;
    constructor(a: AnchoredRadialSeriesView);
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare abstract class AnchoredRadialSeries extends RadialBase {
    static $t: Type;
    protected cd(): SeriesView;
    nh(): void;
    jv(a: any, b: string): any;
    o2(a: SeriesView): void;
    wy: AnchoredRadialSeriesView;
    constructor();
    wz: CategoryLineRasterizer;
    jg(a: Point, b: boolean): number;
    je(a: Point, b: boolean): number;
    hu(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    ia(a: Point, b: boolean, c: boolean): number;
    tj(a: Point, b: boolean, c: boolean): Point;
    xm: string;
    xf: string;
    protected fo(): boolean;
    protected g1(): List$1<SeriesLayerPropertyOverlay>;
    private xq;
    get w4(): IFastItemColumn$1<number>;
    set w4(a: IFastItemColumn$1<number>);
    private w3;
    xi: string;
    xk: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    w2: TrendLineType;
    x7: Brush;
    get x6(): Brush;
    set x6(a: Brush);
    static readonly xu: DependencyProperty;
    xc: number;
    x9: PenLineCap;
    x8: DoubleCollection;
    xd: number;
    xe: number;
    aq(a: Axis): AxisRange;
    protected pa(a: any, b: string, c: any, d: any): void;
    protected np(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    gm(a: Rect, b: Rect, c: SeriesView): boolean;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    protected get_w7(): boolean;
    protected get w7(): boolean;
    protected get_d0(): boolean;
    protected get_fj(): boolean;
    protected w9(a: CategoryAngleAxis, b: Rect, c: Rect, d: Rect): number;
    wn(a: RadialFrame, b: RadialBaseView): void;
    private xa;
    private xb;
    private w8;
    wx(a: List$1<number[]>, b: number, c: SeriesView): Clipper;
    protected ya: Point;
    xt(a: PointCollection, b: PointCollection, c: PointCollection, d: PointCollection, e: boolean): void;
    private w6;
    private w5;
    nk(a: boolean, b: SeriesView): void;
    wq(a: RadialFrame, b: RadialBaseView): void;
    protected ww(a: number, b: number, c: Axis): any[];
    protected xr(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    protected xs(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    xp(a: RadialBaseView, b: RadialFrame): void;
    private xo;
    protected qf(): void;
    jz(a: any, b: Point): any;
    fp(a: any): boolean;
    w1: RadialFrame;
    pt(a: Rect, b: RenderSurface): void;
    private w0;
    pq(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    protected n2(a: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredRadialSeriesView extends RadialBaseView {
    static $t: Type;
    cz: AnchoredRadialSeries;
    constructor(a: AnchoredRadialSeries);
    c0: RadialTrendLineManager;
    c1(a: Rect, b: Rect, c: Rect, d: Rect): void;
    c2(): void;
    protected a7(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
