import { FinancialOverlay } from "./FinancialOverlay";
import { Series } from "./Series";
import { List$1 } from "igniteui-angular-core";
import { Type, Point } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { AxisRange } from "./AxisRange";
import { Axis } from "./Axis";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { Rect } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "igniteui-angular-core";
import { Polygon } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class BollingerBandsOverlay extends FinancialOverlay {
    static $t: Type;
    protected bc(): Series;
    constructor();
    yg: number;
    yf: number;
    protected pa(a: any, b: string, c: any, d: any): void;
    private yd;
    private ye;
    protected x6(): boolean;
    aq(a: Axis): AxisRange;
    yb: List$1<number>;
    yc: List$1<number>;
    xh(a: CategoryFrame, b: FinancialSeriesView): void;
    nk(a: boolean, b: SeriesView): void;
    ia(a: Point, b: boolean, c: boolean): number;
    jg(a: Point, b: boolean): number;
    je(a: Point, b: boolean): number;
    gm(a: Rect, b: Rect, c: SeriesView): boolean;
    xj(a: CategoryFrame, b: FinancialSeriesView): void;
    protected cd(): SeriesView;
    o2(a: SeriesView): void;
    private ya;
    protected wb(): number;
    h3(): number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class BollingerBandsBucketCalculator extends FinancialBucketCalculator {
    static $t: Type;
    constructor(a: FinancialSeriesView);
    protected f: BollingerBandsOverlayView;
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class BollingerBandsOverlayView extends FinancialSeriesView {
    static $t: Type;
    b6: BollingerBandsOverlay;
    constructor(a: BollingerBandsOverlay);
    au(): void;
    protected b1(): FinancialBucketCalculator;
    b8(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: (arg1: number) => number, e: (arg1: number) => number, f: (arg1: number) => number): void;
    b7(): void;
    get ca(): Polygon;
    get cf(): Polyline;
    get cg(): Polyline;
    get ch(): Polyline;
    private cb;
    private ci;
    private cj;
    private ck;
    private b9;
    private cc;
    private cd;
    private ce;
    protected be(): void;
    protected a8(a: RenderingContext, b: boolean): void;
    an(a: any): void;
}
