import { AnnotationLayer } from "./AnnotationLayer";
import { Axis } from "./Axis";
import { CategoryTooltipLayerPosition } from "./CategoryTooltipLayerPosition";
import { Series } from "./Series";
import { Type, Point } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { DataContext } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CategoryToolTipLayer extends AnnotationLayer {
    static $t: Type;
    protected bc(): Series;
    protected get_d6(): boolean;
    constructor();
    protected cd(): SeriesView;
    o2(a: SeriesView): void;
    protected w4: CategoryToolTipLayerView;
    protected get_eh(): boolean;
    w2: Axis;
    w6: boolean;
    w3: CategoryTooltipLayerPosition;
    protected pa(a: any, b: string, c: any, d: any): void;
    protected vt(a: Axis, b: boolean): void;
    protected vu(a: Series, b: boolean): void;
    protected vw(a: Frame, b: SeriesView): void;
    private w5;
    n9(): void;
    private xb;
    private w7;
    protected vz(a: Frame, b: SeriesView): void;
    protected fn(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategoryToolTipLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CategoryToolTipLayer);
    protected b7: CategoryToolTipLayer;
    private b8;
    private _tooltips;
    private cb;
    private b9;
    cd(): any;
    au(): void;
    ak(): void;
    private _htmlTest;
    protected get htmlTest(): any;
    protected set htmlTest(a: any);
    ca(a: Series, b: any, c: DataContext): boolean;
    ck(a: any): Size;
    cj(a: Point): Point;
    ch(a: any, b: number, c: number, d: number, e: number): void;
    cl(): Size;
    cg(a: any): void;
    cf(): void;
    ci(): void;
    protected a8(a: RenderingContext, b: boolean): void;
    an(a: any): void;
}
