import { ScatterTriangulationSeries } from "./ScatterTriangulationSeries";
import { ColorScale } from "./ColorScale";
import { Type, Point } from "igniteui-angular-core";
import { Series } from "./Series";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { RenderSurface } from "./RenderSurface";
import { SeriesView } from "./SeriesView";
import { WriteableBitmap } from "igniteui-angular-core";
import { TriangleRasterizer } from "./TriangleRasterizer";
import { ScalerParams } from "./ScalerParams";
import { ObservableColorCollection } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class ScatterAreaSeries extends ScatterTriangulationSeries {
    static $t: Type;
    protected bc(): Series;
    protected get_d9(): boolean;
    constructor();
    private vy;
    get v0(): ColorScale;
    set v0(a: ColorScale);
    private wh;
    jv(a: any, b: string): any;
    wc: string;
    private v3;
    private get v4();
    private set v4(value);
    protected get_gg(): boolean;
    protected set_gg(a: boolean): void;
    protected pa(a: any, b: string, c: any, d: any): void;
    ps(a: boolean): void;
    pq(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    protected wi(a: SeriesView): void;
    private wf;
    js(a: Point): any;
    protected vw: number[];
    protected vx: number[];
    v2(a: SeriesView, b: ScalerParams, c: ScalerParams): TriangleRasterizer;
    protected v5(): ObservableColorCollection;
    vz: ColorScale;
    wj(): void;
    protected qf(): void;
    nk(a: boolean, b: SeriesView): void;
    protected cd(): SeriesView;
    o2(a: SeriesView): void;
    v1: ScatterAreaSeriesView;
    wg(a: any): void;
    v8: string;
    wa: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterAreaSeriesView extends SeriesView {
    static $t: Type;
    private b4;
    private b0;
    get b3(): number[];
    set b3(a: number[]);
    constructor(a: ScatterAreaSeries);
    cd(a: number, b: number): void;
    b9(a: any): void;
    private b8;
    private b7;
    private b6;
    b1(): number[];
    b2(a: boolean): number[];
    private cc;
    b5(a: Rect, b: ColorScale, c: IFastItemColumn$1<number>): TriangleRasterizer;
    cb(a: TriangleRasterizer): void;
    ca(): void;
    protected a8(a: RenderingContext, b: boolean): void;
    ce(a: WriteableBitmap): void;
    an(a: any): void;
    getDefaultTooltipTemplate(): string;
}
